/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 6;

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 7;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 8;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 9;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[3] = x8;
  switch (XWINT (x5, 0))
    {
    case 8L:
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!register_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case 16L:
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case 32L:
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern51 (x1); /* [-1, 1] */
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 4;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern71 (x3); /* [-1, 2] */
}

int
pattern75 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BFmode:
      return pattern81 (x1, 
E_VNx8BFmode, 
E_VNx16BFmode); /* [-1, 0] */

    case E_VNx32BFmode:
      if (pattern81 (x1, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0)
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (pattern81 (x1, 
E_VNx8HFmode, 
E_VNx16HFmode) != 0)
        return -1;
      return 2;

    case E_VNx8SFmode:
      if (pattern81 (x1, 
E_VNx4SFmode, 
E_VNx8SFmode) != 0)
        return -1;
      return 3;

    case E_VNx4DFmode:
      if (pattern81 (x1, 
E_VNx2DFmode, 
E_VNx4DFmode) != 0)
        return -1;
      return 4;

    case E_VNx32HFmode:
      if (pattern81 (x1, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0)
        return -1;
      return 5;

    case E_VNx16SFmode:
      if (pattern81 (x1, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0)
        return -1;
      return 6;

    case E_VNx8DFmode:
      if (pattern81 (x1, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern79 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern79 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern79 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern79 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern79 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern92 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern92 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern92 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_si (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode)
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x1) != E_V8BFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], i1))
        return -1;
      return 0;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern118 (x3, 
E_VNx8HImode, 
E_VNx8HFmode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern118 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern118 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern118 (x3, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern118 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern118 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return pattern127 (x3); /* [-1, 2] */

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 168)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      x7 = XVECEXP (x5, 0, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern129 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern129 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern144 (x3, 
E_VNx32QImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern144 (x3, 
E_VNx16HImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern144 (x3, 
E_VNx8SImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern144 (x3, 
E_VNx4DImode, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (pattern144 (x3, 
E_VNx16BFmode, 
E_VNx8BFmode) != 0)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (pattern144 (x3, 
E_VNx16HFmode, 
E_VNx8HFmode) != 0)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (pattern144 (x3, 
E_VNx8SFmode, 
E_VNx4SFmode) != 0)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (pattern144 (x3, 
E_VNx4DFmode, 
E_VNx2DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 86
      || GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return 0;

    case E_VNx8HImode:
      return 1;

    case E_VNx4SImode:
      return 2;

    case E_VNx2DImode:
      return 3;

    case E_VNx8BFmode:
      return 4;

    case E_VNx8HFmode:
      return 5;

    case E_VNx4SFmode:
      return 6;

    case E_VNx2DFmode:
      return 7;

    default:
      return -1;
    }
}

int
pattern177 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern180 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[2], E_VNx4SFmode))
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern188 (x3, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern188 (x3, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern188 (x3, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern188 (x3, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (pattern188 (x3, 
E_VNx16BFmode) != 0)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (pattern188 (x3, 
E_VNx16HFmode) != 0)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (pattern188 (x3, 
E_VNx8SFmode) != 0)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (pattern188 (x3, 
E_VNx4DFmode) != 0)
        return -1;
      return 7;

    case E_VNx64QImode:
      if (pattern188 (x3, 
E_VNx64QImode) != 0)
        return -1;
      return 8;

    case E_VNx32HImode:
      if (pattern188 (x3, 
E_VNx32HImode) != 0)
        return -1;
      return 9;

    case E_VNx16SImode:
      if (pattern188 (x3, 
E_VNx16SImode) != 0)
        return -1;
      return 10;

    case E_VNx8DImode:
      if (pattern188 (x3, 
E_VNx8DImode) != 0)
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (pattern188 (x3, 
E_VNx32BFmode) != 0)
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (pattern188 (x3, 
E_VNx32HFmode) != 0)
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (pattern188 (x3, 
E_VNx16SFmode) != 0)
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (pattern188 (x3, 
E_VNx8DFmode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_maxmin_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  return pattern213 (x3); /* [-1, 3] */
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern219 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern219 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern219 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[0], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32QImode)
        return -1;
      return 0;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[0], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16HImode)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (!aligned_register_operand (operands[0], E_VNx8SImode)
          || GET_MODE (x1) != E_VNx8SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8SImode)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x1) != E_VNx4DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx4DImode)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[0], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16BFmode)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[0], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16HFmode)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x1) != E_VNx8SFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8SFmode)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (!aligned_register_operand (operands[0], E_VNx4DFmode)
          || GET_MODE (x1) != E_VNx4DFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx4DFmode)
        return -1;
      return 7;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx64QImode)
        return -1;
      return 8;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32HImode)
        return -1;
      return 9;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x1) != E_VNx16SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16SImode)
        return -1;
      return 10;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x1) != E_VNx8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8DImode)
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32BFmode)
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32HFmode)
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x1) != E_VNx16SFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16SFmode)
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x1) != E_VNx8DFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8DFmode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      x8 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[2] = x8;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx16QImode:
                  if (!register_operand (operands[1], E_VNx16QImode)
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 0;

                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 1;

                case E_VNx32QImode:
                  if (!aligned_register_operand (operands[1], E_VNx32QImode)
                      || !aligned_register_operand (operands[2], E_VNx32QImode))
                    return -1;
                  return 2;

                case E_VNx64QImode:
                  if (!aligned_register_operand (operands[1], E_VNx64QImode)
                      || !aligned_register_operand (operands[2], E_VNx64QImode))
                    return -1;
                  return 3;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || !aligned_register_operand (operands[2], E_VNx16HImode))
                    return -1;
                  return 4;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || !aligned_register_operand (operands[2], E_VNx32HImode))
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 6;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || !aligned_register_operand (operands[2], E_VNx16HImode))
                    return -1;
                  return 7;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || !aligned_register_operand (operands[2], E_VNx32HImode))
                    return -1;
                  return 8;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              res = pattern246 (x2, 
E_VNx4SImode);
              if (res >= 0)
                return res + 9; /* [9, 12] */
              return -1;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !register_operand (operands[2], E_VNx8HImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx16HImode:
                  if (!register_operand (operands[1], E_VNx16HImode)
                      || GET_MODE (x8) != E_VNx16HImode)
                    return -1;
                  return 13;

                case E_VNx32HImode:
                  if (!register_operand (operands[1], E_VNx32HImode)
                      || GET_MODE (x8) != E_VNx32HImode)
                    return -1;
                  return 14;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 168)
            return -1;
          x10 = XVECEXP (x8, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x8, 0, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx16QImode:
                  if (!register_operand (operands[1], E_VNx16QImode)
                      || GET_MODE (x8) != E_VNx16QImode
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 15;

                case E_VNx32QImode:
                  if (!aligned_register_operand (operands[1], E_VNx32QImode)
                      || GET_MODE (x8) != E_VNx32QImode
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 16;

                case E_VNx64QImode:
                  if (!aligned_register_operand (operands[1], E_VNx64QImode)
                      || GET_MODE (x8) != E_VNx64QImode
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 17;

                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || GET_MODE (x8) != E_VNx8HImode
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 18;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || GET_MODE (x8) != E_VNx16HImode
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 19;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || GET_MODE (x8) != E_VNx32HImode
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 20;

                default:
                  return -1;
                }

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !register_operand (operands[2], E_VNx8HImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || GET_MODE (x8) != E_VNx8HImode)
                    return -1;
                  return 21;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || GET_MODE (x8) != E_VNx16HImode)
                    return -1;
                  return 22;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || GET_MODE (x8) != E_VNx32HImode)
                    return -1;
                  return 23;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x6, 1);
      operands[1] = x13;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 24;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode)
                return -1;
              return 25;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 26;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !const_0_to_4_step_4_operand (operands[1], E_SImode))
                return -1;
              res = pattern255 (x8);
              if (res >= 0)
                return res + 27; /* [27, 28] */
              return -1;

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 168)
            return -1;
          x10 = XVECEXP (x8, 0, 0);
          operands[3] = x10;
          x11 = XVECEXP (x8, 0, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 29;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !register_operand (operands[3], E_VNx8HImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern348 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern348 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern358 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 5
      || GET_MODE (x1) != E_DImode)
    return -1;
  return 0;
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern367 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != i4
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern366 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  return pattern370 (x1); /* [-1, 1] */
}

int
pattern376 (rtx x1, unsigned int i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i3)
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  return pattern378 (x1); /* [-1, 1] */
}

int
pattern382 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!aarch64_any_register_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode)
        return -1;
      return 0;

    case E_VNx8QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x1) != E_VNx8QImode)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x1) != E_VNx4QImode)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x1) != E_VNx4HImode)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x1) != E_VNx2HImode)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x1) != E_VNx2SImode)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x1) != E_VNx4HFmode)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x1) != E_VNx2HFmode)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x1) != E_VNx4BFmode)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x1) != E_VNx2BFmode)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x1) != E_VNx2SFmode)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XINT (x2, 1) != 125)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern413 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern413 (x1, 
E_VNx8QImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern413 (x1, 
E_VNx4QImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern413 (x1, 
E_VNx2QImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern413 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern413 (x1, 
E_VNx4HImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern413 (x1, 
E_VNx2HImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern413 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern413 (x1, 
E_VNx2SImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern413 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!aarch64_simd_or_scalar_imm_zero (operands[2], E_V8QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  return 0;
}

int
pattern428 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern427 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern427 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern427 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern435 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      return pattern433 (x1); /* [-1, 5] */

    case ABS:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ABS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern434 (x1, 
E_V4HImode, 
E_V4HFmode, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern434 (x1, 
E_V2SImode, 
E_V2SFmode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case E_V2DImode:
          if (pattern434 (x1, 
E_DImode, 
E_DFmode, 
E_V2DImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern444 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[3], i1)
      || !register_operand (operands[1], E_V4HImode))
    return -1;
  return 0;
}

int
pattern449 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_sqadd_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern25 (x1);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern463 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern464 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern463 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern463 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern463 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern463 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern463 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern463 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern463 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern473 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern477 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern476 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern476 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern476 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern476 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern476 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern476 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern476 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern476 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern476 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern476 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_V8QImode:
      if (pattern476 (x1, 
E_V8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 10;

    case E_V16QImode:
      if (pattern476 (x1, 
E_V16QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 11;

    case E_V4HImode:
      if (pattern476 (x1, 
E_V4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 12;

    case E_V8HImode:
      if (pattern476 (x1, 
E_V8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 13;

    case E_V2SImode:
      if (pattern476 (x1, 
E_V2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 14;

    case E_V4SImode:
      if (pattern476 (x1, 
E_V4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 15;

    case E_V2DImode:
      if (pattern476 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 16;

    case E_V1DImode:
      if (pattern476 (x1, 
E_V1DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern496 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern495 (x1, 
E_SImode); /* [-1, 3] */

    case E_DImode:
      res = pattern495 (x1, 
E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern511 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          return pattern505 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx4SImode:
          if (pattern505 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx2DImode:
          if (pattern505 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 168)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern510 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern510 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern526 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[2], E_DImode))
                return -1;
              return 1;

            case E_SImode:
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      res = pattern19 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern544 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern549 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern548 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern557 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern561 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (!register_operand (x7, i1))
    return -1;
  return 0;
}

int
pattern573 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern583 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  x11 = XVECEXP (x3, 0, 2);
  operands[3] = x11;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  return pattern354 (x1); /* [-1, 3] */
}

int
pattern595 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern605 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 5] */

    case E_VNx4HImode:
      res = pattern605 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case E_VNx2HImode:
      res = pattern605 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case E_VNx4SImode:
      res = pattern605 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    case E_VNx2SImode:
      res = pattern605 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 24; /* [24, 29] */
      return -1;

    case E_VNx2DImode:
      res = pattern605 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 30; /* [30, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern619 (x1, 
E_SImode); /* [-1, 5] */

    case E_DImode:
      res = pattern619 (x1, 
E_DImode);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern624 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern630 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 1);
      operands[3] = x7;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (pattern629 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern629 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern629 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern643 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern642 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern642 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern642 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern658 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i5
      || !register_operand (operands[1], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern667 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern670 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 1);
  operands[2] = x8;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  x10 = XEXP (x1, 1);
  operands[4] = x10;
  x11 = XEXP (x4, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern669 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern669 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern669 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern682 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  return pattern680 (x1); /* [-1, 2] */
}

int
pattern684 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  x10 = XEXP (x1, 1);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern683 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern683 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern683 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern691 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 66
      || GET_MODE (x6) != E_CC_NZCmode)
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x3) != E_VNx16BImode)
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x3) != E_VNx8BImode)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x3) != E_VNx4BImode)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x3) != E_VNx2BImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern699 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || pattern697 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern705 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_logical_and_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern709 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x4, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern708 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern708 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern708 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern708 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern708 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern708 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern708 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern708 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern708 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern708 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern720 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern724 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ld1rq_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern729 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern733 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!aarch64_shift_imm_si (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern739 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern742 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern741 (
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern741 (
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern749 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern754 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          return 0;

        case E_V16QImode:
          return 1;

        case E_V4HImode:
          return 2;

        case E_V8HImode:
          return 3;

        case E_V2SImode:
          return 4;

        case E_V4SImode:
          return 5;

        case E_V2DImode:
          return 6;

        default:
          return -1;
        }

    case CONST_INT:
      if (!aarch64_simd_shift_imm_offset_di (operands[2], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_TImode
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_MODE (x6) != E_TImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_int_rnd_operand (operands[3], E_TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern768 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern773 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern772 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern772 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern772 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern782 (rtx x1, machine_mode i1, int i2, int i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i4
      || XVECLEN (x2, 0) != i3
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern786 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern793 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern799 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern807 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern821 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern827 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern826 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern826 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern836 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[4], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[5], i1))
    return -1;
  return 0;
}

int
pattern849 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode)
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], E_VNx2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern859 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern865 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_VNx4SImode
      || !register_operand (operands[0], E_VNx4SImode)
      || GET_MODE (x1) != E_VNx4SImode
      || !register_operand (operands[1], E_VNx4BImode)
      || !register_operand (operands[2], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern871 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern877 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[3], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[3], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[3], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[3], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[3], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[3], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[3], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[3], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[3], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern914 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern913 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern913 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern913 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern925 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern967 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern913 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern913 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern913 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern973 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern979 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern985 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 40
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern989 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!memory_operand (operands[2], E_V8QImode)
          || !register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!memory_operand (operands[2], E_V4HImode)
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!memory_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 2;

    case E_V2SImode:
      if (!memory_operand (operands[2], E_V2SImode)
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!memory_operand (operands[2], E_V2SFmode)
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      return 4;

    case E_DFmode:
      if (!memory_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern1002 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_QImode:
      if (!register_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1009 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1016 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern345 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1023 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1031 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1036 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !aarch64_simd_shift_imm_qi (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !aarch64_simd_shift_imm_hi (operands[1], E_VOIDmode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[1], E_VOIDmode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[1], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1048 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      return pattern1046 (x1); /* [-1, 6] */

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_CODE (operands[3]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1043 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 7;

            case E_VNx8HFmode:
              if (pattern1043 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 8;

            case E_VNx4SFmode:
              if (pattern1043 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return -1;
              return 9;

            case E_VNx2DFmode:
              if (pattern1043 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return -1;
              return 10;

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1047 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 11;

            case E_VNx4SFmode:
              if (pattern1047 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return -1;
              return 12;

            case E_VNx2DFmode:
              if (pattern1047 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return -1;
              return 13;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1076 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern1075 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1084 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1090 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i2)
      || !aarch64_simd_umax_half_mode (operands[4], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[4] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1043 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1043 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1043 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1043 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return 4;

        case E_VNx4SFmode:
          return 5;

        case E_VNx2DFmode:
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1111 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !aarch64_simd_reg_or_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1116 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1126 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1142 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern1073 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1153 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  switch (GET_CODE (x11))
    {
    case AND:
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != NOT)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      x15 = XEXP (x13, 1);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x11, 1);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || GET_MODE (x6) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !register_operand (operands[3], E_SImode)
              || pattern1152 (x11, 
E_SImode) != 0)
            return -1;
          return 0;

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !register_operand (operands[3], E_DImode)
              || pattern1152 (x11, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != AND
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != NOT
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != i1
          || GET_MODE (x14) != E_SImode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x14, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x12, 1);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx4BImode:
      return 0;

    case E_VNx2BImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1206 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || !aarch64_plus_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1213 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  return 0;
}

int
pattern1231 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1238 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_int_rnd_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1245 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case SET:
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 3
          || XINT (x7, 1) != i1)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[4]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[5]))
        return -1;
      x11 = XVECEXP (x7, 0, 2);
      if (!rtx_equal_p (x11, operands[6]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x7) != E_VNx8BImode)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x7) != E_VNx4BImode)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x7) != E_VNx2BImode)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1289 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1298 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!aarch64_imm3 (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1297 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1297 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_VNx16QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!register_operand (operands[2], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!register_operand (operands[2], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1332 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4HImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[2], E_VNx4SImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1339 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !aarch64_borrow_operation (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1358 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 126)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x6, operands[6]))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x7, operands[7]))
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          return pattern1357 (x1, 
E_VNx16BImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1357 (x1, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (pattern1357 (x1, 
E_VNx4BImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 3;

        case E_VNx8BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx8BImode
              || !register_operand (operands[2], E_VNx8HImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 4;

        case E_VNx4BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx4BImode
              || !register_operand (operands[2], E_VNx4SImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8QImode
          || !register_operand (operands[1], E_V2x8QImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4673; /* aarch64_st1_x2_v8qi */

    case E_V2x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HImode
          || !register_operand (operands[1], E_V2x4HImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4674; /* aarch64_st1_x2_v4hi */

    case E_V2x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SImode
          || !register_operand (operands[1], E_V2x2SImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4675; /* aarch64_st1_x2_v2si */

    case E_V2x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DImode
          || !register_operand (operands[1], E_V2x1DImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4676; /* aarch64_st1_x2_di */

    case E_V2x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HFmode
          || !register_operand (operands[1], E_V2x4HFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4677; /* aarch64_st1_x2_v4hf */

    case E_V2x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SFmode
          || !register_operand (operands[1], E_V2x2SFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4678; /* aarch64_st1_x2_v2sf */

    case E_V2x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DFmode
          || !register_operand (operands[1], E_V2x1DFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4679; /* aarch64_st1_x2_df */

    case E_V2x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4BFmode
          || !register_operand (operands[1], E_V2x4BFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4680; /* aarch64_st1_x2_v4bf */

    case E_V2x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x16QImode
          || !register_operand (operands[1], E_V2x16QImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4681; /* aarch64_st1_x2_v16qi */

    case E_V2x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HImode
          || !register_operand (operands[1], E_V2x8HImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4682; /* aarch64_st1_x2_v8hi */

    case E_V2x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SImode
          || !register_operand (operands[1], E_V2x4SImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4683; /* aarch64_st1_x2_v4si */

    case E_V2x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DImode
          || !register_operand (operands[1], E_V2x2DImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4684; /* aarch64_st1_x2_v2di */

    case E_V2x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HFmode
          || !register_operand (operands[1], E_V2x8HFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4685; /* aarch64_st1_x2_v8hf */

    case E_V2x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SFmode
          || !register_operand (operands[1], E_V2x4SFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4686; /* aarch64_st1_x2_v4sf */

    case E_V2x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DFmode
          || !register_operand (operands[1], E_V2x2DFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4687; /* aarch64_st1_x2_v2df */

    case E_V2x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8BFmode
          || !register_operand (operands[1], E_V2x8BFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4688; /* aarch64_st1_x2_v8bf */

    case E_V3x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8QImode
          || !register_operand (operands[1], E_V3x8QImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4689; /* aarch64_st1_x3_v8qi */

    case E_V3x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HImode
          || !register_operand (operands[1], E_V3x4HImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4690; /* aarch64_st1_x3_v4hi */

    case E_V3x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SImode
          || !register_operand (operands[1], E_V3x2SImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4691; /* aarch64_st1_x3_v2si */

    case E_V3x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DImode
          || !register_operand (operands[1], E_V3x1DImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4692; /* aarch64_st1_x3_di */

    case E_V3x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HFmode
          || !register_operand (operands[1], E_V3x4HFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4693; /* aarch64_st1_x3_v4hf */

    case E_V3x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SFmode
          || !register_operand (operands[1], E_V3x2SFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4694; /* aarch64_st1_x3_v2sf */

    case E_V3x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DFmode
          || !register_operand (operands[1], E_V3x1DFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4695; /* aarch64_st1_x3_df */

    case E_V3x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4BFmode
          || !register_operand (operands[1], E_V3x4BFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4696; /* aarch64_st1_x3_v4bf */

    case E_V3x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x16QImode
          || !register_operand (operands[1], E_V3x16QImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4697; /* aarch64_st1_x3_v16qi */

    case E_V3x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HImode
          || !register_operand (operands[1], E_V3x8HImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4698; /* aarch64_st1_x3_v8hi */

    case E_V3x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SImode
          || !register_operand (operands[1], E_V3x4SImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4699; /* aarch64_st1_x3_v4si */

    case E_V3x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DImode
          || !register_operand (operands[1], E_V3x2DImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4700; /* aarch64_st1_x3_v2di */

    case E_V3x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HFmode
          || !register_operand (operands[1], E_V3x8HFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4701; /* aarch64_st1_x3_v8hf */

    case E_V3x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SFmode
          || !register_operand (operands[1], E_V3x4SFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4702; /* aarch64_st1_x3_v4sf */

    case E_V3x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DFmode
          || !register_operand (operands[1], E_V3x2DFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4703; /* aarch64_st1_x3_v2df */

    case E_V3x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8BFmode
          || !register_operand (operands[1], E_V3x8BFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4704; /* aarch64_st1_x3_v8bf */

    case E_V4x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8QImode
          || !register_operand (operands[1], E_V4x8QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4705; /* aarch64_st1_x4_v8qi */

    case E_V4x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HImode
          || !register_operand (operands[1], E_V4x4HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4706; /* aarch64_st1_x4_v4hi */

    case E_V4x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SImode
          || !register_operand (operands[1], E_V4x2SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4707; /* aarch64_st1_x4_v2si */

    case E_V4x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DImode
          || !register_operand (operands[1], E_V4x1DImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4708; /* aarch64_st1_x4_di */

    case E_V4x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HFmode
          || !register_operand (operands[1], E_V4x4HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4709; /* aarch64_st1_x4_v4hf */

    case E_V4x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SFmode
          || !register_operand (operands[1], E_V4x2SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4710; /* aarch64_st1_x4_v2sf */

    case E_V4x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DFmode
          || !register_operand (operands[1], E_V4x1DFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4711; /* aarch64_st1_x4_df */

    case E_V4x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4BFmode
          || !register_operand (operands[1], E_V4x4BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4712; /* aarch64_st1_x4_v4bf */

    case E_V4x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x16QImode
          || !register_operand (operands[1], E_V4x16QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4713; /* aarch64_st1_x4_v16qi */

    case E_V4x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HImode
          || !register_operand (operands[1], E_V4x8HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4714; /* aarch64_st1_x4_v8hi */

    case E_V4x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SImode
          || !register_operand (operands[1], E_V4x4SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4715; /* aarch64_st1_x4_v4si */

    case E_V4x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DImode
          || !register_operand (operands[1], E_V4x2DImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4716; /* aarch64_st1_x4_v2di */

    case E_V4x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HFmode
          || !register_operand (operands[1], E_V4x8HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4717; /* aarch64_st1_x4_v8hf */

    case E_V4x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SFmode
          || !register_operand (operands[1], E_V4x4SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4718; /* aarch64_st1_x4_v4sf */

    case E_V4x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DFmode
          || !register_operand (operands[1], E_V4x2DFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4719; /* aarch64_st1_x4_v2df */

    case E_V4x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8BFmode
          || !register_operand (operands[1], E_V4x8BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4720; /* aarch64_st1_x4_v8bf */

    case E_V8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4737; /* aarch64_be_st1v8qi */

    case E_V16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4738; /* aarch64_be_st1v16qi */

    case E_V4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4739; /* aarch64_be_st1v4hi */

    case E_V8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4740; /* aarch64_be_st1v8hi */

    case E_V2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4741; /* aarch64_be_st1v2si */

    case E_V4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4742; /* aarch64_be_st1v4si */

    case E_V2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4743; /* aarch64_be_st1v2di */

    case E_V4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4744; /* aarch64_be_st1v4hf */

    case E_V8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4745; /* aarch64_be_st1v8hf */

    case E_V4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BFmode
          || !register_operand (operands[1], E_V4BFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4746; /* aarch64_be_st1v4bf */

    case E_V8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BFmode
          || !register_operand (operands[1], E_V8BFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4747; /* aarch64_be_st1v8bf */

    case E_V2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4748; /* aarch64_be_st1v2sf */

    case E_V4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4749; /* aarch64_be_st1v4sf */

    case E_V2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4750; /* aarch64_be_st1v2df */

    case E_DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4751; /* aarch64_be_st1di */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern477 (x2))
    {
    case 0:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6577; /* aarch64_pred_qnegvnx16qi */

    case 1:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6586; /* aarch64_pred_qnegvnx8qi */

    case 2:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6595; /* aarch64_pred_qnegvnx4qi */

    case 3:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6604; /* aarch64_pred_qnegvnx2qi */

    case 4:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6613; /* aarch64_pred_qnegvnx8hi */

    case 5:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6622; /* aarch64_pred_qnegvnx4hi */

    case 6:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6631; /* aarch64_pred_qnegvnx2hi */

    case 7:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6640; /* aarch64_pred_qnegvnx4si */

    case 8:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6649; /* aarch64_pred_qnegvnx2si */

    case 9:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6658; /* aarch64_pred_qnegvnx2di */

    case 10:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6667; /* aarch64_pred_qnegv8qi */

    case 11:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6676; /* aarch64_pred_qnegv16qi */

    case 12:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6685; /* aarch64_pred_qnegv4hi */

    case 13:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6694; /* aarch64_pred_qnegv8hi */

    case 14:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6703; /* aarch64_pred_qnegv2si */

    case 15:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6712; /* aarch64_pred_qnegv4si */

    case 16:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6721; /* aarch64_pred_qnegv2di */

    case 17:
      if (!(
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2763 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6730; /* aarch64_pred_qnegv1di */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern477 (x2))
    {
    case 0:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6575; /* aarch64_pred_rbitvnx16qi */

    case 1:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6584; /* aarch64_pred_rbitvnx8qi */

    case 2:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6593; /* aarch64_pred_rbitvnx4qi */

    case 3:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6602; /* aarch64_pred_rbitvnx2qi */

    case 4:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6611; /* aarch64_pred_rbitvnx8hi */

    case 5:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6620; /* aarch64_pred_rbitvnx4hi */

    case 6:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6629; /* aarch64_pred_rbitvnx2hi */

    case 7:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6638; /* aarch64_pred_rbitvnx4si */

    case 8:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6647; /* aarch64_pred_rbitvnx2si */

    case 9:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6656; /* aarch64_pred_rbitvnx2di */

    case 10:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6665; /* aarch64_pred_rbitv8qi */

    case 11:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6674; /* aarch64_pred_rbitv16qi */

    case 12:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6683; /* aarch64_pred_rbitv4hi */

    case 13:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6692; /* aarch64_pred_rbitv8hi */

    case 14:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6701; /* aarch64_pred_rbitv2si */

    case 15:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6710; /* aarch64_pred_rbitv4si */

    case 16:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6719; /* aarch64_pred_rbitv2di */

    case 17:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6728; /* aarch64_pred_rbitv1di */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern99 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_V4HImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3440; /* aarch64_sqdmulhv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_V8HImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3446; /* aarch64_sqdmulhv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_V2SImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3448; /* aarch64_sqdmulhv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_V4SImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3454; /* aarch64_sqdmulhv4si */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_HImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3456; /* aarch64_sqdmulhhi */

        case E_SImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_SImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3458; /* aarch64_sqdmulhsi */

        case E_VNx32QImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx32QImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11528; /* aarch64_sve_sqdmulhvnx32qi */

        case E_VNx16HImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx16HImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11531; /* aarch64_sve_sqdmulhvnx16hi */

        case E_VNx8SImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx8SImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11534; /* aarch64_sve_sqdmulhvnx8si */

        case E_VNx4DImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx4DImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11537; /* aarch64_sve_sqdmulhvnx4di */

        case E_VNx64QImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx64QImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11540; /* aarch64_sve_sqdmulhvnx64qi */

        case E_VNx32HImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx32HImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11543; /* aarch64_sve_sqdmulhvnx32hi */

        case E_VNx16SImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx16SImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11546; /* aarch64_sve_sqdmulhvnx16si */

        case E_VNx8DImode:
          x2 = XEXP (x1, 1);
          if (pattern80 (x2, 
E_VNx8DImode) != 0
              || !
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11549; /* aarch64_sve_sqdmulhvnx8di */

        case E_VNx16QImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_VNx16QImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11803; /* aarch64_sve_sqdmulhvnx16qi */

        case E_VNx8HImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_VNx8HImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11805; /* aarch64_sve_sqdmulhvnx8hi */

        case E_VNx4SImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_VNx4SImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11807; /* aarch64_sve_sqdmulhvnx4si */

        case E_VNx2DImode:
          x2 = XEXP (x1, 1);
          if (pattern79 (x2, 
E_VNx2DImode) != 0
              || !
#line 1161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11809; /* aarch64_sve_sqdmulhvnx2di */

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern793 (x2, 
E_HImode, 
E_V4HImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3460; /* aarch64_sqdmulh_nv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern793 (x2, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3466; /* aarch64_sqdmulh_nv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern793 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3468; /* aarch64_sqdmulh_nv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern793 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3474; /* aarch64_sqdmulh_nv4si */

        case E_VNx32QImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx16QImode, 
E_VNx32QImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11552; /* aarch64_sve_single_sqdmulhvnx32qi */

        case E_VNx16HImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx8HImode, 
E_VNx16HImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11555; /* aarch64_sve_single_sqdmulhvnx16hi */

        case E_VNx8SImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx4SImode, 
E_VNx8SImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11558; /* aarch64_sve_single_sqdmulhvnx8si */

        case E_VNx4DImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx2DImode, 
E_VNx4DImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11561; /* aarch64_sve_single_sqdmulhvnx4di */

        case E_VNx64QImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx16QImode, 
E_VNx64QImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11564; /* aarch64_sve_single_sqdmulhvnx64qi */

        case E_VNx32HImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx8HImode, 
E_VNx32HImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11567; /* aarch64_sve_single_sqdmulhvnx32hi */

        case E_VNx16SImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx4SImode, 
E_VNx16SImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11570; /* aarch64_sve_single_sqdmulhvnx16si */

        case E_VNx8DImode:
          x2 = XEXP (x1, 1);
          if (pattern81 (x2, 
E_VNx2DImode, 
E_VNx8DImode) != 0
              || !
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11573; /* aarch64_sve_single_sqdmulhvnx8di */

        default:
          return -1;
        }

    case 2:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3476; /* aarch64_sqdmulh_lanev4hi */

    case 3:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3492; /* aarch64_sqdmulh_laneqv4hi */

    case 4:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3482; /* aarch64_sqdmulh_lanev8hi */

    case 5:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3498; /* aarch64_sqdmulh_laneqv8hi */

    case 6:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3484; /* aarch64_sqdmulh_lanev2si */

    case 7:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3500; /* aarch64_sqdmulh_laneqv2si */

    case 8:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3490; /* aarch64_sqdmulh_lanev4si */

    case 9:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3506; /* aarch64_sqdmulh_laneqv4si */

    case 10:
      if (!
#line 5612 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3508; /* aarch64_sqdmulh_lanehi */

    case 11:
      if (!
#line 5627 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3512; /* aarch64_sqdmulh_laneqhi */

    case 12:
      if (!
#line 5612 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3510; /* aarch64_sqdmulh_lanesi */

    case 13:
      if (!
#line 5627 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3514; /* aarch64_sqdmulh_laneqsi */

    case 14:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11811; /* aarch64_sve_sqdmulh_lane_vnx8hi */

    case 15:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11813; /* aarch64_sve_sqdmulh_lane_vnx4si */

    case 16:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11815; /* aarch64_sve_sqdmulh_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern108 (x1))
    {
    case 0:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4859; /* aarch64_uzp2v8qi */

    case 1:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4867; /* aarch64_uzp2v16qi */

    case 2:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4883; /* aarch64_uzp2v4hi */

    case 3:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4891; /* aarch64_uzp2v8hi */

    case 4:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4907; /* aarch64_uzp2v2si */

    case 5:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4915; /* aarch64_uzp2v4si */

    case 6:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4921; /* aarch64_uzp2v2di */

    case 7:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4937; /* aarch64_uzp2v4hf */

    case 8:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4945; /* aarch64_uzp2v8hf */

    case 9:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4961; /* aarch64_uzp2v4bf */

    case 10:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4969; /* aarch64_uzp2v8bf */

    case 11:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4985; /* aarch64_uzp2v2sf */

    case 12:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4993; /* aarch64_uzp2v4sf */

    case 13:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4999; /* aarch64_uzp2v2df */

    case 14:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10536; /* aarch64_sve_uzp2vnx16qi */

    case 15:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10546; /* aarch64_sve_uzp2vnx8qi */

    case 16:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10556; /* aarch64_sve_uzp2vnx4qi */

    case 17:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10566; /* aarch64_sve_uzp2vnx2qi */

    case 18:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10576; /* aarch64_sve_uzp2vnx8hi */

    case 19:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10586; /* aarch64_sve_uzp2vnx4hi */

    case 20:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10596; /* aarch64_sve_uzp2vnx2hi */

    case 21:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10606; /* aarch64_sve_uzp2vnx4si */

    case 22:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10616; /* aarch64_sve_uzp2vnx2si */

    case 23:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10626; /* aarch64_sve_uzp2vnx2di */

    case 24:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10636; /* aarch64_sve_uzp2vnx8hf */

    case 25:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10646; /* aarch64_sve_uzp2vnx4hf */

    case 26:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10656; /* aarch64_sve_uzp2vnx2hf */

    case 27:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10666; /* aarch64_sve_uzp2vnx8bf */

    case 28:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10676; /* aarch64_sve_uzp2vnx4bf */

    case 29:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10686; /* aarch64_sve_uzp2vnx2bf */

    case 30:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10696; /* aarch64_sve_uzp2vnx4sf */

    case 31:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10706; /* aarch64_sve_uzp2vnx2sf */

    case 32:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10716; /* aarch64_sve_uzp2vnx2df */

    case 33:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10797; /* aarch64_sve_uzp2vnx16bi */

    case 34:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10803; /* aarch64_sve_uzp2vnx8bi */

    case 35:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10809; /* aarch64_sve_uzp2vnx4bi */

    case 36:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10815; /* aarch64_sve_uzp2vnx2bi */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[1], E_V4x8QImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4569; /* aarch64_vec_store_lanesv4x8qi_lanev8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[1], E_V4x4HImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4570; /* aarch64_vec_store_lanesv4x4hi_lanev4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[1], E_V4x2SImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4571; /* aarch64_vec_store_lanesv4x2si_lanev2si */

    case E_V4x1DImode:
      if (!register_operand (operands[1], E_V4x1DImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4572; /* aarch64_vec_store_lanesv4x1di_lanedi */

    case E_V4x4HFmode:
      if (!register_operand (operands[1], E_V4x4HFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4573; /* aarch64_vec_store_lanesv4x4hf_lanev4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[1], E_V4x2SFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4574; /* aarch64_vec_store_lanesv4x2sf_lanev2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[1], E_V4x1DFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4575; /* aarch64_vec_store_lanesv4x1df_lanedf */

    case E_V4x4BFmode:
      if (!register_operand (operands[1], E_V4x4BFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4576; /* aarch64_vec_store_lanesv4x4bf_lanev4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[1], E_V4x16QImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4577; /* aarch64_vec_store_lanesv4x16qi_lanev16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[1], E_V4x8HImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4578; /* aarch64_vec_store_lanesv4x8hi_lanev8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[1], E_V4x4SImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4579; /* aarch64_vec_store_lanesv4x4si_lanev4si */

    case E_V4x2DImode:
      if (!register_operand (operands[1], E_V4x2DImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4580; /* aarch64_vec_store_lanesv4x2di_lanev2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[1], E_V4x8HFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4581; /* aarch64_vec_store_lanesv4x8hf_lanev8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[1], E_V4x4SFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4582; /* aarch64_vec_store_lanesv4x4sf_lanev4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[1], E_V4x2DFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4583; /* aarch64_vec_store_lanesv4x2df_lanev2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[1], E_V4x8BFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4584; /* aarch64_vec_store_lanesv4x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern101 (x1))
    {
    case 0:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3651; /* aarch64_urshlv8qi */

    case 1:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3657; /* aarch64_urshlv16qi */

    case 2:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3667; /* aarch64_urshlv4hi */

    case 3:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3673; /* aarch64_urshlv8hi */

    case 4:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3683; /* aarch64_urshlv2si */

    case 5:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3689; /* aarch64_urshlv4si */

    case 6:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3693; /* aarch64_urshlv2di */

    case 7:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3703; /* aarch64_urshldi */

    case 8:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11530; /* aarch64_sve_urshlvnx32qi */

    case 9:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11533; /* aarch64_sve_urshlvnx16hi */

    case 10:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11536; /* aarch64_sve_urshlvnx8si */

    case 11:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11539; /* aarch64_sve_urshlvnx4di */

    case 12:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11542; /* aarch64_sve_urshlvnx64qi */

    case 13:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11545; /* aarch64_sve_urshlvnx32hi */

    case 14:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11548; /* aarch64_sve_urshlvnx16si */

    case 15:
      if (!
#line 755 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11551; /* aarch64_sve_urshlvnx8di */

    case 16:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11554; /* aarch64_sve_single_urshlvnx32qi */

    case 17:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11557; /* aarch64_sve_single_urshlvnx16hi */

    case 18:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11560; /* aarch64_sve_single_urshlvnx8si */

    case 19:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11563; /* aarch64_sve_single_urshlvnx4di */

    case 20:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11566; /* aarch64_sve_single_urshlvnx64qi */

    case 21:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11569; /* aarch64_sve_single_urshlvnx32hi */

    case 22:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11572; /* aarch64_sve_single_urshlvnx16si */

    case 23:
      if (!
#line 766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11575; /* aarch64_sve_single_urshlvnx8di */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3706; /* aarch64_sqshlv8qi */

    case 1:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3718; /* aarch64_sqshlv16qi */

    case 2:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3722; /* aarch64_sqshlv4hi */

    case 3:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3734; /* aarch64_sqshlv8hi */

    case 4:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3738; /* aarch64_sqshlv2si */

    case 5:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3750; /* aarch64_sqshlv4si */

    case 6:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3754; /* aarch64_sqshlv2di */

    case 7:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3758; /* aarch64_sqshlqi */

    case 8:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3762; /* aarch64_sqshlhi */

    case 9:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3766; /* aarch64_sqshlsi */

    case 10:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3770; /* aarch64_sqshldi */

    case 11:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3861; /* aarch64_sqshl_nv8qi */

    case 12:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3864; /* aarch64_sqshl_nv16qi */

    case 13:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3867; /* aarch64_sqshl_nv4hi */

    case 14:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3870; /* aarch64_sqshl_nv8hi */

    case 15:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3873; /* aarch64_sqshl_nv2si */

    case 16:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3876; /* aarch64_sqshl_nv4si */

    case 17:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3879; /* aarch64_sqshl_nv2di */

    case 18:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3882; /* aarch64_sqshl_nqi */

    case 19:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3885; /* aarch64_sqshl_nhi */

    case 20:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3888; /* aarch64_sqshl_nsi */

    case 21:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3891; /* aarch64_sqshl_ndi */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[2], E_VNx16BImode)
          || !aarch64_sve_ld1ro_operand_b (operands[1], E_OImode)
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6463; /* aarch64_sve_ld1rovnx16qi */

    case E_VNx8HImode:
      if (pattern725 (x3, 
E_VNx8HImode) != 0
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6464; /* aarch64_sve_ld1rovnx8hi */

    case E_VNx4SImode:
      if (pattern726 (x3, 
E_VNx4SImode) != 0
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6465; /* aarch64_sve_ld1rovnx4si */

    case E_VNx2DImode:
      if (pattern727 (x3, 
E_VNx2DImode) != 0
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6466; /* aarch64_sve_ld1rovnx2di */

    case E_VNx8BFmode:
      if (pattern725 (x3, 
E_VNx8BFmode) != 0
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6467; /* aarch64_sve_ld1rovnx8bf */

    case E_VNx8HFmode:
      if (pattern725 (x3, 
E_VNx8HFmode) != 0
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6468; /* aarch64_sve_ld1rovnx8hf */

    case E_VNx4SFmode:
      if (pattern726 (x3, 
E_VNx4SFmode) != 0
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6469; /* aarch64_sve_ld1rovnx4sf */

    case E_VNx2DFmode:
      if (pattern727 (x3, 
E_VNx2DFmode) != 0
          || !
#line 2818 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM && TARGET_NON_STREAMING))
        return -1;
      return 6470; /* aarch64_sve_ld1rovnx2df */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern724 (x3, 
E_V16QImode, 
E_VNx16BImode, 
E_VNx16QImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6455; /* aarch64_sve_ld1rqvnx16qi */

    case E_VNx8HImode:
      if (pattern724 (x3, 
E_V8HImode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6456; /* aarch64_sve_ld1rqvnx8hi */

    case E_VNx4SImode:
      if (pattern724 (x3, 
E_V4SImode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6457; /* aarch64_sve_ld1rqvnx4si */

    case E_VNx2DImode:
      if (pattern724 (x3, 
E_V2DImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6458; /* aarch64_sve_ld1rqvnx2di */

    case E_VNx8BFmode:
      if (pattern724 (x3, 
E_V8BFmode, 
E_VNx8BImode, 
E_VNx8BFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6459; /* aarch64_sve_ld1rqvnx8bf */

    case E_VNx8HFmode:
      if (pattern724 (x3, 
E_V8HFmode, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6460; /* aarch64_sve_ld1rqvnx8hf */

    case E_VNx4SFmode:
      if (pattern724 (x3, 
E_V4SFmode, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6461; /* aarch64_sve_ld1rqvnx4sf */

    case E_VNx2DFmode:
      if (pattern724 (x3, 
E_V2DFmode, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6462; /* aarch64_sve_ld1rqvnx2df */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2129; /* aarch64_sminpv8qi */

    case 1:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2135; /* aarch64_sminpv16qi */

    case 2:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2145; /* aarch64_sminpv4hi */

    case 3:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2151; /* aarch64_sminpv8hi */

    case 4:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2161; /* aarch64_sminpv2si */

    case 5:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2167; /* aarch64_sminpv4si */

    case 6:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10414; /* aarch64_pred_reduc_smin_vnx16qi */

    case 7:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10421; /* aarch64_pred_reduc_smin_vnx8hi */

    case 8:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10428; /* aarch64_pred_reduc_smin_vnx4si */

    case 9:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10435; /* aarch64_pred_reduc_smin_vnx2di */

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
        return -1;
      return 1139; /* tlsie_tiny_si */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
        return -1;
      return 1140; /* tlsie_tiny_di */

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern730 (x3, 
E_VNx4BImode, 
E_VNx4SImode, 
E_VNx1SImode) != 0
          || !
#line 229 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11162; /* aarch64_sve_ld1_extendqvnx4si */

    case E_VNx2DImode:
      if (pattern730 (x3, 
E_VNx2BImode, 
E_VNx2DImode, 
E_VNx1DImode) != 0
          || !
#line 229 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11163; /* aarch64_sve_ld1_extendqvnx2di */

    case E_VNx4SFmode:
      if (pattern730 (x3, 
E_VNx4BImode, 
E_VNx4SFmode, 
E_VNx1SImode) != 0
          || !
#line 229 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11164; /* aarch64_sve_ld1_extendqvnx4sf */

    case E_VNx2DFmode:
      if (pattern730 (x3, 
E_VNx2BImode, 
E_VNx2DFmode, 
E_VNx1DImode) != 0
          || !
#line 229 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11165; /* aarch64_sve_ld1_extendqvnx2df */

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern94 (x1))
    {
    case 0:
      if (!(
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2177; /* aarch64_sminpv4hf */

    case 1:
      if (!(
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2183; /* aarch64_sminpv8hf */

    case 2:
      if (!
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2193; /* aarch64_sminpv2sf */

    case 3:
      if (!
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2199; /* aarch64_sminpv4sf */

    case 4:
      if (!
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2203; /* aarch64_sminpv2df */

    case 5:
      if (!
#line 9027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10443; /* aarch64_pred_reduc_smin_vnx8hf */

    case 6:
      if (!
#line 9027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10448; /* aarch64_pred_reduc_smin_vnx4sf */

    case 7:
      if (!
#line 9027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10453; /* aarch64_pred_reduc_smin_vnx2df */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern112 (x2, 
E_VNx16BImode, 
86) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 85
      || GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 85
      || GET_MODE (x4) != E_VNx16BImode
      || !
#line 1127 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 5729; /* aarch64_update_ffr_for_load */
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern130 (x1))
    {
    case 0:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12144; /* aarch64_sve_umulltvnx8hi */

    case 1:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12165; /* aarch64_sve_umulltvnx4si */

    case 2:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12186; /* aarch64_sve_umulltvnx2di */

    case 3:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12194; /* aarch64_sve_umullt_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12200; /* aarch64_sve_umullt_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern136 (x1))
    {
    case 0:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12940; /* aarch64_sve_bgrpvnx16qi */

    case 1:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12943; /* aarch64_sve_bgrpvnx8hi */

    case 2:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12946; /* aarch64_sve_bgrpvnx4si */

    case 3:
      if (!
#line 3922 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12949; /* aarch64_sve_bgrpvnx2di */

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern142 (x1))
    {
    case 0:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12772; /* aarch64_pred_reduc_andqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12780; /* aarch64_pred_reduc_andqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12788; /* aarch64_pred_reduc_andqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12796; /* aarch64_pred_reduc_andqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern121 (x1))
    {
    case 0:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 8))
        return -1;
      return 10404; /* aarch64_pred_reduc_uadd_vnx16qi */

    case 1:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 10406; /* aarch64_pred_reduc_uadd_vnx8hi */

    case 2:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 10408; /* aarch64_pred_reduc_uadd_vnx4si */

    case 3:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 10410; /* aarch64_pred_reduc_uadd_vnx2di */

    default:
      return -1;
    }
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1122 (x2))
        {
        case 0:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10924; /* *cond_float_nonextendvnx8hivnx8hf_relaxed */
          break;

        case 1:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10930; /* *cond_float_nonextendvnx4sivnx8hf_relaxed */
          break;

        case 2:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10936; /* *cond_float_nonextendvnx2divnx8hf_relaxed */
          break;

        case 3:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10926; /* *cond_float_nonextendvnx8hivnx4sf_relaxed */
          break;

        case 4:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10932; /* *cond_float_nonextendvnx4sivnx4sf_relaxed */
          break;

        case 5:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10938; /* *cond_float_nonextendvnx2divnx4sf_relaxed */
          break;

        case 6:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10928; /* *cond_float_nonextendvnx8hivnx2df_relaxed */
          break;

        case 7:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10934; /* *cond_float_nonextendvnx4sivnx2df_relaxed */
          break;

        case 8:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10940; /* *cond_float_nonextendvnx2divnx2df_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (pattern1123 (x2))
        {
        case 0:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10942; /* *cond_float_nonextendvnx8hivnx8hf_strict */
          break;

        case 1:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10948; /* *cond_float_nonextendvnx4sivnx8hf_strict */
          break;

        case 2:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10954; /* *cond_float_nonextendvnx2divnx8hf_strict */
          break;

        case 3:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10944; /* *cond_float_nonextendvnx8hivnx4sf_strict */
          break;

        case 4:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10950; /* *cond_float_nonextendvnx4sivnx4sf_strict */
          break;

        case 5:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10956; /* *cond_float_nonextendvnx2divnx4sf_strict */
          break;

        case 6:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10946; /* *cond_float_nonextendvnx8hivnx2df_strict */
          break;

        case 7:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10952; /* *cond_float_nonextendvnx4sivnx2df_strict */
          break;

        case 8:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10958; /* *cond_float_nonextendvnx2divnx2df_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
      || pattern1121 (x2, 
E_VNx4SImode, 
E_VNx2DFmode) != 0
      || !
#line 9703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 10960; /* *cond_float_extendvnx4sivnx2df */
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11832; /* *cond_uqshlvnx2di_2 */
    }
  if (register_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11840; /* *cond_uqshlvnx2di_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11848; /* *cond_uqshlvnx2di_any */
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11825; /* *cond_sqshlvnx16qi_2 */
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11833; /* *cond_sqshlvnx16qi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11841; /* *cond_sqshlvnx16qi_any */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11710; /* *cond_uhsubvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11751; /* *cond_uhsubvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11791; /* *cond_uhsubvnx2di_any */
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11683; /* *cond_srshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11729; /* *cond_srshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11769; /* *cond_srshlvnx8hi_any */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11704; /* *cond_shsubvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11746; /* *cond_shsubvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11786; /* *cond_shsubvnx2di_any */
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1059 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8540; /* *cond_smaxvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8686; /* *cond_smaxvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8790; /* *cond_smaxvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8553; /* *cond_smaxvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8699; /* *cond_smaxvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8803; /* *cond_smaxvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8566; /* *cond_smaxvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8712; /* *cond_smaxvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8816; /* *cond_smaxvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8579; /* *cond_smaxvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8725; /* *cond_smaxvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8829; /* *cond_smaxvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8638; /* *cond_smaxvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8888; /* *cond_smaxvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8645; /* *cond_smaxvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8895; /* *cond_smaxvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8652; /* *cond_smaxvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8902; /* *cond_smaxvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8592; /* *cond_smaxvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8738; /* *cond_smaxvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8842; /* *cond_smaxvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8605; /* *cond_smaxvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8751; /* *cond_smaxvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8855; /* *cond_smaxvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8618; /* *cond_smaxvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8764; /* *cond_smaxvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8868; /* *cond_smaxvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8631; /* *cond_smaxvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8777; /* *cond_smaxvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8881; /* *cond_smaxvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8659; /* *cond_smaxvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8909; /* *cond_smaxvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8666; /* *cond_smaxvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8916; /* *cond_smaxvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8673; /* *cond_smaxvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8923; /* *cond_smaxvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1058 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8532; /* *cond_divvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8678; /* *cond_divvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8782; /* *cond_divvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8545; /* *cond_divvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8691; /* *cond_divvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8795; /* *cond_divvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8558; /* *cond_divvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8704; /* *cond_divvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8808; /* *cond_divvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8571; /* *cond_divvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8717; /* *cond_divvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8821; /* *cond_divvnx2df_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8584; /* *cond_divvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8730; /* *cond_divvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8834; /* *cond_divvnx8bf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8597; /* *cond_divvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8743; /* *cond_divvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8847; /* *cond_divvnx8hf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8610; /* *cond_divvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8756; /* *cond_divvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8860; /* *cond_divvnx4sf_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8623; /* *cond_divvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8769; /* *cond_divvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8873; /* *cond_divvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx16QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6436; /* sve_ld1rvnx16qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx16QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9462; /* aarch64_sel_dupvnx16qi */

    case E_VNx8QImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6437; /* sve_ld1rvnx8qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9463; /* aarch64_sel_dupvnx8qi */

    case E_VNx4QImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6438; /* sve_ld1rvnx4qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9464; /* aarch64_sel_dupvnx4qi */

    case E_VNx2QImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6439; /* sve_ld1rvnx2qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9465; /* aarch64_sel_dupvnx2qi */

    case E_VNx8HImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8HImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6440; /* sve_ld1rvnx8hi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9466; /* aarch64_sel_dupvnx8hi */

    case E_VNx4HImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4HImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6441; /* sve_ld1rvnx4hi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9467; /* aarch64_sel_dupvnx4hi */

    case E_VNx2HImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2HImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6442; /* sve_ld1rvnx2hi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9468; /* aarch64_sel_dupvnx2hi */

    case E_VNx4SImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4SImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6443; /* sve_ld1rvnx4si */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9469; /* aarch64_sel_dupvnx4si */

    case E_VNx2SImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2SImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6444; /* sve_ld1rvnx2si */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9470; /* aarch64_sel_dupvnx2si */

    case E_VNx2DImode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_DImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2DImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6445; /* sve_ld1rvnx2di */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2DImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9471; /* aarch64_sel_dupvnx2di */

    case E_VNx8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8HFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6446; /* sve_ld1rvnx8hf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9472; /* aarch64_sel_dupvnx8hf */

    case E_VNx4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx4HFmode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4HFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6447; /* sve_ld1rvnx4hf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9473; /* aarch64_sel_dupvnx4hf */

    case E_VNx2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2HFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2HFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6448; /* sve_ld1rvnx2hf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9474; /* aarch64_sel_dupvnx2hf */

    case E_VNx8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_BFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8BFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6449; /* sve_ld1rvnx8bf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_BFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9475; /* aarch64_sel_dupvnx8bf */

    case E_VNx4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx4BFmode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_BFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4BFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6450; /* sve_ld1rvnx4bf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_BFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9476; /* aarch64_sel_dupvnx4bf */

    case E_VNx2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2BFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_BFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2BFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6451; /* sve_ld1rvnx2bf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_BFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9477; /* aarch64_sel_dupvnx2bf */

    case E_VNx4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4SFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6452; /* sve_ld1rvnx4sf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9478; /* aarch64_sel_dupvnx4sf */

    case E_VNx2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2SFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2SFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6453; /* sve_ld1rvnx2sf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9479; /* aarch64_sel_dupvnx2sf */

    case E_VNx2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern731 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_DFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2DFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6454; /* sve_ld1rvnx2df */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2DFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9480; /* aarch64_sel_dupvnx2df */

    default:
      return -1;
    }
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern732 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7489; /* *cond_sssubvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7659; /* *cond_sssubvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7829; /* *cond_sssubvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7506; /* *cond_sssubvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7676; /* *cond_sssubvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7846; /* *cond_sssubvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7523; /* *cond_sssubvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7693; /* *cond_sssubvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7863; /* *cond_sssubvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7540; /* *cond_sssubvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7710; /* *cond_sssubvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7880; /* *cond_sssubvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7557; /* *cond_sssubvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7727; /* *cond_sssubvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7897; /* *cond_sssubvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7574; /* *cond_sssubvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7744; /* *cond_sssubvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7914; /* *cond_sssubvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7591; /* *cond_sssubvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7761; /* *cond_sssubvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7931; /* *cond_sssubvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7608; /* *cond_sssubvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7778; /* *cond_sssubvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7948; /* *cond_sssubvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7625; /* *cond_sssubvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7795; /* *cond_sssubvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7965; /* *cond_sssubvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7642; /* *cond_sssubvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7812; /* *cond_sssubvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7982; /* *cond_sssubvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern732 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7476; /* *cond_mulvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7646; /* *cond_mulvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7816; /* *cond_mulvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7493; /* *cond_mulvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7663; /* *cond_mulvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7833; /* *cond_mulvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7510; /* *cond_mulvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7680; /* *cond_mulvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7850; /* *cond_mulvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7527; /* *cond_mulvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7697; /* *cond_mulvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7867; /* *cond_mulvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7544; /* *cond_mulvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7714; /* *cond_mulvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7884; /* *cond_mulvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7561; /* *cond_mulvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7731; /* *cond_mulvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7901; /* *cond_mulvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7578; /* *cond_mulvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7748; /* *cond_mulvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7918; /* *cond_mulvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7595; /* *cond_mulvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7765; /* *cond_mulvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7935; /* *cond_mulvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7612; /* *cond_mulvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7782; /* *cond_mulvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7952; /* *cond_mulvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7629; /* *cond_mulvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7799; /* *cond_mulvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7969; /* *cond_mulvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !register_operand (operands[2], E_V2x8QImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4417; /* aarch64_vec_load_lanesv2x8qi_lanev8qi */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !register_operand (operands[2], E_V2x4HImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4418; /* aarch64_vec_load_lanesv2x4hi_lanev4hi */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !register_operand (operands[2], E_V2x2SImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4419; /* aarch64_vec_load_lanesv2x2si_lanev2si */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !register_operand (operands[2], E_V2x1DImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4420; /* aarch64_vec_load_lanesv2x1di_lanedi */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !register_operand (operands[2], E_V2x4HFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4421; /* aarch64_vec_load_lanesv2x4hf_lanev4hf */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !register_operand (operands[2], E_V2x2SFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4422; /* aarch64_vec_load_lanesv2x2sf_lanev2sf */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !register_operand (operands[2], E_V2x1DFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4423; /* aarch64_vec_load_lanesv2x1df_lanedf */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !register_operand (operands[2], E_V2x4BFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4424; /* aarch64_vec_load_lanesv2x4bf_lanev4bf */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode)
          || GET_MODE (x3) != E_V2x16QImode
          || !register_operand (operands[2], E_V2x16QImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4425; /* aarch64_vec_load_lanesv2x16qi_lanev16qi */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode)
          || GET_MODE (x3) != E_V2x8HImode
          || !register_operand (operands[2], E_V2x8HImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4426; /* aarch64_vec_load_lanesv2x8hi_lanev8hi */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode)
          || GET_MODE (x3) != E_V2x4SImode
          || !register_operand (operands[2], E_V2x4SImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4427; /* aarch64_vec_load_lanesv2x4si_lanev4si */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode)
          || GET_MODE (x3) != E_V2x2DImode
          || !register_operand (operands[2], E_V2x2DImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4428; /* aarch64_vec_load_lanesv2x2di_lanev2di */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode)
          || GET_MODE (x3) != E_V2x8HFmode
          || !register_operand (operands[2], E_V2x8HFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4429; /* aarch64_vec_load_lanesv2x8hf_lanev8hf */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode)
          || GET_MODE (x3) != E_V2x4SFmode
          || !register_operand (operands[2], E_V2x4SFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4430; /* aarch64_vec_load_lanesv2x4sf_lanev4sf */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode)
          || GET_MODE (x3) != E_V2x2DFmode
          || !register_operand (operands[2], E_V2x2DFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4431; /* aarch64_vec_load_lanesv2x2df_lanev2df */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode)
          || GET_MODE (x3) != E_V2x8BFmode
          || !register_operand (operands[2], E_V2x8BFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4432; /* aarch64_vec_load_lanesv2x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern798 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5738; /* maskloadvnx16qivnx16bi */

    case E_VNx8QImode:
      if (pattern798 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5739; /* maskloadvnx8qivnx8bi */

    case E_VNx4QImode:
      if (pattern798 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5740; /* maskloadvnx4qivnx4bi */

    case E_VNx2QImode:
      if (pattern798 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5741; /* maskloadvnx2qivnx2bi */

    case E_VNx8HImode:
      if (pattern798 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5742; /* maskloadvnx8hivnx8bi */

    case E_VNx4HImode:
      if (pattern798 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5743; /* maskloadvnx4hivnx4bi */

    case E_VNx2HImode:
      if (pattern798 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5744; /* maskloadvnx2hivnx2bi */

    case E_VNx4SImode:
      if (pattern798 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5745; /* maskloadvnx4sivnx4bi */

    case E_VNx2SImode:
      if (pattern798 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5746; /* maskloadvnx2sivnx2bi */

    case E_VNx2DImode:
      if (pattern798 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5747; /* maskloadvnx2divnx2bi */

    case E_VNx8HFmode:
      if (pattern798 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5748; /* maskloadvnx8hfvnx8bi */

    case E_VNx4HFmode:
      if (pattern798 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5749; /* maskloadvnx4hfvnx4bi */

    case E_VNx2HFmode:
      if (pattern798 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5750; /* maskloadvnx2hfvnx2bi */

    case E_VNx8BFmode:
      if (pattern798 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5751; /* maskloadvnx8bfvnx8bi */

    case E_VNx4BFmode:
      if (pattern798 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5752; /* maskloadvnx4bfvnx4bi */

    case E_VNx2BFmode:
      if (pattern798 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5753; /* maskloadvnx2bfvnx2bi */

    case E_VNx4SFmode:
      if (pattern798 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5754; /* maskloadvnx4sfvnx4bi */

    case E_VNx2SFmode:
      if (pattern798 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5755; /* maskloadvnx2sfvnx2bi */

    case E_VNx2DFmode:
      if (pattern798 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5756; /* maskloadvnx2dfvnx2bi */

    default:
      return -1;
    }
}

 int
recog_316 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern174 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9980; /* while_wrsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9990; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10000; /* while_wrsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10010; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10020; /* while_wrsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10030; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10040; /* while_wrsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10050; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern174 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9972; /* while_ultsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9982; /* while_ultdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9992; /* while_ultsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10002; /* while_ultdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10012; /* while_ultsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10022; /* while_ultdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10032; /* while_ultsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10042; /* while_ultdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern190 (x1))
    {
    case 0:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11311; /* aarch64_st1vnx32qi */

    case 1:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11313; /* aarch64_st1vnx16hi */

    case 2:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11315; /* aarch64_st1vnx8si */

    case 3:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11317; /* aarch64_st1vnx4di */

    case 4:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11319; /* aarch64_st1vnx16bf */

    case 5:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11321; /* aarch64_st1vnx16hf */

    case 6:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11323; /* aarch64_st1vnx8sf */

    case 7:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11325; /* aarch64_st1vnx4df */

    case 8:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11327; /* aarch64_st1vnx64qi */

    case 9:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11329; /* aarch64_st1vnx32hi */

    case 10:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11331; /* aarch64_st1vnx16si */

    case 11:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11333; /* aarch64_st1vnx8di */

    case 12:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11335; /* aarch64_st1vnx32bf */

    case 13:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11337; /* aarch64_st1vnx32hf */

    case 14:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11339; /* aarch64_st1vnx16sf */

    case 15:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11341; /* aarch64_st1vnx8df */

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1063 (x2))
        {
        case 0:
          if (!
#line 916 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13329; /* aarch64_sme_readvnx4di */

        case 1:
          if (!
#line 916 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13330; /* aarch64_sme_readvnx8di */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_SImode))
        return -1;
      switch (pattern1063 (x2))
        {
        case 0:
          if (!
#line 928 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13331; /* *aarch64_sme_readvnx4di_plus */

        case 1:
          if (!
#line 928 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13332; /* *aarch64_sme_readvnx8di_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern803 (x3, 
E_VNx16QImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12059; /* aarch64_sve_srivnx16qi */

    case E_VNx8HImode:
      if (pattern803 (x3, 
E_VNx8HImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12061; /* aarch64_sve_srivnx8hi */

    case E_VNx4SImode:
      if (pattern803 (x3, 
E_VNx4SImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12063; /* aarch64_sve_srivnx4si */

    case E_VNx2DImode:
      if (pattern803 (x3, 
E_VNx2DImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12065; /* aarch64_sve_srivnx2di */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (pattern879 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12671; /* aarch64_pred_flogbvnx8hf */

    case E_VNx4SImode:
      if (pattern879 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12672; /* aarch64_pred_flogbvnx4sf */

    case E_VNx2DImode:
      if (pattern879 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12673; /* aarch64_pred_flogbvnx2df */

    default:
      return -1;
    }
}

 int
recog_363 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12566; /* aarch64_sve_cmla90vnx16qi */

    case 1:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12574; /* aarch64_sve_cmla90vnx8hi */

    case 2:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12582; /* aarch64_sve_cmla90vnx4si */

    case 3:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12590; /* aarch64_sve_cmla90vnx2di */

    case 4:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12598; /* aarch64_cmla90_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12606; /* aarch64_cmla90_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern205 (x1))
    {
    case 0:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12615; /* aarch64_sve_cdot180vnx4si */

    case 1:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12619; /* aarch64_sve_cdot180vnx2di */

    case 2:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12623; /* aarch64_cdot180_lane_vnx4si */

    case 3:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12627; /* aarch64_cdot180_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern199 (x1))
    {
    case 0:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12497; /* aarch64_pred_smaxpvnx16qi */

    case 1:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12502; /* aarch64_pred_smaxpvnx8hi */

    case 2:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12507; /* aarch64_pred_smaxpvnx4si */

    case 3:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12512; /* aarch64_pred_smaxpvnx2di */

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1, 
E_VNx32BImode))
    {
    case 0:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11432; /* aarch64_sve_pext8x2 */

    case 1:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11433; /* aarch64_sve_pext16x2 */

    case 2:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11434; /* aarch64_sve_pext32x2 */

    case 3:
      if (!
#line 625 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11435; /* aarch64_sve_pext64x2 */

    default:
      return -1;
    }
}

 int
recog_394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10138; /* while_ugesivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10148; /* while_ugedivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10158; /* while_ugesivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10168; /* while_ugedivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10178; /* while_ugesivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10188; /* while_ugedivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10198; /* while_ugesivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10208; /* while_ugedivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern227 (x2, 
MEM) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_VNx16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_VNx16QImode)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!pmode_register_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode)
          || !rtx_equal_p (x5, operands[1])
          || !
#line 616 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME))
        return -1;
      return 13053; /* aarch64_sme_str0 */

    case PLUS:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != PLUS
          || GET_MODE (x7) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != PLUS)
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XEXP (x6, 1);
      operands[3] = x9;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x7, 1);
      operands[1] = x11;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x5, 0);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      x13 = XEXP (x5, 1);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !aarch64_mov_operand (operands[3], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !(
#line 631 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
            return -1;
          return 13054; /* aarch64_sme_strnsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !aarch64_mov_operand (operands[3], E_DImode)
              || GET_MODE (x5) != E_DImode
              || !(
#line 631 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
            return -1;
          return 13055; /* aarch64_sme_strndi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_407 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[3] = x7;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      switch (XWINT (x3, 0))
        {
        case 8L:
          if (!
#line 644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11436; /* aarch64_sve_psel8 */

        case 16L:
          if (!
#line 644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11437; /* aarch64_sve_psel16 */

        case 32L:
          if (!
#line 644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11438; /* aarch64_sve_psel32 */

        case 64L:
          if (!
#line 644 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11439; /* aarch64_sve_psel64 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (XWINT (x3, 0))
        {
        case 8L:
          if (!
#line 658 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 8))
            return -1;
          return 11440; /* *aarch64_sve_psel8_plus */

        case 16L:
          if (!
#line 658 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 16))
            return -1;
          return 11441; /* *aarch64_sve_psel16_plus */

        case 32L:
          if (!
#line 658 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 32))
            return -1;
          return 11442; /* *aarch64_sve_psel32_plus */

        case 64L:
          if (!
#line 658 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 64))
            return -1;
          return 11443; /* *aarch64_sve_psel64_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern224 (x1))
    {
    case 0:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11344; /* aarch64_stnt1vnx32qi_strided2 */

    case 1:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11346; /* aarch64_stnt1vnx16hi_strided2 */

    case 2:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11348; /* aarch64_stnt1vnx8si_strided2 */

    case 3:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11350; /* aarch64_stnt1vnx4di_strided2 */

    case 4:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11352; /* aarch64_stnt1vnx16bf_strided2 */

    case 5:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11354; /* aarch64_stnt1vnx16hf_strided2 */

    case 6:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11356; /* aarch64_stnt1vnx8sf_strided2 */

    case 7:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11358; /* aarch64_stnt1vnx4df_strided2 */

    case 8:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11360; /* aarch64_stnt1vnx64qi_strided2 */

    case 9:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11362; /* aarch64_stnt1vnx32hi_strided2 */

    case 10:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11364; /* aarch64_stnt1vnx16si_strided2 */

    case 11:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11366; /* aarch64_stnt1vnx8di_strided2 */

    case 12:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11368; /* aarch64_stnt1vnx32bf_strided2 */

    case 13:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11370; /* aarch64_stnt1vnx32hf_strided2 */

    case 14:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11372; /* aarch64_stnt1vnx16sf_strided2 */

    case 15:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11374; /* aarch64_stnt1vnx8df_strided2 */

    default:
      return -1;
    }
}

 int
recog_423 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern948 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6071 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8970; /* aarch64_pred_subvnx8hf */

    case E_VNx4SFmode:
      if (pattern948 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6071 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8971; /* aarch64_pred_subvnx4sf */

    case E_VNx2DFmode:
      if (pattern948 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6071 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8972; /* aarch64_pred_subvnx2df */

    case E_VNx8BFmode:
      if (pattern210 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
        return -1;
      return 11856; /* aarch64_pred_subvnx8bf */

    default:
      return -1;
    }
}

 int
recog_431 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern256 (x1))
    {
    case 0:
      if (!
#line 1431 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13740; /* aarch64_sme_smlsvnx4sivnx16qi */

    case 1:
      if (!
#line 1431 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13744; /* aarch64_sme_smlsvnx4sivnx8hi */

    case 2:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13756; /* aarch64_sme_smlsvnx4sivnx32qi */

    case 3:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13760; /* aarch64_sme_smlsvnx4sivnx64qi */

    case 4:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13764; /* aarch64_sme_smlsvnx4sivnx16hi */

    case 5:
      if (!
#line 1461 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13768; /* aarch64_sme_smlsvnx4sivnx32hi */

    case 6:
      if (!
#line 1559 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13868; /* aarch64_sme_smlsvnx2divnx8hi */

    case 7:
      if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13876; /* aarch64_sme_smlsvnx2divnx16hi */

    case 8:
      if (!
#line 1589 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13880; /* aarch64_sme_smlsvnx2divnx32hi */

    case 9:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13788; /* aarch64_sme_single_smlsvnx4sivnx32qi */

    case 10:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13792; /* aarch64_sme_single_smlsvnx4sivnx64qi */

    case 11:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13796; /* aarch64_sme_single_smlsvnx4sivnx16hi */

    case 12:
      if (!
#line 1492 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13800; /* aarch64_sme_single_smlsvnx4sivnx32hi */

    case 13:
      if (!
#line 1620 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13892; /* aarch64_sme_single_smlsvnx2divnx16hi */

    case 14:
      if (!
#line 1620 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13896; /* aarch64_sme_single_smlsvnx2divnx32hi */

    case 15:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13820; /* aarch64_sme_lane_smlsvnx4sivnx16qi */

    case 16:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13824; /* aarch64_sme_lane_smlsvnx4sivnx32qi */

    case 17:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13828; /* aarch64_sme_lane_smlsvnx4sivnx64qi */

    case 18:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13832; /* aarch64_sme_lane_smlsvnx4sivnx8hi */

    case 19:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13836; /* aarch64_sme_lane_smlsvnx4sivnx16hi */

    case 20:
      if (!
#line 1526 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13840; /* aarch64_sme_lane_smlsvnx4sivnx32hi */

    case 21:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13908; /* aarch64_sme_lane_smlsvnx2divnx8hi */

    case 22:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13912; /* aarch64_sme_lane_smlsvnx2divnx16hi */

    case 23:
      if (!
#line 1654 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13916; /* aarch64_sme_lane_smlsvnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1445 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13748; /* *aarch64_sme_smlsvnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1445 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13752; /* *aarch64_sme_smlsvnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1322 ())
            {
            case 0:
              if (
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13772; /* *aarch64_sme_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13776; /* *aarch64_sme_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1323 ())
        {
        case 0:
          if (!
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13780; /* *aarch64_sme_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1475 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13784; /* *aarch64_sme_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1573 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 13872; /* *aarch64_sme_smlsvnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1323 ())
        {
        case 0:
          if (!
#line 1603 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13884; /* *aarch64_sme_smlsvnx2divnx16hi_plus */

        case 1:
          if (!
#line 1603 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13888; /* *aarch64_sme_smlsvnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1324 (x3))
            {
            case 0:
              if (
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13804; /* *aarch64_sme_single_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13808; /* *aarch64_sme_single_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern255 (x3))
        {
        case 0:
          if (!
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13812; /* *aarch64_sme_single_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1507 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13816; /* *aarch64_sme_single_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1635 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13900; /* *aarch64_sme_single_smlsvnx2divnx16hi_plus */

    case 28:
      if (!
#line 1635 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13904; /* *aarch64_sme_single_smlsvnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13844; /* *aarch64_sme_lane_smlsvnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1364 (x3))
                {
                case 0:
                  if (
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13848; /* *aarch64_sme_lane_smlsvnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13852; /* *aarch64_sme_lane_smlsvnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 13856; /* *aarch64_sme_lane_smlsvnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1365 (x3))
        {
        case 0:
          if (!
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13860; /* *aarch64_sme_lane_smlsvnx4sivnx16hi */

        case 1:
          if (!
#line 1543 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13864; /* *aarch64_sme_lane_smlsvnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 13920; /* *aarch64_sme_lane_smlsvnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1365 (x3))
        {
        case 0:
          if (!
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13924; /* *aarch64_sme_lane_smlsvnx2divnx16hi */

        case 1:
          if (!
#line 1671 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13928; /* *aarch64_sme_lane_smlsvnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_439 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern239 (x1))
    {
    case 0:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13337; /* aarch64_sme_write_horvnx32qivnx32qi */

    case 1:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13339; /* aarch64_sme_write_horvnx16hivnx16hi */

    case 2:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13341; /* aarch64_sme_write_horvnx8sivnx8si */

    case 3:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13343; /* aarch64_sme_write_horvnx4divnx4di */

    case 4:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13345; /* aarch64_sme_write_horvnx16bfvnx16bf */

    case 5:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13347; /* aarch64_sme_write_horvnx16hfvnx16hf */

    case 6:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13349; /* aarch64_sme_write_horvnx8sfvnx8sf */

    case 7:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13351; /* aarch64_sme_write_horvnx4dfvnx4df */

    case 8:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13353; /* aarch64_sme_write_horvnx64qivnx64qi */

    case 9:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13355; /* aarch64_sme_write_horvnx32hivnx32hi */

    case 10:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13357; /* aarch64_sme_write_horvnx16sivnx16si */

    case 11:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13359; /* aarch64_sme_write_horvnx8divnx8di */

    case 12:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13361; /* aarch64_sme_write_horvnx32bfvnx32bf */

    case 13:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13363; /* aarch64_sme_write_horvnx32hfvnx32hf */

    case 14:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13365; /* aarch64_sme_write_horvnx16sfvnx16sf */

    case 15:
      if (!
#line 981 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13367; /* aarch64_sme_write_horvnx8dfvnx8df */

    case 16:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13369; /* *aarch64_sme_write_horvnx32qivnx32qi_plus */

    case 17:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13371; /* *aarch64_sme_write_horvnx16hivnx16hi_plus */

    case 18:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13373; /* *aarch64_sme_write_horvnx8sivnx8si_plus */

    case 19:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13375; /* *aarch64_sme_write_horvnx4divnx4di_plus */

    case 20:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13377; /* *aarch64_sme_write_horvnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13379; /* *aarch64_sme_write_horvnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13381; /* *aarch64_sme_write_horvnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13383; /* *aarch64_sme_write_horvnx4dfvnx4df_plus */

    case 24:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13385; /* *aarch64_sme_write_horvnx64qivnx64qi_plus */

    case 25:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13387; /* *aarch64_sme_write_horvnx32hivnx32hi_plus */

    case 26:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13389; /* *aarch64_sme_write_horvnx16sivnx16si_plus */

    case 27:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13391; /* *aarch64_sme_write_horvnx8divnx8di_plus */

    case 28:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13393; /* *aarch64_sme_write_horvnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13395; /* *aarch64_sme_write_horvnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13397; /* *aarch64_sme_write_horvnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 999 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13399; /* *aarch64_sme_write_horvnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_446 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 282:
      if (pattern206 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5208; /* aarch64_sm3tt1aqv4si */

    case 283:
      if (pattern206 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5209; /* aarch64_sm3tt1bqv4si */

    case 284:
      if (pattern206 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5210; /* aarch64_sm3tt2aqv4si */

    case 285:
      if (pattern206 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5211; /* aarch64_sm3tt2bqv4si */

    case 591:
      return recog_400 (x1, insn, pnum_clobbers);

    case 194:
      return recog_420 (x1, insn, pnum_clobbers);

    case 459:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 10181 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5347; /* aarch64_fmlalbv8hf */

        case 1:
          if (!
#line 2091 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12074; /* aarch64_sve_add_fmlalbvnx8hf */

        case 2:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5349; /* aarch64_fmlalb_lanev8hfv8qi */

        case 3:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5351; /* aarch64_fmlalb_lanev8hfv16qi */

        default:
          return -1;
        }

    case 465:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 10181 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5348; /* aarch64_fmlaltv8hf */

        case 1:
          if (!
#line 2091 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12075; /* aarch64_sve_add_fmlaltvnx8hf */

        case 2:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5350; /* aarch64_fmlalt_lanev8hfv8qi */

        case 3:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5352; /* aarch64_fmlalt_lanev8hfv16qi */

        default:
          return -1;
        }

    case 460:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5353; /* aarch64_fmlallbbv4sf */

        case 1:
          if (!
#line 2106 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12076; /* aarch64_sve_add_fmlallbbvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5357; /* aarch64_fmlallbb_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5361; /* aarch64_fmlallbb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 461:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5354; /* aarch64_fmlallbtv4sf */

        case 1:
          if (!
#line 2106 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12077; /* aarch64_sve_add_fmlallbtvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5358; /* aarch64_fmlallbt_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5362; /* aarch64_fmlallbt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 462:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5355; /* aarch64_fmlalltbv4sf */

        case 1:
          if (!
#line 2106 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12078; /* aarch64_sve_add_fmlalltbvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5359; /* aarch64_fmlalltb_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5363; /* aarch64_fmlalltb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 463:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5356; /* aarch64_fmlallttv4sf */

        case 1:
          if (!
#line 2106 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12079; /* aarch64_sve_add_fmlallttvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5360; /* aarch64_fmlalltt_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5364; /* aarch64_fmlalltt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 127:
      return recog_398 (x1, insn, pnum_clobbers);

    case 391:
      return recog_414 (x1, insn, pnum_clobbers);

    case 353:
      switch (pattern211 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3392 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8517; /* aarch64_pred_famaxvnx8hf */

        case 1:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3392 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8521; /* aarch64_pred_famaxvnx4sf */

        case 2:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3392 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8525; /* aarch64_pred_famaxvnx2df */

        default:
          return -1;
        }

    case 354:
      switch (pattern211 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3393 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8518; /* aarch64_pred_faminvnx8hf */

        case 1:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3393 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8522; /* aarch64_pred_faminvnx4sf */

        case 2:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3393 "../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8526; /* aarch64_pred_faminvnx2df */

        default:
          return -1;
        }

    case 371:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8519; /* aarch64_pred_divvnx8hf */

        case 1:
          if (!
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8523; /* aarch64_pred_divvnx4sf */

        case 2:
          if (!
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8527; /* aarch64_pred_divvnx2df */

        default:
          return -1;
        }

    case 379:
      return recog_424 (x1, insn, pnum_clobbers);

    case 352:
      return recog_422 (x1, insn, pnum_clobbers);

    case 355:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8940; /* aarch64_pred_cadd90vnx8hf */

        case 1:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8942; /* aarch64_pred_cadd90vnx4sf */

        case 2:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8944; /* aarch64_pred_cadd90vnx2df */

        default:
          return -1;
        }

    case 356:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8941; /* aarch64_pred_cadd270vnx8hf */

        case 1:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8943; /* aarch64_pred_cadd270vnx4sf */

        case 2:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8945; /* aarch64_pred_cadd270vnx2df */

        default:
          return -1;
        }

    case 393:
      return recog_423 (x1, insn, pnum_clobbers);

    case 378:
      return recog_421 (x1, insn, pnum_clobbers);

    case 372:
      switch (pattern214 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9043; /* aarch64_pred_fmax_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9049; /* aarch64_pred_fmax_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9055; /* aarch64_pred_fmax_nanvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11850; /* aarch64_pred_fmax_nanvnx8bf */

        default:
          return -1;
        }

    case 373:
      switch (pattern214 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9044; /* aarch64_pred_fmaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9050; /* aarch64_pred_fmaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9056; /* aarch64_pred_fmaxvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11851; /* aarch64_pred_fmaxvnx8bf */

        default:
          return -1;
        }

    case 374:
      switch (pattern214 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9045; /* aarch64_pred_fmin_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9051; /* aarch64_pred_fmin_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9057; /* aarch64_pred_fmin_nanvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11852; /* aarch64_pred_fmin_nanvnx8bf */

        default:
          return -1;
        }

    case 375:
      return recog_413 (x1, insn, pnum_clobbers);

    case 395:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9047; /* aarch64_pred_smaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9053; /* aarch64_pred_smaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9059; /* aarch64_pred_smaxvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11857; /* aarch64_pred_smaxvnx8bf */

        case 4:
          if (!
#line 2953 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12543; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2953 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12545; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2953 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12547; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 396:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9048; /* aarch64_pred_sminvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9054; /* aarch64_pred_sminvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9060; /* aarch64_pred_sminvnx2df */

        case 3:
          if (!
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11858; /* aarch64_pred_sminvnx8bf */

        case 4:
          if (!
#line 2953 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12544; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2953 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12546; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2953 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12548; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 579:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern236 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3285 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9436; /* aarch64_sve_bfdot_lanevnx4sf */

    case 580:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern236 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3286 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9437; /* aarch64_sve_bfmlalb_lanevnx4sf */

    case 581:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern236 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3287 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9438; /* aarch64_sve_bfmlalt_lanevnx4sf */

    case 582:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern236 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3288 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9439; /* aarch64_sve_bfmlslb_lanevnx4sf */

    case 583:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern236 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3289 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9440; /* aarch64_sve_bfmlslt_lanevnx4sf */

    case 357:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10211; /* aarch64_pred_fcmeqvnx8hf */

        case 1:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10217; /* aarch64_pred_fcmeqvnx4sf */

        case 2:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10223; /* aarch64_pred_fcmeqvnx2df */

        default:
          return -1;
        }

    case 358:
      return recog_419 (x1, insn, pnum_clobbers);

    case 359:
      return recog_418 (x1, insn, pnum_clobbers);

    case 364:
      return recog_417 (x1, insn, pnum_clobbers);

    case 365:
      return recog_416 (x1, insn, pnum_clobbers);

    case 366:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10216; /* aarch64_pred_fcmnevnx8hf */

        case 1:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10222; /* aarch64_pred_fcmnevnx4sf */

        case 2:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10228; /* aarch64_pred_fcmnevnx2df */

        default:
          return -1;
        }

    case 367:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern950 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 8528 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10229; /* aarch64_pred_fcmuovnx8hf */

        case E_VNx4BImode:
          if (pattern950 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 8528 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10230; /* aarch64_pred_fcmuovnx4sf */

        case E_VNx2BImode:
          if (pattern950 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 8528 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10231; /* aarch64_pred_fcmuovnx2df */

        default:
          return -1;
        }

    case 439:
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern880 (x2, 
E_VNx4SFmode, 
E_VNx8BFmode, 
E_VNx4BImode) != 0
              || !
#line 9901 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
            return -1;
          return 10972; /* aarch64_sve_cvtntvnx8bf */

        case E_VNx8HFmode:
          if (pattern880 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
              || !
#line 3233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12643; /* aarch64_sve_cvtntvnx8hf */

        case E_VNx4SFmode:
          if (pattern880 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
              || !
#line 3233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12644; /* aarch64_sve_cvtntvnx4sf */

        default:
          return -1;
        }

    case 120:
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 348 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11254; /* aarch64_gather_ld1q */

    case 122:
      return recog_415 (x1, insn, pnum_clobbers);

    case 541:
      return recog_412 (x1, insn, pnum_clobbers);

    case 542:
      return recog_411 (x1, insn, pnum_clobbers);

    case 622:
      if (pattern225 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!aarch64_reg_or_zero (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11407; /* aarch64_scatter_st1q */

    case 124:
      return recog_403 (x1, insn, pnum_clobbers);

    case 481:
      return recog_407 (x1, insn, pnum_clobbers);

    case 443:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 84
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_VNx16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx16QImode))
        return -1;
      switch (pattern1066 (x2))
        {
        case 0:
          if (!
#line 2162 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx8HFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12086; /* aarch64_sve_dotvnx8hf */

        case 1:
          if (!
#line 2162 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx4SFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12087; /* aarch64_sve_dotvnx4sf */

        default:
          return -1;
        }

    case 441:
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VNx4SFmode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DFmode)
          || !
#line 3323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12648; /* aarch64_sve2_cvtxntvnx2df */

    case 136:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12707; /* aarch64_sve_whilege_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12715; /* aarch64_sve_whilege_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12723; /* aarch64_sve_whilege_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12731; /* aarch64_sve_whilege_b64_x2 */

        default:
          return -1;
        }

    case 137:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12708; /* aarch64_sve_whilegt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12716; /* aarch64_sve_whilegt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12724; /* aarch64_sve_whilegt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12732; /* aarch64_sve_whilegt_b64_x2 */

        default:
          return -1;
        }

    case 138:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12709; /* aarch64_sve_whileugt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12717; /* aarch64_sve_whileugt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12725; /* aarch64_sve_whileugt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12733; /* aarch64_sve_whileugt_b64_x2 */

        default:
          return -1;
        }

    case 139:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12710; /* aarch64_sve_whileuge_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12718; /* aarch64_sve_whileuge_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12726; /* aarch64_sve_whileuge_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12734; /* aarch64_sve_whileuge_b64_x2 */

        default:
          return -1;
        }

    case 140:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12711; /* aarch64_sve_whilele_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12719; /* aarch64_sve_whilele_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12727; /* aarch64_sve_whilele_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12735; /* aarch64_sve_whilele_b64_x2 */

        default:
          return -1;
        }

    case 141:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12712; /* aarch64_sve_whileult_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12720; /* aarch64_sve_whileult_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12728; /* aarch64_sve_whileult_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12736; /* aarch64_sve_whileult_b64_x2 */

        default:
          return -1;
        }

    case 142:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12713; /* aarch64_sve_whileule_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12721; /* aarch64_sve_whileule_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12729; /* aarch64_sve_whileule_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12737; /* aarch64_sve_whileule_b64_x2 */

        default:
          return -1;
        }

    case 143:
      switch (pattern226 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12714; /* aarch64_sve_whilelt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12722; /* aarch64_sve_whilelt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12730; /* aarch64_sve_whilelt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12738; /* aarch64_sve_whilelt_b64_x2 */

        default:
          return -1;
        }

    case 632:
      return recog_406 (x1, insn, pnum_clobbers);

    case 699:
      return recog_405 (x1, insn, pnum_clobbers);

    case 701:
      return recog_404 (x1, insn, pnum_clobbers);

    case 650:
      return recog_402 (x1, insn, pnum_clobbers);

    case 651:
      return recog_401 (x1, insn, pnum_clobbers);

    case 679:
      return recog_408 (x1, insn, pnum_clobbers);

    case 703:
      return recog_399 (x1, insn, pnum_clobbers);

    case 633:
      return recog_426 (x1, insn, pnum_clobbers);

    case 663:
      return recog_425 (x1, insn, pnum_clobbers);

    case 639:
      return recog_410 (x1, insn, pnum_clobbers);

    case 646:
      return recog_409 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern621 (x2, 
E_SImode))
                {
                case 0:
                  return 216; /* *add_zero_extendqi_si */

                case 1:
                  return 220; /* *add_zero_extendhi_si */

                case 2:
                  return 224; /* *add_zero_extendsi_si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern621 (x2, 
E_DImode))
                {
                case 0:
                  return 218; /* *add_zero_extendqi_di */

                case 1:
                  return 222; /* *add_zero_extendhi_di */

                case 2:
                  return 226; /* *add_zero_extendsi_di */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern622 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4703 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3065; /* aarch64_uaddwv8qi */

            case E_V4SImode:
              if (pattern622 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4703 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3067; /* aarch64_uaddwv4hi */

            case E_V2DImode:
              if (pattern622 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4703 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3069; /* aarch64_uaddwv2si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern298 (x2))
            {
            case 0:
              if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3036; /* aarch64_uaddlv8qi */

            case 1:
              if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3040; /* aarch64_uaddlv4hi */

            case 2:
              if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3044; /* aarch64_uaddlv2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SMAX:
          switch (pattern628 (x2, 
SMIN))
            {
            case 0:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1689; /* aarch64_sabalv8qi */

            case 1:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1691; /* aarch64_sabalv4hi */

            case 2:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1693; /* aarch64_sabalv2si */

            case 3:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1695; /* aarch64_sabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1697; /* aarch64_sabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1699; /* aarch64_sabal2v4si_insn */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern628 (x2, 
UMIN))
            {
            case 0:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1690; /* aarch64_uabalv8qi */

            case 1:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1692; /* aarch64_uabalv4hi */

            case 2:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1694; /* aarch64_uabalv2si */

            case 3:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1696; /* aarch64_uabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1698; /* aarch64_uabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1700; /* aarch64_uabal2v4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern623 (x2))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3012; /* aarch64_uaddlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3024; /* aarch64_uaddlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3016; /* aarch64_uaddlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3028; /* aarch64_uaddlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3020; /* aarch64_uaddlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3032; /* aarch64_uaddlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern625 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3071; /* aarch64_uaddwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3077; /* aarch64_uaddw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3073; /* aarch64_uaddwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3079; /* aarch64_uaddw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3075; /* aarch64_uaddwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3081; /* aarch64_uaddw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern393 (x2, 
E_DImode) != 0)
        return -1;
      switch (pattern334 (x2))
        {
        case 0:
          if (!
#line 10381 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11030; /* aarch64_sve_incdi_pat */

        case 1:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11064; /* *aarch64_sve_incdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11067; /* *aarch64_sve_incdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11070; /* *aarch64_sve_incdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11073; /* *aarch64_sve_incdivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_473 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      switch (pattern414 (x3))
        {
        case 0:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8200; /* *bicvnx16qi3 */

        case 1:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8201; /* *bicvnx8qi3 */

        case 2:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8202; /* *bicvnx4qi3 */

        case 3:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8203; /* *bicvnx2qi3 */

        case 4:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8204; /* *bicvnx8hi3 */

        case 5:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8205; /* *bicvnx4hi3 */

        case 6:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8206; /* *bicvnx2hi3 */

        case 7:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8207; /* *bicvnx4si3 */

        case 8:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8208; /* *bicvnx2si3 */

        case 9:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8209; /* *bicvnx2di3 */

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL
          || XINT (x4, 1) != 126)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x8))
        {
        case LT:
          switch (pattern960 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9781; /* *cmpltvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9791; /* *cmpltvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9821; /* *cmpltvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9801; /* *cmpltvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9831; /* *cmpltvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9851; /* *cmpltvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9811; /* *cmpltvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9841; /* *cmpltvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9861; /* *cmpltvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9871; /* *cmpltvnx2di_and */

            default:
              return -1;
            }

        case LE:
          switch (pattern960 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9782; /* *cmplevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9792; /* *cmplevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9822; /* *cmplevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9802; /* *cmplevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9832; /* *cmplevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9852; /* *cmplevnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9812; /* *cmplevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9842; /* *cmplevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9862; /* *cmplevnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9872; /* *cmplevnx2di_and */

            default:
              return -1;
            }

        case EQ:
          switch (pattern960 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9783; /* *cmpeqvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9793; /* *cmpeqvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9823; /* *cmpeqvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9803; /* *cmpeqvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9833; /* *cmpeqvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9853; /* *cmpeqvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9813; /* *cmpeqvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9843; /* *cmpeqvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9863; /* *cmpeqvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9873; /* *cmpeqvnx2di_and */

            default:
              return -1;
            }

        case NE:
          switch (pattern960 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9784; /* *cmpnevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9794; /* *cmpnevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9824; /* *cmpnevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9804; /* *cmpnevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9834; /* *cmpnevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9854; /* *cmpnevnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9814; /* *cmpnevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9844; /* *cmpnevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9864; /* *cmpnevnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9874; /* *cmpnevnx2di_and */

            default:
              return -1;
            }

        case GE:
          switch (pattern960 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9785; /* *cmpgevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9795; /* *cmpgevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9825; /* *cmpgevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9805; /* *cmpgevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9835; /* *cmpgevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9855; /* *cmpgevnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9815; /* *cmpgevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9845; /* *cmpgevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9865; /* *cmpgevnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9875; /* *cmpgevnx2di_and */

            default:
              return -1;
            }

        case GT:
          switch (pattern960 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9786; /* *cmpgtvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9796; /* *cmpgtvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9826; /* *cmpgtvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9806; /* *cmpgtvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9836; /* *cmpgtvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9856; /* *cmpgtvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9816; /* *cmpgtvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9846; /* *cmpgtvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9866; /* *cmpgtvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9876; /* *cmpgtvnx2di_and */

            default:
              return -1;
            }

        case LTU:
          switch (pattern961 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9787; /* *cmplovnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9797; /* *cmplovnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9827; /* *cmplovnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9807; /* *cmplovnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9837; /* *cmplovnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9857; /* *cmplovnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9817; /* *cmplovnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9847; /* *cmplovnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9867; /* *cmplovnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9877; /* *cmplovnx2di_and */

            default:
              return -1;
            }

        case LEU:
          switch (pattern961 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9788; /* *cmplsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9798; /* *cmplsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9828; /* *cmplsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9808; /* *cmplsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9838; /* *cmplsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9858; /* *cmplsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9818; /* *cmplsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9848; /* *cmplsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9868; /* *cmplsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9878; /* *cmplsvnx2di_and */

            default:
              return -1;
            }

        case GEU:
          switch (pattern961 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9789; /* *cmphsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9799; /* *cmphsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9829; /* *cmphsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9809; /* *cmphsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9839; /* *cmphsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9859; /* *cmphsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9819; /* *cmphsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9849; /* *cmphsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9869; /* *cmphsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9879; /* *cmphsvnx2di_and */

            default:
              return -1;
            }

        case GTU:
          switch (pattern961 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9790; /* *cmphivnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9800; /* *cmphivnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9830; /* *cmphivnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9810; /* *cmphivnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9840; /* *cmphivnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9860; /* *cmphivnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9820; /* *cmphivnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9850; /* *cmphivnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9870; /* *cmphivnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9880; /* *cmphivnx2di_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      switch (pattern417 (x3))
        {
        case 0:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10232; /* *fcmeqvnx8hf_and_combine */

        case 1:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10238; /* *fcmeqvnx4sf_and_combine */

        case 2:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10244; /* *fcmeqvnx2df_and_combine */

        case 3:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10233; /* *fcmgevnx8hf_and_combine */

        case 4:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10239; /* *fcmgevnx4sf_and_combine */

        case 5:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10245; /* *fcmgevnx2df_and_combine */

        case 6:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10234; /* *fcmgtvnx8hf_and_combine */

        case 7:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10240; /* *fcmgtvnx4sf_and_combine */

        case 8:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10246; /* *fcmgtvnx2df_and_combine */

        case 9:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10235; /* *fcmlevnx8hf_and_combine */

        case 10:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10241; /* *fcmlevnx4sf_and_combine */

        case 11:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10247; /* *fcmlevnx2df_and_combine */

        case 12:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10236; /* *fcmltvnx8hf_and_combine */

        case 13:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10242; /* *fcmltvnx4sf_and_combine */

        case 14:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10248; /* *fcmltvnx2df_and_combine */

        case 15:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10237; /* *fcmnevnx8hf_and_combine */

        case 16:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10243; /* *fcmnevnx4sf_and_combine */

        case 17:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10249; /* *fcmnevnx2df_and_combine */

        case 18:
          if (!
#line 8573 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10250; /* *fcmuovnx8hf_and_combine */

        case 19:
          if (!
#line 8573 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10251; /* *fcmuovnx4sf_and_combine */

        case 20:
          if (!
#line 8573 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10252; /* *fcmuovnx2df_and_combine */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern534 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1601; /* negv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1605; /* negv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1609; /* negv2si2_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2398; /* negv4hf2_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2402; /* negv2sf2_vec_concatz_be */

        default:
          return -1;
        }

    case LT:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4078; /* aarch64_cmltv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4098; /* aarch64_cmltv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4243; /* aarch64_cmltv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4118; /* aarch64_cmltv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4263; /* aarch64_cmltv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4298; /* aarch64_cmltdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4313; /* aarch64_facltv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4329; /* aarch64_facltv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4357; /* aarch64_facltdf_vec_concatz_be */

        default:
          return -1;
        }

    case LE:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4081; /* aarch64_cmlev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4101; /* aarch64_cmlev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4246; /* aarch64_cmlev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4121; /* aarch64_cmlev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4266; /* aarch64_cmlev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4301; /* aarch64_cmledf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4316; /* aarch64_faclev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4332; /* aarch64_faclev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4360; /* aarch64_facledf_vec_concatz_be */

        default:
          return -1;
        }

    case EQ:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      switch (pattern535 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4084; /* aarch64_cmeqv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4104; /* aarch64_cmeqv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4249; /* aarch64_cmeqv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4124; /* aarch64_cmeqv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4269; /* aarch64_cmeqv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4304; /* aarch64_cmeqdf_vec_concatz_be */

        default:
          return -1;
        }

    case GE:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4087; /* aarch64_cmgev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4107; /* aarch64_cmgev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4252; /* aarch64_cmgev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4127; /* aarch64_cmgev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4272; /* aarch64_cmgev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4307; /* aarch64_cmgedf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4319; /* aarch64_facgev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4335; /* aarch64_facgev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4363; /* aarch64_facgedf_vec_concatz_be */

        default:
          return -1;
        }

    case GT:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4090; /* aarch64_cmgtv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4110; /* aarch64_cmgtv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4255; /* aarch64_cmgtv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4130; /* aarch64_cmgtv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4275; /* aarch64_cmgtv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4310; /* aarch64_cmgtdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4322; /* aarch64_facgtv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4338; /* aarch64_facgtv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4366; /* aarch64_facgtdf_vec_concatz_be */

        default:
          return -1;
        }

    case LTU:
      switch (pattern539 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4153; /* aarch64_cmltuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4169; /* aarch64_cmltuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4185; /* aarch64_cmltuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case LEU:
      switch (pattern539 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4156; /* aarch64_cmleuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4172; /* aarch64_cmleuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4188; /* aarch64_cmleuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GEU:
      switch (pattern539 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4159; /* aarch64_cmgeuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4175; /* aarch64_cmgeuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4191; /* aarch64_cmgeuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GTU:
      switch (pattern539 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4162; /* aarch64_cmgtuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4178; /* aarch64_cmgtuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4194; /* aarch64_cmgtuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case NE:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != AND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7399 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 4240; /* *aarch64_cmtstdi_vec_concatz_be */

    default:
      return -1;
    }
}

 int
recog_499 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern679 (x2))
            {
            case 0:
              if (!
#line 1829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2204; /* aarch64_xtn2v8hi_insn_le */

            case 1:
              if (!
#line 1829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2205; /* aarch64_xtn2v4si_insn_le */

            case 2:
              if (!
#line 1829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2206; /* aarch64_xtn2v2di_insn_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              x7 = XEXP (x6, 0);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  switch (pattern775 (x2))
                    {
                    case 0:
                      if (!
#line 4911 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3190; /* aarch64_addhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4911 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3192; /* aarch64_addhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4911 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3194; /* aarch64_addhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern837 (x2))
                    {
                    case 0:
                      if (!
#line 4927 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3196; /* aarch64_raddhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4927 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3198; /* aarch64_raddhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4927 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3200; /* aarch64_raddhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                case MINUS:
                  switch (pattern837 (x2))
                    {
                    case 0:
                      if (!
#line 4927 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3197; /* aarch64_rsubhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4927 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3199; /* aarch64_rsubhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4927 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3201; /* aarch64_rsubhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern775 (x2))
                {
                case 0:
                  if (!
#line 4911 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3191; /* aarch64_subhn2v8hi_insn_le */

                case 1:
                  if (!
#line 4911 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3193; /* aarch64_subhn2v4si_insn_le */

                case 2:
                  if (!
#line 4911 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3195; /* aarch64_subhn2v2di_insn_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern682 (x2))
                {
                case 0:
                  if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4014; /* aarch64_sshrn2_nv8hi_insn_le */

                case 1:
                  if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4020; /* aarch64_sshrn2_nv4si_insn_le */

                case 2:
                  if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4026; /* aarch64_sshrn2_nv2di_insn_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SMIN:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != SMAX)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x8 = XEXP (x6, 1);
              operands[3] = x8;
              x9 = XEXP (x5, 1);
              operands[4] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1088 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !
#line 5497 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3396; /* aarch64_sqxtun2v8hi_le */

                case E_V8HImode:
                  if (pattern1088 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !
#line 5497 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3397; /* aarch64_sqxtun2v4si_le */

                case E_V4SImode:
                  if (pattern1088 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !
#line 5497 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3398; /* aarch64_sqxtun2v2di_le */

                default:
                  return -1;
                }

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              operands[3] = x10;
              x11 = XEXP (x7, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  operands[2] = x11;
                  x8 = XEXP (x6, 1);
                  operands[4] = x8;
                  x9 = XEXP (x5, 1);
                  operands[5] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern1176 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V8HImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V8HImode)
                          || !
#line 7068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4064; /* aarch64_sqshrun2_nv8hi_insn_le */

                    case E_V8HImode:
                      if (pattern1176 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V4SImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V4SImode)
                          || !
#line 7068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4065; /* aarch64_sqshrun2_nv4si_insn_le */

                    case E_V4SImode:
                      if (pattern1176 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V2DImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V2DImode)
                          || !
#line 7068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4066; /* aarch64_sqshrun2_nv2di_insn_le */

                    default:
                      return -1;
                    }

                case PLUS:
                  x12 = XEXP (x11, 0);
                  if (GET_CODE (x12) != SIGN_EXTEND)
                    return -1;
                  x13 = XEXP (x12, 0);
                  operands[2] = x13;
                  x14 = XEXP (x11, 1);
                  operands[4] = x14;
                  x8 = XEXP (x6, 1);
                  operands[5] = x8;
                  x9 = XEXP (x5, 1);
                  operands[6] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern1238 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V8SImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V8SImode)
                          || !
#line 7130 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4070; /* aarch64_sqrshrun2_nv8hi_insn_le */

                    case E_V8HImode:
                      if (pattern1238 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V4DImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V4DImode)
                          || !
#line 7130 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4071; /* aarch64_sqrshrun2_nv4si_insn_le */

                    case E_V4SImode:
                      if (pattern1238 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V2TImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V2TImode)
                          || !
#line 7130 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4072; /* aarch64_sqrshrun2_nv2di_insn_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern681 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4015; /* aarch64_ushrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4021; /* aarch64_ushrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4027; /* aarch64_ushrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4048; /* aarch64_rshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4051; /* aarch64_rshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4054; /* aarch64_rshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 588
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V2SFmode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V2DFmode)
              || !
#line 3219 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2658; /* aarch64_float_trunc_rodd_hi_v4sf_le */

        case 3:
          if (XINT (x3, 1) != 188
              || GET_MODE (x3) != E_V8QImode)
            return -1;
          x16 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 84
              || GET_MODE (x16) != E_DImode
              || !register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_V8QImode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x17 = XVECEXP (x3, 0, 1);
          operands[3] = x17;
          if (!register_operand (operands[3], E_V4SFmode)
              || !
#line 10118 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8 && !BYTES_BIG_ENDIAN))
            return -1;
          return 5328; /* aarch64_fcvtnv4sf_high_le */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern678 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 3264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2666; /* aarch64_float_truncate_hi_v4sf_le */

        case E_V8HFmode:
          if (pattern678 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !
#line 3264 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2667; /* aarch64_float_truncate_hi_v8hf_le */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_494 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern776 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2990; /* *aarch64_combinezv8qi */

        case E_V8HImode:
          if (pattern776 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2991; /* *aarch64_combinezv4hi */

        case E_V8BFmode:
          if (pattern776 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2992; /* *aarch64_combinezv4bf */

        case E_V8HFmode:
          if (pattern776 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2993; /* *aarch64_combinezv4hf */

        case E_V4SImode:
          if (pattern776 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2994; /* *aarch64_combinezv2si */

        case E_V4SFmode:
          if (pattern776 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2995; /* *aarch64_combinezv2sf */

        case E_V2SImode:
          if (pattern776 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2996; /* *aarch64_combinezsi */

        case E_V2SFmode:
          if (pattern776 (x2, 
E_SFmode, 
E_V2SFmode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2997; /* *aarch64_combinezsf */

        case E_V2DImode:
          if (pattern776 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2998; /* *aarch64_combinezdi */

        case E_V2DFmode:
          if (pattern776 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4392 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2999; /* *aarch64_combinezdf */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern679 (x2))
            {
            case 0:
              if (!
#line 5411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3372; /* aarch64_sqxtn2v8hi_le */

            case 1:
              if (!
#line 5411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3374; /* aarch64_sqxtn2v4si_le */

            case 2:
              if (!
#line 5411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3376; /* aarch64_sqxtn2v2di_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern681 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4010; /* aarch64_sqsshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4016; /* aarch64_sqsshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4022; /* aarch64_sqsshrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4046; /* aarch64_sqrshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4049; /* aarch64_sqrshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4052; /* aarch64_sqrshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern682 (x2))
            {
            case 0:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4011; /* aarch64_squshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4017; /* aarch64_squshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4023; /* aarch64_squshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern679 (x2))
            {
            case 0:
              if (!
#line 5411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3373; /* aarch64_uqxtn2v8hi_le */

            case 1:
              if (!
#line 5411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3375; /* aarch64_uqxtn2v4si_le */

            case 2:
              if (!
#line 5411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3377; /* aarch64_uqxtn2v2di_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern682 (x2))
            {
            case 0:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4012; /* aarch64_uqsshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4018; /* aarch64_uqsshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4024; /* aarch64_uqsshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern681 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4013; /* aarch64_uqushrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4019; /* aarch64_uqushrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4025; /* aarch64_uqushrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4047; /* aarch64_uqrshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4050; /* aarch64_uqrshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6994 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4053; /* aarch64_uqrshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_508 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_472 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (!register_operand (x5, E_VNx16BImode))
        return -1;
      operands[1] = x5;
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 86
          && GET_MODE (x3) == E_VNx16BImode
          && 
#line 1162 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return 5732; /* aarch64_rdffr_z */
      operands[2] = x5;
      operands[1] = x3;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !
#line 6759 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9061; /* andvnx16bi3 */

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_CODE (operands[3]))
        {
        case REG:
        case SUBREG:
          switch (pattern51 (x2))
            {
            case 0:
              return 531; /* and_ashlsi3 */

            case 1:
              return 546; /* and_ashldi3 */

            default:
              return -1;
            }

        case CONST_INT:
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern940 (x2, 
E_SImode) != 0
                  || !
#line 6654 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (SImode, operands[3], operands[2])))
                return -1;
              return 879; /* *andim_ashiftsi_bfiz */

            case E_DImode:
              if (pattern940 (x2, 
E_DImode) != 0
                  || !
#line 6654 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (DImode, operands[3], operands[2])))
                return -1;
              return 880; /* *andim_ashiftdi_bfiz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern52 (x2))
        {
        case 0:
          return 534; /* and_ashrsi3 */

        case 1:
          return 549; /* and_ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[2] = x7;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern499 (x2))
        {
        case 0:
          return 537; /* and_lshrsi3 */

        case 1:
          return 552; /* and_lshrdi3 */

        default:
          break;
        }
      if (XWINT (x7, 0) != 56L)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 176
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[2] = x11;
      if (!aarch64_granule16_simm9 (operands[2], E_DImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode)
          || !
#line 8464 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1231; /* stg */

    case ROTATERT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern52 (x2))
        {
        case 0:
          return 540; /* and_rotrsi3 */

        case 1:
          return 555; /* and_rotrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern52 (x2))
        {
        case 0:
          return 543; /* and_rotlsi3 */

        case 1:
          return 558; /* and_rotldi3 */

        default:
          return -1;
        }

    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern720 (x2, 
E_SImode) != 0)
                return -1;
              return 589; /* andnsi3 */

            case E_DImode:
              if (pattern720 (x2, 
E_DImode) != 0)
                return -1;
              return 591; /* andndi3 */

            case E_V8QImode:
              if (pattern720 (x2, 
E_V8QImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1340; /* andnv8qi3 */

            case E_V16QImode:
              if (pattern720 (x2, 
E_V16QImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1343; /* andnv16qi3 */

            case E_V4HImode:
              if (pattern720 (x2, 
E_V4HImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1344; /* andnv4hi3 */

            case E_V8HImode:
              if (pattern720 (x2, 
E_V8HImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1347; /* andnv8hi3 */

            case E_V2SImode:
              if (pattern720 (x2, 
E_V2SImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1348; /* andnv2si3 */

            case E_V4SImode:
              if (pattern720 (x2, 
E_V4SImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1351; /* andnv4si3 */

            case E_V2DImode:
              if (pattern720 (x2, 
E_V2DImode) != 0
                  || !
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1352; /* andnv2di3 */

            case E_VNx16BImode:
              if (pattern720 (x2, 
E_VNx16BImode) != 0
                  || !
#line 3864 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7360; /* *one_cmplvnx16bi3 */

            case E_VNx8BImode:
              if (pattern720 (x2, 
E_VNx8BImode) != 0
                  || !
#line 3864 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7361; /* *one_cmplvnx8bi3 */

            case E_VNx4BImode:
              if (pattern720 (x2, 
E_VNx4BImode) != 0
                  || !
#line 3864 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7362; /* *one_cmplvnx4bi3 */

            case E_VNx2BImode:
              if (pattern720 (x2, 
E_VNx2BImode) != 0
                  || !
#line 3864 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7363; /* *one_cmplvnx2bi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern379 (x2))
            {
            case 0:
              return 603; /* and_one_cmpl_ashlsi3 */

            case 1:
              return 618; /* and_one_cmpl_ashldi3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern379 (x2))
            {
            case 0:
              return 606; /* and_one_cmpl_ashrsi3 */

            case 1:
              return 621; /* and_one_cmpl_ashrdi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern379 (x2))
            {
            case 0:
              return 609; /* and_one_cmpl_lshrsi3 */

            case 1:
              return 624; /* and_one_cmpl_lshrdi3 */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern379 (x2))
            {
            case 0:
              return 612; /* and_one_cmpl_rotrsi3 */

            case 1:
              return 627; /* and_one_cmpl_rotrdi3 */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern379 (x2))
            {
            case 0:
              return 615; /* and_one_cmpl_rotlsi3 */

            case 1:
              return 630; /* and_one_cmpl_rotldi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_473 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern309 (x2))
            {
            case 0:
              if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9065; /* aarch64_pred_andvnx16bi_z */

            case 1:
              if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9068; /* aarch64_pred_andvnx8bi_z */

            case 2:
              if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9071; /* aarch64_pred_andvnx4bi_z */

            case 3:
              if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9074; /* aarch64_pred_andvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (pattern525 (x2))
                {
                case 0:
                  if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9101; /* aarch64_pred_bicvnx16bi_z */

                case 1:
                  if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9103; /* aarch64_pred_bicvnx8bi_z */

                case 2:
                  if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9105; /* aarch64_pred_bicvnx4bi_z */

                case 3:
                  if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9107; /* aarch64_pred_bicvnx2bi_z */

                case 4:
                  if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9125; /* aarch64_pred_norvnx16bi_z */

                case 5:
                  if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9127; /* aarch64_pred_norvnx8bi_z */

                case 6:
                  if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9129; /* aarch64_pred_norvnx4bi_z */

                case 7:
                  if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9131; /* aarch64_pred_norvnx2bi_z */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pnum_clobbers == NULL
                  || XVECLEN (x12, 0) != 4)
                return -1;
              x13 = XVECEXP (x12, 0, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x14 = XVECEXP (x12, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x12, 0, 2);
              operands[2] = x15;
              x16 = XVECEXP (x12, 0, 3);
              operands[3] = x16;
              x5 = XEXP (x2, 1);
              if (!rtx_equal_p (x5, operands[1]))
                return -1;
              switch (XINT (x12, 1))
                {
                case 357:
                  switch (pattern1140 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10253; /* *fcmeqvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10259; /* *fcmeqvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10265; /* *fcmeqvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10271; /* *fcmeqvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10277; /* *fcmeqvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10283; /* *fcmeqvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 358:
                  switch (pattern1140 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10254; /* *fcmgevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10260; /* *fcmgevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10266; /* *fcmgevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10272; /* *fcmgevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10278; /* *fcmgevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10284; /* *fcmgevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 359:
                  switch (pattern1140 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10255; /* *fcmgtvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10261; /* *fcmgtvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10267; /* *fcmgtvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10273; /* *fcmgtvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10279; /* *fcmgtvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10285; /* *fcmgtvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 364:
                  switch (pattern1140 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10256; /* *fcmlevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10262; /* *fcmlevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10268; /* *fcmlevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10274; /* *fcmlevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10280; /* *fcmlevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10286; /* *fcmlevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 365:
                  switch (pattern1140 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10257; /* *fcmltvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10263; /* *fcmltvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10269; /* *fcmltvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10275; /* *fcmltvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10281; /* *fcmltvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10287; /* *fcmltvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 366:
                  switch (pattern1140 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10258; /* *fcmnevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10264; /* *fcmnevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10270; /* *fcmnevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10276; /* *fcmnevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10282; /* *fcmnevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10288; /* *fcmnevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 367:
                  x7 = XEXP (x3, 1);
                  switch (GET_CODE (x7))
                    {
                    case REG:
                    case SUBREG:
                      operands[4] = x7;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1231 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10289; /* *fcmuovnx8hf_bic_combine */

                        case E_VNx4BImode:
                          if (pattern1231 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10290; /* *fcmuovnx4sf_bic_combine */

                        case E_VNx2BImode:
                          if (pattern1231 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10291; /* *fcmuovnx2df_bic_combine */

                        default:
                          return -1;
                        }

                    case NOT:
                      x17 = XEXP (x7, 0);
                      operands[4] = x17;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1232 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10292; /* *fcmuovnx8hf_nor_combine */

                        case E_VNx4BImode:
                          if (pattern1232 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10293; /* *fcmuovnx4sf_nor_combine */

                        case E_VNx2BImode:
                          if (pattern1232 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8715 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10294; /* *fcmuovnx2df_nor_combine */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern308 (x2, 
E_VNx16BImode) != 0
                  || !
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9066; /* aarch64_pred_iorvnx16bi_z */

            case E_VNx8BImode:
              if (pattern308 (x2, 
E_VNx8BImode) != 0
                  || !
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9069; /* aarch64_pred_iorvnx8bi_z */

            case E_VNx4BImode:
              if (pattern308 (x2, 
E_VNx4BImode) != 0
                  || !
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9072; /* aarch64_pred_iorvnx4bi_z */

            case E_VNx2BImode:
              if (pattern308 (x2, 
E_VNx2BImode) != 0
                  || !
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9075; /* aarch64_pred_iorvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          switch (pattern525 (x2))
            {
            case 0:
              if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9102; /* aarch64_pred_ornvnx16bi_z */

            case 1:
              if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9104; /* aarch64_pred_ornvnx8bi_z */

            case 2:
              if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9106; /* aarch64_pred_ornvnx4bi_z */

            case 3:
              if (!
#line 6861 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9108; /* aarch64_pred_ornvnx2bi_z */

            case 4:
              if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9126; /* aarch64_pred_nandvnx16bi_z */

            case 5:
              if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9128; /* aarch64_pred_nandvnx8bi_z */

            case 6:
              if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9130; /* aarch64_pred_nandvnx4bi_z */

            case 7:
              if (!
#line 6935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9132; /* aarch64_pred_nandvnx2bi_z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern309 (x2))
        {
        case 0:
          if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9067; /* aarch64_pred_xorvnx16bi_z */

        case 1:
          if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9070; /* aarch64_pred_xorvnx8bi_z */

        case 2:
          if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9073; /* aarch64_pred_xorvnx4bi_z */

        case 3:
          if (!
#line 6789 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9076; /* aarch64_pred_xorvnx2bi_z */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_520 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern316 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern758 (x3, 
E_SImode) == 0
                  && 
#line 7392 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1083; /* *aarch64_sminsi3_cssc */
              break;

            case E_DImode:
              if (pattern758 (x3, 
E_DImode) == 0
                  && 
#line 7392 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1087; /* *aarch64_smindi3_cssc */
              break;

            case E_SFmode:
              if (pattern34 (x3, 
E_SFmode) == 0
                  && 
#line 7426 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1096; /* sminsf3 */
              break;

            case E_DFmode:
              if (pattern34 (x3, 
E_DFmode) == 0
                  && 
#line 7426 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1097; /* smindf3 */
              break;

            case E_V8QImode:
              if (pattern34 (x3, 
E_V8QImode) == 0
                  && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2075; /* sminv8qi3 */
              break;

            case E_V16QImode:
              if (pattern34 (x3, 
E_V16QImode) == 0
                  && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2085; /* sminv16qi3 */
              break;

            case E_V4HImode:
              if (pattern34 (x3, 
E_V4HImode) == 0
                  && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2091; /* sminv4hi3 */
              break;

            case E_V8HImode:
              if (pattern34 (x3, 
E_V8HImode) == 0
                  && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2101; /* sminv8hi3 */
              break;

            case E_V2SImode:
              if (pattern34 (x3, 
E_V2SImode) == 0
                  && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2107; /* sminv2si3 */
              break;

            case E_V4SImode:
              if (pattern34 (x3, 
E_V4SImode) == 0
                  && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2117; /* sminv4si3 */
              break;

            case E_V4HFmode:
              if (pattern34 (x3, 
E_V4HFmode) == 0
                  && (
#line 3348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2671; /* sminv4hf3 */
              break;

            case E_V8HFmode:
              if (pattern34 (x3, 
E_V8HFmode) == 0
                  && (
#line 3348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2673; /* sminv8hf3 */
              break;

            case E_V2SFmode:
              if (pattern34 (x3, 
E_V2SFmode) == 0
                  && 
#line 3348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2675; /* sminv2sf3 */
              break;

            case E_V4SFmode:
              if (pattern34 (x3, 
E_V4SFmode) == 0
                  && 
#line 3348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2677; /* sminv4sf3 */
              break;

            case E_V2DFmode:
              if (pattern34 (x3, 
E_V2DFmode) == 0
                  && 
#line 3348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2679; /* sminv2df3 */
              break;

            case E_VNx32QImode:
              if (pattern35 (x3, 
E_VNx32QImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11457; /* *sminvnx32qi3 */
              break;

            case E_VNx16HImode:
              if (pattern35 (x3, 
E_VNx16HImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11461; /* *sminvnx16hi3 */
              break;

            case E_VNx8SImode:
              if (pattern35 (x3, 
E_VNx8SImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11465; /* *sminvnx8si3 */
              break;

            case E_VNx4DImode:
              if (pattern35 (x3, 
E_VNx4DImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11469; /* *sminvnx4di3 */
              break;

            case E_VNx64QImode:
              if (pattern35 (x3, 
E_VNx64QImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11473; /* *sminvnx64qi3 */
              break;

            case E_VNx32HImode:
              if (pattern35 (x3, 
E_VNx32HImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11477; /* *sminvnx32hi3 */
              break;

            case E_VNx16SImode:
              if (pattern35 (x3, 
E_VNx16SImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11481; /* *sminvnx16si3 */
              break;

            case E_VNx8DImode:
              if (pattern35 (x3, 
E_VNx8DImode) == 0
                  && 
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11485; /* *sminvnx8di3 */
              break;

            default:
              break;
            }
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              return 1091; /* *aarch64_sminsi3_zero */

            case 1:
              return 1093; /* *aarch64_smindi3_zero */

            default:
              return -1;
            }

        case 1:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7421; /* *post_ra_sminvnx16qi3 */

        case 2:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7426; /* *post_ra_sminvnx8qi3 */

        case 3:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7431; /* *post_ra_sminvnx4qi3 */

        case 4:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7436; /* *post_ra_sminvnx2qi3 */

        case 5:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7441; /* *post_ra_sminvnx8hi3 */

        case 6:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7446; /* *post_ra_sminvnx4hi3 */

        case 7:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7451; /* *post_ra_sminvnx2hi3 */

        case 8:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7456; /* *post_ra_sminvnx4si3 */

        case 9:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7461; /* *post_ra_sminvnx2si3 */

        case 10:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7466; /* *post_ra_sminvnx2di3 */

        case 11:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7471; /* *post_ra_sminv2di3 */

        case 12:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11490; /* aarch64_sve_single_sminvnx32qi */

        case 13:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11495; /* aarch64_sve_single_sminvnx16hi */

        case 14:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11500; /* aarch64_sve_single_sminvnx8si */

        case 15:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11505; /* aarch64_sve_single_sminvnx4di */

        case 16:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11510; /* aarch64_sve_single_sminvnx64qi */

        case 17:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11515; /* aarch64_sve_single_sminvnx32hi */

        case 18:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11520; /* aarch64_sve_single_sminvnx16si */

        case 19:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11525; /* aarch64_sve_single_sminvnx8di */

        default:
          return -1;
        }

    case SMAX:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[1] = x9;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern965 (x3, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6814 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3995; /* aarch64_sqshrun_nhi_insn */

                case 65535L:
                  if (pattern965 (x3, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6814 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3996; /* aarch64_sqshrun_nsi_insn */

                case 4294967295L:
                  if (pattern965 (x3, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6814 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3997; /* aarch64_sqshrun_ndi_insn */

                default:
                  return -1;
                }

            case PLUS:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != SIGN_EXTEND)
                return -1;
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 1);
              operands[3] = x12;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern1076 (x3, 
E_SImode, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6885 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4007; /* aarch64_sqrshrun_nhi_insn */

                case 65535L:
                  if (pattern1076 (x3, 
E_DImode, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6885 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4008; /* aarch64_sqrshrun_nsi_insn */

                case 4294967295L:
                  if (!register_operand (operands[0], E_TImode)
                      || GET_MODE (x3) != E_TImode
                      || GET_MODE (x4) != E_TImode
                      || pattern1075 (x6, 
E_TImode, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6885 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4009; /* aarch64_sqrshrun_ndi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern320 (x3))
            {
            case 0:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11576; /* aarch64_sve_sclampvnx16qi */

            case 1:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11578; /* aarch64_sve_sclampvnx8hi */

            case 2:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11580; /* aarch64_sve_sclampvnx4si */

            case 3:
              if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11582; /* aarch64_sve_sclampvnx2di */

            case 4:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11592; /* aarch64_sve_sclamp_singlevnx32qi */

            case 5:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11594; /* aarch64_sve_sclamp_singlevnx16hi */

            case 6:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11596; /* aarch64_sve_sclamp_singlevnx8si */

            case 7:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11598; /* aarch64_sve_sclamp_singlevnx4di */

            case 8:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11600; /* aarch64_sve_sclamp_singlevnx64qi */

            case 9:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11602; /* aarch64_sve_sclamp_singlevnx32hi */

            case 10:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11604; /* aarch64_sve_sclamp_singlevnx16si */

            case 11:
              if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11606; /* aarch64_sve_sclamp_singlevnx8di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern317 (x3))
        {
        case 0:
          if (!(
#line 10043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5292; /* *aarch64_faminmax_fused */

        case 1:
          if (!(
#line 10043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5294; /* *aarch64_faminmax_fused */

        case 2:
          if (!
#line 10043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5296; /* *aarch64_faminmax_fused */

        case 3:
          if (!
#line 10043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5298; /* *aarch64_faminmax_fused */

        case 4:
          if (!
#line 10043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5300; /* *aarch64_faminmax_fused */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      operands[1] = x4;
      res = recog_474 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (!subreg_lowpart_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTRACT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!aarch64_simd_shift_imm_offset_si (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
          || !
#line 6682 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
        return -1;
      return 883; /* *ashiftsi_extvdi_bfiz */

    case SIGN_EXTEND:
      switch (pattern314 (x3))
        {
        case 0:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 867; /* *extendqi_shft_si */

        case 1:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 871; /* *extendhi_shft_si */

        case 2:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 875; /* *extendsi_shft_si */

        case 3:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 869; /* *extendqi_shft_di */

        case 4:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 873; /* *extendhi_shft_di */

        case 5:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 877; /* *extendsi_shft_di */

        case 6:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3782; /* aarch64_sshllv8qi */

        case 7:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3784; /* aarch64_sshllv4hi */

        case 8:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3786; /* aarch64_sshllv2si */

        case 9:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3788; /* aarch64_sshll2v16qi */

        case 10:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3790; /* aarch64_sshll2v8hi */

        case 11:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3792; /* aarch64_sshll2v4si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern314 (x3))
        {
        case 0:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 868; /* *zero_extendqi_shft_si */

        case 1:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 872; /* *zero_extendhi_shft_si */

        case 2:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 876; /* *zero_extendsi_shft_si */

        case 3:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 870; /* *zero_extendqi_shft_di */

        case 4:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 874; /* *zero_extendhi_shft_di */

        case 5:
          if (!
#line 6637 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 878; /* *zero_extendsi_shft_di */

        case 6:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3783; /* aarch64_ushllv8qi */

        case 7:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3785; /* aarch64_ushllv4hi */

        case 8:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3787; /* aarch64_ushllv2si */

        case 9:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3789; /* aarch64_ushll2v16qi */

        case 10:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3791; /* aarch64_ushll2v8hi */

        case 11:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3793; /* aarch64_ushll2v4si */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x10 = XEXP (x4, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern341 (x3, 
E_VOIDmode, 
E_SImode) != 0
              || !aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
              || !
#line 6667 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
            return -1;
          return 881; /* *ashiftsi_extv_bfiz */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_simd_shift_imm_offset_di (operands[2], E_VOIDmode)
              || !aarch64_simd_shift_imm_di (operands[3], E_VOIDmode)
              || !
#line 6667 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (DImode) - 1)))
            return -1;
          return 882; /* *ashiftdi_extv_bfiz */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_538 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern6 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
        case TRUNCATE:
          switch (pattern527 (x2))
            {
            case 0:
              if (
#line 5866 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0))
                return 719; /* *aarch64_ashr_reg_si3_mask1 */
              break;

            case 1:
              if (
#line 5866 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0))
                return 724; /* *aarch64_ashr_reg_di3_mask1 */
              break;

            case 2:
              if (
#line 5930 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 741; /* *aarch64_ashr_reg_di3_mask2 */
              break;

            case 3:
              if (
#line 5878 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)))
                return 729; /* *aarch64_ashr_reg_si3_neg_mask2 */
              break;

            case 4:
              if (
#line 5878 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 734; /* *aarch64_ashr_reg_di3_neg_mask2 */
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          switch (pattern528 (x2))
            {
            case 0:
              if (
#line 6194 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
                return 772; /* *ashrqi3_insn */
              break;

            case 1:
              if (
#line 6194 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
                return 775; /* *ashrhi3_insn */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!aarch64_reg_or_shift_imm_di (operands[2], E_QImode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          return 755; /* *aarch64_ashr_sisd_or_int_si3 */

        case 1:
          return 756; /* *aarch64_ashr_sisd_or_int_di3 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 5948 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)))
        return -1;
      return 746; /* *aarch64_ashr_reg_minussi3 */

    case 2:
      if (!
#line 5948 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)))
        return -1;
      return 749; /* *aarch64_ashr_reg_minusdi3 */

    case 3:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1880; /* aarch64_simd_ashrv8qi */

    case 4:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1883; /* aarch64_simd_ashrv16qi */

    case 5:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1884; /* aarch64_simd_ashrv4hi */

    case 6:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1887; /* aarch64_simd_ashrv8hi */

    case 7:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1888; /* aarch64_simd_ashrv2si */

    case 8:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1891; /* aarch64_simd_ashrv4si */

    case 9:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1892; /* aarch64_simd_ashrv2di */

    case 10:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8270; /* *post_ra_v_ashrvnx16qi3 */

    case 11:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8272; /* *post_ra_v_ashrvnx8qi3 */

    case 12:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8274; /* *post_ra_v_ashrvnx4qi3 */

    case 13:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8276; /* *post_ra_v_ashrvnx2qi3 */

    case 14:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8278; /* *post_ra_v_ashrvnx8hi3 */

    case 15:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8280; /* *post_ra_v_ashrvnx4hi3 */

    case 16:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8282; /* *post_ra_v_ashrvnx2hi3 */

    case 17:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8284; /* *post_ra_v_ashrvnx4si3 */

    case 18:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8286; /* *post_ra_v_ashrvnx2si3 */

    case 19:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8288; /* *post_ra_v_ashrvnx2di3 */

    default:
      return -1;
    }
}

 int
recog_563 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10198; /* while_ugesivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10208; /* while_ugedivnx2bi_ptest */
}

 int
recog_571 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10197; /* while_ugtsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10207; /* while_ugtdivnx2bi_ptest */
}

 int
recog_581 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10156; /* while_gtsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10166; /* while_gtdivnx8bi_ptest */
}

 int
recog_591 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10115; /* *while_gesivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10125; /* *while_gedivnx2bi_cc */
}

 int
recog_601 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern457 (x2, 
66, 
E_CC_NZCmode, 
CLOBBER) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  switch (GET_CODE (x7))
    {
    case LT:
      switch (pattern1182 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9481; /* aarch64_pred_cmpltvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9491; /* aarch64_pred_cmpltvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9521; /* aarch64_pred_cmpltvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9501; /* aarch64_pred_cmpltvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9531; /* aarch64_pred_cmpltvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9551; /* aarch64_pred_cmpltvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9511; /* aarch64_pred_cmpltvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9541; /* aarch64_pred_cmpltvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9561; /* aarch64_pred_cmpltvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9571; /* aarch64_pred_cmpltvnx2di */

        default:
          return -1;
        }

    case LE:
      switch (pattern1182 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9482; /* aarch64_pred_cmplevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9492; /* aarch64_pred_cmplevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9522; /* aarch64_pred_cmplevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9502; /* aarch64_pred_cmplevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9532; /* aarch64_pred_cmplevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9552; /* aarch64_pred_cmplevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9512; /* aarch64_pred_cmplevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9542; /* aarch64_pred_cmplevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9562; /* aarch64_pred_cmplevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9572; /* aarch64_pred_cmplevnx2di */

        default:
          return -1;
        }

    case EQ:
      switch (pattern1182 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9483; /* aarch64_pred_cmpeqvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9493; /* aarch64_pred_cmpeqvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9523; /* aarch64_pred_cmpeqvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9503; /* aarch64_pred_cmpeqvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9533; /* aarch64_pred_cmpeqvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9553; /* aarch64_pred_cmpeqvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9513; /* aarch64_pred_cmpeqvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9543; /* aarch64_pred_cmpeqvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9563; /* aarch64_pred_cmpeqvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9573; /* aarch64_pred_cmpeqvnx2di */

        default:
          return -1;
        }

    case NE:
      switch (pattern1182 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9484; /* aarch64_pred_cmpnevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9494; /* aarch64_pred_cmpnevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9524; /* aarch64_pred_cmpnevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9504; /* aarch64_pred_cmpnevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9534; /* aarch64_pred_cmpnevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9554; /* aarch64_pred_cmpnevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9514; /* aarch64_pred_cmpnevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9544; /* aarch64_pred_cmpnevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9564; /* aarch64_pred_cmpnevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9574; /* aarch64_pred_cmpnevnx2di */

        default:
          return -1;
        }

    case GE:
      switch (pattern1182 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9485; /* aarch64_pred_cmpgevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9495; /* aarch64_pred_cmpgevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9525; /* aarch64_pred_cmpgevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9505; /* aarch64_pred_cmpgevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9535; /* aarch64_pred_cmpgevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9555; /* aarch64_pred_cmpgevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9515; /* aarch64_pred_cmpgevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9545; /* aarch64_pred_cmpgevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9565; /* aarch64_pred_cmpgevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9575; /* aarch64_pred_cmpgevnx2di */

        default:
          return -1;
        }

    case GT:
      switch (pattern1182 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9486; /* aarch64_pred_cmpgtvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9496; /* aarch64_pred_cmpgtvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9526; /* aarch64_pred_cmpgtvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9506; /* aarch64_pred_cmpgtvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9536; /* aarch64_pred_cmpgtvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9556; /* aarch64_pred_cmpgtvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9516; /* aarch64_pred_cmpgtvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9546; /* aarch64_pred_cmpgtvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9566; /* aarch64_pred_cmpgtvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9576; /* aarch64_pred_cmpgtvnx2di */

        default:
          return -1;
        }

    case LTU:
      switch (pattern1183 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9487; /* aarch64_pred_cmplovnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9497; /* aarch64_pred_cmplovnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9527; /* aarch64_pred_cmplovnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9507; /* aarch64_pred_cmplovnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9537; /* aarch64_pred_cmplovnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9557; /* aarch64_pred_cmplovnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9517; /* aarch64_pred_cmplovnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9547; /* aarch64_pred_cmplovnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9567; /* aarch64_pred_cmplovnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9577; /* aarch64_pred_cmplovnx2di */

        default:
          return -1;
        }

    case LEU:
      switch (pattern1183 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9488; /* aarch64_pred_cmplsvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9498; /* aarch64_pred_cmplsvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9528; /* aarch64_pred_cmplsvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9508; /* aarch64_pred_cmplsvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9538; /* aarch64_pred_cmplsvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9558; /* aarch64_pred_cmplsvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9518; /* aarch64_pred_cmplsvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9548; /* aarch64_pred_cmplsvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9568; /* aarch64_pred_cmplsvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9578; /* aarch64_pred_cmplsvnx2di */

        default:
          return -1;
        }

    case GEU:
      switch (pattern1183 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9489; /* aarch64_pred_cmphsvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9499; /* aarch64_pred_cmphsvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9529; /* aarch64_pred_cmphsvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9509; /* aarch64_pred_cmphsvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9539; /* aarch64_pred_cmphsvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9559; /* aarch64_pred_cmphsvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9519; /* aarch64_pred_cmphsvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9549; /* aarch64_pred_cmphsvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9569; /* aarch64_pred_cmphsvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9579; /* aarch64_pred_cmphsvnx2di */

        default:
          return -1;
        }

    case GTU:
      switch (pattern1183 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9490; /* aarch64_pred_cmphivnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9500; /* aarch64_pred_cmphivnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9530; /* aarch64_pred_cmphivnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9510; /* aarch64_pred_cmphivnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9540; /* aarch64_pred_cmphivnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9560; /* aarch64_pred_cmphivnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9520; /* aarch64_pred_cmphivnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9550; /* aarch64_pred_cmphivnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9570; /* aarch64_pred_cmphivnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9580; /* aarch64_pred_cmphivnx2di */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x7, 0) != 2)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[4] = x9;
      switch (XINT (x7, 1))
        {
        case 341:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9881; /* aarch64_pred_cmpeqvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9891; /* aarch64_pred_cmpeqvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9901; /* aarch64_pred_cmpeqvnx4si_wide */

            default:
              return -1;
            }

        case 342:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9882; /* aarch64_pred_cmpgevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9892; /* aarch64_pred_cmpgevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9902; /* aarch64_pred_cmpgevnx4si_wide */

            default:
              return -1;
            }

        case 343:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9883; /* aarch64_pred_cmpgtvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9893; /* aarch64_pred_cmpgtvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9903; /* aarch64_pred_cmpgtvnx4si_wide */

            default:
              return -1;
            }

        case 344:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9884; /* aarch64_pred_cmphivnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9894; /* aarch64_pred_cmphivnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9904; /* aarch64_pred_cmphivnx4si_wide */

            default:
              return -1;
            }

        case 345:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9885; /* aarch64_pred_cmphsvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9895; /* aarch64_pred_cmphsvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9905; /* aarch64_pred_cmphsvnx4si_wide */

            default:
              return -1;
            }

        case 346:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9886; /* aarch64_pred_cmplevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9896; /* aarch64_pred_cmplevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9906; /* aarch64_pred_cmplevnx4si_wide */

            default:
              return -1;
            }

        case 347:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9887; /* aarch64_pred_cmplovnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9897; /* aarch64_pred_cmplovnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9907; /* aarch64_pred_cmplovnx4si_wide */

            default:
              return -1;
            }

        case 348:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9888; /* aarch64_pred_cmplsvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9898; /* aarch64_pred_cmplsvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9908; /* aarch64_pred_cmplsvnx4si_wide */

            default:
              return -1;
            }

        case 349:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9889; /* aarch64_pred_cmpltvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9899; /* aarch64_pred_cmpltvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9909; /* aarch64_pred_cmpltvnx4si_wide */

            default:
              return -1;
            }

        case 350:
          switch (pattern1288 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9890; /* aarch64_pred_cmpnevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9900; /* aarch64_pred_cmpnevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9910; /* aarch64_pred_cmpnevnx4si_wide */

            default:
              return -1;
            }

        case 473:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern1296 (x4, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12953; /* aarch64_pred_matchvnx16qi */

            case E_VNx8BImode:
              if (pattern1296 (x4, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12955; /* aarch64_pred_matchvnx8hi */

            default:
              return -1;
            }

        case 474:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern1296 (x4, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12954; /* aarch64_pred_nmatchvnx16qi */

            case E_VNx8BImode:
              if (pattern1296 (x4, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12956; /* aarch64_pred_nmatchvnx8hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_624 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      return recog_514 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (aarch64_comparison_operator (x3, E_VOIDmode))
            {
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) == CONST_INT)
            {
              res = recog_2 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x3;
          if (!aarch64_comparison_operation (operands[1], E_VOIDmode))
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case PLUS:
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              switch (pattern587 (x2))
                {
                case 0:
                  return 475; /* csinc3si_insn */

                case 1:
                  return 476; /* csinc3di_insn */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern587 (x2))
                {
                case 0:
                  return 477; /* *csinv3si_insn */

                case 1:
                  return 478; /* *csinv3di_insn */

                default:
                  return -1;
                }

            case NEG:
              switch (pattern587 (x2))
                {
                case 0:
                  return 481; /* csneg3si_insn */

                case 1:
                  return 482; /* csneg3di_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              x8 = XEXP (x6, 0);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x9 = XEXP (x2, 2);
                  if (GET_CODE (x9) != ZERO_EXTEND
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_SImode)
                    return -1;
                  switch (GET_CODE (x10))
                    {
                    case NEG:
                      x11 = XEXP (x10, 0);
                      operands[3] = x11;
                      if (!register_operand (operands[3], E_SImode))
                        return -1;
                      return 483; /* *csinv3_uxtw_insn1 */

                    case NOT:
                      x11 = XEXP (x10, 0);
                      operands[3] = x11;
                      if (!register_operand (operands[3], E_SImode))
                        return -1;
                      return 484; /* *csinv3_uxtw_insn1 */

                    default:
                      return -1;
                    }

                case NEG:
                  switch (pattern937 (x2))
                    {
                    case 0:
                      return 485; /* *csinv3_uxtw_insn2 */

                    case 1:
                      return 487; /* *csinv3_uxtw_insn3 */

                    default:
                      return -1;
                    }

                case NOT:
                  switch (pattern937 (x2))
                    {
                    case 0:
                      return 486; /* *csinv3_uxtw_insn2 */

                    case 1:
                      return 488; /* *csinv3_uxtw_insn3 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_512 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_511 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_522 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_507 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_510 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_518 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_521 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_529 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_534 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_509 (x1, insn, pnum_clobbers);

    case DIV:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern34 (x2, 
E_SImode) != 0)
            return -1;
          return 399; /* divsi3 */

        case E_DImode:
          if (pattern34 (x2, 
E_DImode) != 0)
            return -1;
          return 401; /* divdi3 */

        case E_HFmode:
          if (pattern34 (x2, 
E_HFmode) != 0
              || !(
#line 7329 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1070; /* *divhf3 */

        case E_SFmode:
          if (pattern34 (x2, 
E_SFmode) != 0
              || !
#line 7329 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1071; /* *divsf3 */

        case E_DFmode:
          if (pattern34 (x2, 
E_DFmode) != 0
              || !
#line 7329 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1072; /* *divdf3 */

        case E_V4HFmode:
          if (pattern34 (x2, 
E_V4HFmode) != 0
              || !(
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2387; /* *divv4hf3 */

        case E_V8HFmode:
          if (pattern34 (x2, 
E_V8HFmode) != 0
              || !(
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2390; /* *divv8hf3 */

        case E_V2SFmode:
          if (pattern34 (x2, 
E_V2SFmode) != 0
              || !
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2391; /* *divv2sf3 */

        case E_V4SFmode:
          if (pattern34 (x2, 
E_V4SFmode) != 0
              || !
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2394; /* *divv4sf3 */

        case E_V2DFmode:
          if (pattern34 (x2, 
E_V2DFmode) != 0
              || !
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2395; /* *divv2df3 */

        default:
          return -1;
        }

    case UDIV:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern34 (x2, 
E_SImode) != 0)
            return -1;
          return 400; /* udivsi3 */

        case E_DImode:
          if (pattern34 (x2, 
E_DImode) != 0)
            return -1;
          return 402; /* udivdi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x6 = XEXP (x2, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x3 = XEXP (x2, 0);
          operands[2] = x3;
          if (cc_register (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (register_operand (operands[0], E_QImode)
                      && aarch64_comparison_operator_mode (operands[1], E_QImode))
                    return 441; /* aarch64_cstoreqi */
                  break;

                case E_HImode:
                  if (register_operand (operands[0], E_HImode)
                      && aarch64_comparison_operator_mode (operands[1], E_HImode))
                    return 442; /* aarch64_cstorehi */
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && aarch64_comparison_operator_mode (operands[1], E_SImode))
                    return 443; /* aarch64_cstoresi */
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && aarch64_comparison_operator_mode (operands[1], E_DImode))
                    return 444; /* aarch64_cstoredi */
                  break;

                default:
                  break;
                }
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      operands[2] = x6;
      switch (GET_CODE (x2))
        {
        case EQ:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern752 (x2, 
E_SImode) != 0
                  || !
#line 4469 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 445; /* *compare_cstoresi_insn */

            case E_DImode:
              if (pattern752 (x2, 
E_DImode) != 0
                  || !
#line 4469 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 447; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        case NE:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern752 (x2, 
E_SImode) != 0
                  || !
#line 4469 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 446; /* *compare_cstoresi_insn */

            case E_DImode:
              if (pattern752 (x2, 
E_DImode) != 0
                  || !
#line 4469 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 448; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_524 (x1, insn, pnum_clobbers);

    case AND:
      return recog_508 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_523 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          return 688; /* clzsi2 */

        case 1:
          return 689; /* clzdi2 */

        case 2:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2830; /* clzv8qi2 */

        case 3:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2833; /* clzv16qi2 */

        case 4:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2834; /* clzv4hi2 */

        case 5:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2837; /* clzv8hi2 */

        case 6:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2838; /* clzv2si2 */

        case 7:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2841; /* clzv4si2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 5551 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 690; /* *aarch64_popcountsi2_cssc_insn */

        case 1:
          if (!
#line 5551 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 691; /* *aarch64_popcountdi2_cssc_insn */

        case 2:
          if (!
#line 3565 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2842; /* popcountv8qi2 */

        case 3:
          if (!
#line 3565 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2845; /* popcountv16qi2 */

        default:
          return -1;
        }

    case CLRSB:
      switch (pattern0 (x1))
        {
        case 0:
          return 692; /* clrsbsi2 */

        case 1:
          return 693; /* clrsbdi2 */

        case 2:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2818; /* clrsbv8qi2 */

        case 3:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2821; /* clrsbv16qi2 */

        case 4:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2822; /* clrsbv4hi2 */

        case 5:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2825; /* clrsbv8hi2 */

        case 6:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2826; /* clrsbv2si2 */

        case 7:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2829; /* clrsbv4si2 */

        default:
          return -1;
        }

    case BITREVERSE:
      switch (pattern1 (x1))
        {
        case 0:
          return 694; /* aarch64_rbitsi */

        case 1:
          return 695; /* aarch64_rbitdi */

        case 2:
          if (!
#line 380 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1396; /* aarch64_rbitv8qi */

        case 3:
          if (!
#line 380 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1399; /* aarch64_rbitv16qi */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern3 (x1))
        {
        case 0:
          return 696; /* ctzsi2 */

        case 1:
          return 697; /* ctzdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_533 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_538 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_539 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      if (subreg_lowpart_operator (x6, E_VOIDmode))
        {
          operands[4] = x6;
          switch (pattern526 (x2))
            {
            case 0:
              if (
#line 5866 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0))
                return 721; /* *aarch64_rotr_reg_si3_mask1 */
              break;

            case 1:
              if (
#line 5866 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0))
                return 726; /* *aarch64_rotr_reg_di3_mask1 */
              break;

            case 2:
              if (
#line 5930 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 743; /* *aarch64_rotr_reg_di3_mask2 */
              break;

            case 3:
              if (
#line 5878 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)))
                return 731; /* *aarch64_rotr_reg_si3_neg_mask2 */
              break;

            case 4:
              if (
#line 5878 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 736; /* *aarch64_rotr_reg_di3_neg_mask2 */
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (pattern419 (x2))
        {
        case 0:
          return 762; /* *rorsi3_insn */

        case 1:
          return 763; /* *rordi3_insn */

        default:
          return -1;
        }

    case ROTATE:
      return recog_532 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (pattern529 (x2))
        {
        case 0:
          if (!
#line 6341 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
            return -1;
          return 814; /* *extvsi */

        case 1:
          if (!
#line 6341 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (DImode) - 1)))
            return -1;
          return 816; /* *extvdi */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      res = recog_475 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (XWINT (x6, 0) != 64L
          || GET_CODE (x9) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (XWINT (x9, 0))
        {
        case 0L:
          switch (pattern900 ())
            {
            case 0:
              if (!
#line 7593 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1112; /* aarch64_movdi_tilow */

            case 1:
              if (!
#line 7593 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1113; /* aarch64_movdi_tflow */

            case 2:
              if (!
#line 7593 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1114; /* aarch64_movdi_tdlow */

            default:
              return -1;
            }

        case 64L:
          switch (pattern900 ())
            {
            case 0:
              if (!
#line 7603 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1115; /* aarch64_movdi_tihigh */

            case 1:
              if (!
#line 7603 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1116; /* aarch64_movdi_tfhigh */

            case 2:
              if (!
#line 7603 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1117; /* aarch64_movdi_tdhigh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case TRUNCATE:
    case HIGH:
      return recog_506 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_540 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_526 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_525 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_513 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_536 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_543 (x1, insn, pnum_clobbers);

    case FLOAT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 7115 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1025; /* floatsisf2 */

        case 1:
          if (!
#line 7126 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1029; /* floatdisf2 */

        case 2:
          if (!
#line 7115 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1027; /* floatdidf2 */

        case 3:
          if (!
#line 7126 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1031; /* floatsidf2 */

        case 4:
          if (!
#line 7141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1033; /* aarch64_fp16_floatsihf2 */

        case 5:
          if (!
#line 7141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1035; /* aarch64_fp16_floatdihf2 */

        case 6:
          if (!
#line 3043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
            return -1;
          return 2612; /* floathihf2 */

        case 7:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2620; /* floatv4hiv4hf2 */

        case 8:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2622; /* floatv8hiv8hf2 */

        case 9:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2624; /* floatv2siv2sf2 */

        case 10:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2626; /* floatv4siv4sf2 */

        case 11:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2628; /* floatv2div2df2 */

        case 12:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12659; /* floatvnx8sivnx8sf2 */

        case 13:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12661; /* floatvnx16sivnx16sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 7115 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1026; /* floatunssisf2 */

        case 1:
          if (!
#line 7126 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1030; /* floatunsdisf2 */

        case 2:
          if (!
#line 7115 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1028; /* floatunsdidf2 */

        case 3:
          if (!
#line 7126 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1032; /* floatunssidf2 */

        case 4:
          if (!
#line 7141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1034; /* aarch64_fp16_floatunssihf2 */

        case 5:
          if (!
#line 7141 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1036; /* aarch64_fp16_floatunsdihf2 */

        case 6:
          if (!
#line 3043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
            return -1;
          return 2613; /* floatunshihf2 */

        case 7:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2621; /* floatunsv4hiv4hf2 */

        case 8:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2623; /* floatunsv8hiv8hf2 */

        case 9:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2625; /* floatunsv2siv2sf2 */

        case 10:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2627; /* floatunsv4siv4sf2 */

        case 11:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2629; /* floatunsv2div2df2 */

        case 12:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12660; /* floatunsvnx8sivnx8sf2 */

        case 13:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12662; /* floatunsvnx16sivnx16sf2 */

        default:
          return -1;
        }

    case SQRT:
      return recog_537 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_527 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_520 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_535 (x1, insn, pnum_clobbers);

    case UMIN:
      return recog_531 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!aarch64_valid_symref (operands[2], E_VOIDmode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1125; /* add_losym_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1126; /* add_losym_di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_515 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_530 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_505 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_516 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_517 (x1, insn, pnum_clobbers);

    case US_PLUS:
      return recog_542 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      return recog_519 (x1, insn, pnum_clobbers);

    case US_MINUS:
      return recog_541 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      return recog_545 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      return recog_544 (x1, insn, pnum_clobbers);

    case SS_NEG:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3402; /* aarch64_sqnegv8qi */

        case 1:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3408; /* aarch64_sqnegv16qi */

        case 2:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3410; /* aarch64_sqnegv4hi */

        case 3:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3416; /* aarch64_sqnegv8hi */

        case 4:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3418; /* aarch64_sqnegv2si */

        case 5:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3424; /* aarch64_sqnegv4si */

        case 6:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3426; /* aarch64_sqnegv2di */

        case 7:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3428; /* aarch64_sqnegqi */

        case 8:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3430; /* aarch64_sqneghi */

        case 9:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3432; /* aarch64_sqnegsi */

        case 10:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3434; /* aarch64_sqnegdi */

        default:
          return -1;
        }

    case SS_ABS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3405; /* aarch64_sqabsv8qi */

        case 1:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3409; /* aarch64_sqabsv16qi */

        case 2:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3413; /* aarch64_sqabsv4hi */

        case 3:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3417; /* aarch64_sqabsv8hi */

        case 4:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3421; /* aarch64_sqabsv2si */

        case 5:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3425; /* aarch64_sqabsv4si */

        case 6:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3427; /* aarch64_sqabsv2di */

        case 7:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3429; /* aarch64_sqabsqi */

        case 8:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3431; /* aarch64_sqabshi */

        case 9:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3433; /* aarch64_sqabssi */

        case 10:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3437; /* aarch64_sqabsdi */

        default:
          return -1;
        }

    case SS_ASHIFT:
      return recog_528 (x1, insn, pnum_clobbers);

    case VEC_SERIES:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern563 (x2, 
E_QImode, 
E_VNx16QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6479; /* vec_seriesvnx16qi */

        case E_VNx8QImode:
          if (pattern563 (x2, 
E_QImode, 
E_VNx8QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6480; /* vec_seriesvnx8qi */

        case E_VNx4QImode:
          if (pattern563 (x2, 
E_QImode, 
E_VNx4QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6481; /* vec_seriesvnx4qi */

        case E_VNx2QImode:
          if (pattern563 (x2, 
E_QImode, 
E_VNx2QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6482; /* vec_seriesvnx2qi */

        case E_VNx8HImode:
          if (pattern563 (x2, 
E_HImode, 
E_VNx8HImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6483; /* vec_seriesvnx8hi */

        case E_VNx4HImode:
          if (pattern563 (x2, 
E_HImode, 
E_VNx4HImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6484; /* vec_seriesvnx4hi */

        case E_VNx2HImode:
          if (pattern563 (x2, 
E_HImode, 
E_VNx2HImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6485; /* vec_seriesvnx2hi */

        case E_VNx4SImode:
          if (pattern563 (x2, 
E_SImode, 
E_VNx4SImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6486; /* vec_seriesvnx4si */

        case E_VNx2SImode:
          if (pattern563 (x2, 
E_SImode, 
E_VNx2SImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6487; /* vec_seriesvnx2si */

        case E_VNx2DImode:
          if (pattern563 (x2, 
E_DImode, 
E_VNx2DImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6488; /* vec_seriesvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2805 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2853 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2893 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1106 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && ((
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1680 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && ((
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1753 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1805 (insn, operands);

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1693 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1766 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1818 (insn, operands);

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1706 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1779 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1719 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1792 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1844 (insn, operands);

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1968 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1971 (insn, operands);

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1969 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1972 (insn, operands);

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1970 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1973 (insn, operands);

        default:
          return NULL;
        }

    case 1L:
      x6 = XVECEXP (x2, 0, 2);
      operands[4] = x6;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return NULL;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1043 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
                  || !((
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1857 (insn, operands);

            case E_VNx8HFmode:
              if (pattern1043 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1870 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1043 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1883 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1043 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1896 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case CONST:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1256 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1974 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1256 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1975 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1256 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1976 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      return split_67 (x1, insn);

    case 2:
      return split_66 (x1, insn);

    case 4:
      return split_68 (x1, insn);

    case 5:
      x4 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x4) != CONST_INT)
        return NULL;
      x5 = XVECEXP (x3, 0, 2);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 3);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 4);
      operands[4] = x7;
      switch (XINT (x3, 1))
        {
        case 376:
          switch (pattern1109 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2012 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2028 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2044 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2016 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2032 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2048 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2020 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2036 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2052 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2024 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2040 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2056 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2060 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2064 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2068 (insn, operands);

            default:
              return NULL;
            }

        case 377:
          switch (pattern1109 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2013 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2029 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2045 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2017 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2033 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2049 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2021 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2037 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2053 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2025 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2041 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2057 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2061 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2065 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2069 (insn, operands);

            default:
              return NULL;
            }

        case 381:
          switch (pattern1109 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2014 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2030 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2046 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2018 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2034 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2050 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2022 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2038 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2054 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2026 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2042 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2058 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2062 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2066 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2070 (insn, operands);

            default:
              return NULL;
            }

        case 382:
          switch (pattern1109 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2015 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2031 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2047 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2019 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2035 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2051 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2023 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2039 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2055 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2027 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2043 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2059 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2067 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2071 (insn, operands);

            default:
              return NULL;
            }

        case 360:
          switch (pattern1110 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2072 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2084 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2076 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2088 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2080 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2092 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2096 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2100 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2104 (insn, operands);

            default:
              return NULL;
            }

        case 361:
          switch (pattern1110 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2073 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2085 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2077 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2089 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2081 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2093 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2097 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2101 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2105 (insn, operands);

            default:
              return NULL;
            }

        case 362:
          switch (pattern1110 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2074 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2086 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2078 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2090 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2082 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2094 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2098 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2102 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2106 (insn, operands);

            default:
              return NULL;
            }

        case 363:
          switch (pattern1110 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2075 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2087 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2079 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2091 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2083 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2095 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2099 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2103 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2107 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_85 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2537 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2547 (insn, operands);
}

 rtx_insn *
split_88 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2477 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2487 (insn, operands);
}

 rtx_insn *
split_91 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2417 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2427 (insn, operands);
}

 rtx_insn *
split_94 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2516 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2526 (insn, operands);
}

 rtx_insn *
split_97 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2456 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2466 (insn, operands);
}

 rtx_insn *
split_101 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2535 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2545 (insn, operands);
}

 rtx_insn *
split_105 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2455 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2465 (insn, operands);
}

 rtx_insn *
split_110 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2514 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2524 (insn, operands);
}

 rtx_insn *
split_117 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2533 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2543 (insn, operands);
}

 rtx_insn *
split_124 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2552 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2562 (insn, operands);
}

 rtx_insn *
split_132 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1097 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2408 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2418 (insn, operands);

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2428 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2438 (insn, operands);

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2448 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2458 (insn, operands);

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2468 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2478 (insn, operands);

    case 4:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2488 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2498 (insn, operands);

    case 5:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2508 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2518 (insn, operands);

    case 6:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2528 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2538 (insn, operands);

    case 7:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2548 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2558 (insn, operands);

    case 8:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2409 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2419 (insn, operands);

    case 9:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2429 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2439 (insn, operands);

    case 10:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2449 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2459 (insn, operands);

    case 11:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2469 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2479 (insn, operands);

    case 12:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2489 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2499 (insn, operands);

    case 13:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2509 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2519 (insn, operands);

    case 14:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2529 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2539 (insn, operands);

    case 15:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2549 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2559 (insn, operands);

    case 16:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2410 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2420 (insn, operands);

    case 17:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2430 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2440 (insn, operands);

    case 18:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2450 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2460 (insn, operands);

    case 19:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2470 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2480 (insn, operands);

    case 20:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2490 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2500 (insn, operands);

    case 21:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2510 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2520 (insn, operands);

    case 22:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2530 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2540 (insn, operands);

    case 23:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2550 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2560 (insn, operands);

    case 24:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2411 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2421 (insn, operands);

    case 25:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2431 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2441 (insn, operands);

    case 26:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2451 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2461 (insn, operands);

    case 27:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2471 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2481 (insn, operands);

    case 28:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2491 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2501 (insn, operands);

    case 29:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2511 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2521 (insn, operands);

    case 30:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2531 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2541 (insn, operands);

    case 31:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2551 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2561 (insn, operands);

    case 32:
      return split_131 (x1, insn);

    case 33:
      return split_130 (x1, insn);

    case 34:
      return split_129 (x1, insn);

    case 35:
      return split_128 (x1, insn);

    case 36:
      return split_127 (x1, insn);

    case 37:
      return split_126 (x1, insn);

    case 38:
      return split_125 (x1, insn);

    case 39:
      return split_124 (x1, insn);

    case 40:
      return split_123 (x1, insn);

    case 41:
      return split_122 (x1, insn);

    case 42:
      return split_121 (x1, insn);

    case 43:
      return split_120 (x1, insn);

    case 44:
      return split_119 (x1, insn);

    case 45:
      return split_118 (x1, insn);

    case 46:
      return split_117 (x1, insn);

    case 47:
      return split_116 (x1, insn);

    case 48:
      return split_115 (x1, insn);

    case 49:
      return split_114 (x1, insn);

    case 50:
      return split_113 (x1, insn);

    case 51:
      return split_112 (x1, insn);

    case 52:
      return split_111 (x1, insn);

    case 53:
      return split_110 (x1, insn);

    case 54:
      return split_109 (x1, insn);

    case 55:
      return split_108 (x1, insn);

    case 56:
      return split_107 (x1, insn);

    case 57:
      return split_106 (x1, insn);

    case 58:
      return split_105 (x1, insn);

    case 59:
      return split_104 (x1, insn);

    case 60:
      return split_103 (x1, insn);

    case 61:
      return split_102 (x1, insn);

    case 62:
      return split_101 (x1, insn);

    case 63:
      return split_100 (x1, insn);

    case 64:
      return split_99 (x1, insn);

    case 65:
      return split_98 (x1, insn);

    case 66:
      return split_97 (x1, insn);

    case 67:
      return split_96 (x1, insn);

    case 68:
      return split_95 (x1, insn);

    case 69:
      return split_94 (x1, insn);

    case 70:
      return split_93 (x1, insn);

    case 71:
      return split_92 (x1, insn);

    case 72:
      return split_91 (x1, insn);

    case 73:
      return split_90 (x1, insn);

    case 74:
      return split_89 (x1, insn);

    case 75:
      return split_88 (x1, insn);

    case 76:
      return split_87 (x1, insn);

    case 77:
      return split_86 (x1, insn);

    case 78:
      return split_85 (x1, insn);

    case 79:
      return split_84 (x1, insn);

    case 80:
      if (!(
#line 10172 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10174 "../../gcc/config/aarch64/aarch64-sve.md"
( (operands[4] != CONST0_RTX (VNx16BImode)
       || operands[5] != CONST0_RTX (VNx16BImode)))))
        return NULL;
      return gen_split_2679 (insn, operands);

    case 81:
      if (!(
#line 10196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10198 "../../gcc/config/aarch64/aarch64-sve.md"
( (operands[4] != CONST0_RTX (VNx16BImode)
       || operands[5] != CONST0_RTX (VNx16BImode)))))
        return NULL;
      return gen_split_2680 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          if (register_operand (operands[0], E_SImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2533 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern861 (x6, 
E_SImode) != 0
              || !
#line 3636 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return NULL;
          if (register_operand (operands[0], E_DImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2533 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), DImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern861 (x6, 
E_DImode) != 0
              || !
#line 3636 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              || !
#line 2545 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_3 (insn, operands);

        case SUBREG:
        case MEM:
          if (peep2_current_count < 2
              || pattern585 (x4, 
ZERO_EXTEND) != 0)
            return NULL;
          if (
#line 139 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_221 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 3)
            return NULL;
          x9 = PATTERN (peep2_next_insn (2));
          if (pattern1225 (x9, 
ZERO_EXTEND) != 0
              || !
#line 244 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_231 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (peep2_current_count < 2)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != COMPARE
          || GET_MODE (x10) != E_CCmode)
        return NULL;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 66
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return NULL;
      x13 = XEXP (x10, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1197 (x2, 
E_SImode) != 0
              || !
#line 3598 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        case E_DImode:
          if (pattern1197 (x2, 
E_DImode) != 0
              || !
#line 3598 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_CCmode)
        return NULL;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 66
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (aarch64_reg_or_zero (operands[2], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern931 (x6, 
E_SImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_6 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (aarch64_reg_or_zero (operands[2], E_DImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern931 (x6, 
E_DImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_7 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      operands[3] = x5;
      if (const_int_operand (operands[3], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern932 (x6, 
E_SImode) == 0
              && 
#line 3657 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!const_int_operand (operands[3], E_DImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern932 (x6, 
E_DImode) != 0
          || !
#line 3657 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      return peephole2_12 (x1, insn, pmatch_len_);

    case SIGN_EXTEND:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      if (pattern585 (x4, 
SIGN_EXTEND) != 0)
        return NULL;
      if (
#line 127 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_220 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 3)
        return NULL;
      x9 = PATTERN (peep2_next_insn (2));
      if (pattern1225 (x9, 
SIGN_EXTEND) != 0
          || !
#line 224 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_230 (insn, operands);

    default:
      return NULL;
    }
}
