/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 4;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 5;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 9;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 10;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 11;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x3) != E_VNx8SFmode
          || !aligned_register_operand (operands[1], E_VNx8SImode))
        return -1;
      return 12;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern33 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern33 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V8QImode:
          if (pattern34 (x1, 
E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern34 (x1, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V4HImode:
          if (pattern34 (x1, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V8HImode:
          if (pattern34 (x1, 
E_V8HImode) != 0)
            return -1;
          return 5;

        case E_V2SImode:
          if (pattern34 (x1, 
E_V2SImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern34 (x1, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case E_VNx32QImode:
          if (pattern35 (x1, 
E_VNx32QImode) != 0)
            return -1;
          return 8;

        case E_VNx16HImode:
          if (pattern35 (x1, 
E_VNx16HImode) != 0)
            return -1;
          return 9;

        case E_VNx8SImode:
          if (pattern35 (x1, 
E_VNx8SImode) != 0)
            return -1;
          return 10;

        case E_VNx4DImode:
          if (pattern35 (x1, 
E_VNx4DImode) != 0)
            return -1;
          return 11;

        case E_VNx64QImode:
          if (pattern35 (x1, 
E_VNx64QImode) != 0)
            return -1;
          return 12;

        case E_VNx32HImode:
          if (pattern35 (x1, 
E_VNx32HImode) != 0)
            return -1;
          return 13;

        case E_VNx16SImode:
          if (pattern35 (x1, 
E_VNx16SImode) != 0)
            return -1;
          return 14;

        case E_VNx8DImode:
          if (pattern35 (x1, 
E_VNx8DImode) != 0)
            return -1;
          return 15;

        default:
          return -1;
        }

    case CONST_VECTOR:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern36 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 16;

        case E_VNx8QImode:
          if (pattern36 (x1, 
E_VNx8QImode) != 0)
            return -1;
          return 17;

        case E_VNx4QImode:
          if (pattern36 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 18;

        case E_VNx2QImode:
          if (pattern36 (x1, 
E_VNx2QImode) != 0)
            return -1;
          return 19;

        case E_VNx8HImode:
          if (pattern36 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 20;

        case E_VNx4HImode:
          if (pattern36 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 21;

        case E_VNx2HImode:
          if (pattern36 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 22;

        case E_VNx4SImode:
          if (pattern36 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 23;

        case E_VNx2SImode:
          if (pattern36 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 24;

        case E_VNx2DImode:
          if (pattern36 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 25;

        case E_V2DImode:
          if (pattern36 (x1, 
E_V2DImode) != 0)
            return -1;
          return 26;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern38 (x1);
      if (res >= 0)
        return res + 27; /* [27, 34] */
      return -1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 5;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 6;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 7;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 8;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          return pattern79 (x3, 
E_V8QImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern79 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_V4HImode:
          if (pattern79 (x3, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern79 (x3, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V2SImode:
          if (pattern79 (x3, 
E_V2SImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern79 (x3, 
E_V4SImode) != 0)
            return -1;
          return 5;

        case E_V2DImode:
          if (pattern79 (x3, 
E_V2DImode) != 0)
            return -1;
          return 6;

        case E_QImode:
          if (pattern79 (x3, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_HImode:
          if (pattern79 (x3, 
E_HImode) != 0)
            return -1;
          return 8;

        case E_SImode:
          if (pattern79 (x3, 
E_SImode) != 0)
            return -1;
          return 9;

        case E_DImode:
          if (pattern79 (x3, 
E_DImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern102 (x3, 
E_V8QImode) != 0)
            return -1;
          return 11;

        case E_V16QImode:
          if (pattern102 (x3, 
E_V16QImode) != 0)
            return -1;
          return 12;

        case E_V4HImode:
          if (pattern103 (x3, 
E_V4HImode) != 0)
            return -1;
          return 13;

        case E_V8HImode:
          if (pattern103 (x3, 
E_V8HImode) != 0)
            return -1;
          return 14;

        case E_V2SImode:
          if (pattern104 (x3, 
E_V2SImode) != 0)
            return -1;
          return 15;

        case E_V4SImode:
          if (pattern104 (x3, 
E_V4SImode) != 0)
            return -1;
          return 16;

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DImode) != 0)
            return -1;
          return 17;

        case E_QImode:
          if (pattern102 (x3, 
E_QImode) != 0)
            return -1;
          return 18;

        case E_HImode:
          if (pattern103 (x3, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_SImode:
          if (pattern104 (x3, 
E_SImode) != 0)
            return -1;
          return 20;

        case E_DImode:
          if (pattern105 (x3, 
E_DImode) != 0)
            return -1;
          return 21;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8SImode:
          if (!register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 0;

        case E_VNx8DImode:
          if (!register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_hi (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern168 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern168 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern168 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern183 (x3, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern183 (x3, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8BImode:
          if (!register_operand (operands[1], E_VNx8BImode)
              || !register_operand (operands[2], E_VNx8HImode))
            return -1;
          return 6;

        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          return 7;

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              return 8;

            case E_VNx4SImode:
              if (!register_operand (operands[2], E_VNx4SImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern198 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern198 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern198 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          return pattern195 (x2, 
E_V16QImode, 
E_V4SFmode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern195 (x2, 
E_VNx16QImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern207 (x2, 
E_V4SFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern213 (x3); /* [-1, 3] */

    case UNSPEC:
      if (XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 351)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 351)
        return -1;
      x9 = XVECEXP (x8, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      res = pattern217 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i2))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 168)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 93)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (!const_int_operand (x7, E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[1] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[2] = x10;
      operands[3] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          return pattern247 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern247 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[1] = x12;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[3] = x10;
      operands[4] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          res = pattern251 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern251 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern268 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      if (GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx16QImode:
          if (!register_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[4], E_VNx16QImode))
            return -1;
          return 0;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !register_operand (operands[4], E_VNx8HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (pattern267 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_VNx2BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx2DImode:
      return 0;

    case E_VNx1TImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern287 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[3] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          if (GET_MODE (x2) != E_VNx16QImode
              || GET_MODE (x3) != E_VNx16QImode
              || !register_operand (operands[2], E_VNx16BImode)
              || !register_operand (operands[3], E_VNx16QImode))
            return -1;
          return 0;

        case E_VNx8HImode:
          if (GET_MODE (x2) != E_VNx8HImode
              || !register_operand (operands[2], E_VNx8BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx8HImode:
              if (!register_operand (operands[3], E_VNx8HImode))
                return -1;
              return 1;

            case E_VNx8BFmode:
              if (!register_operand (operands[3], E_VNx8BFmode))
                return -1;
              return 2;

            case E_VNx8HFmode:
              if (!register_operand (operands[3], E_VNx8HFmode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_VNx4SImode:
          if (GET_MODE (x2) != E_VNx4SImode
              || !register_operand (operands[2], E_VNx4BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode))
                return -1;
              return 4;

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_VNx2DImode:
          if (GET_MODE (x2) != E_VNx2DImode
              || !register_operand (operands[2], E_VNx2BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode))
                return -1;
              return 6;

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_VNx1TImode:
          if (GET_MODE (x2) != E_VNx1TImode
              || GET_MODE (x3) != E_VNx1TImode
              || !register_operand (operands[2], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[3], E_VNx16QImode))
                return -1;
              return 8;

            case E_VNx8HImode:
              if (!register_operand (operands[3], E_VNx8HImode))
                return -1;
              return 9;

            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode))
                return -1;
              return 10;

            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode))
                return -1;
              return 11;

            case E_VNx8BFmode:
              if (!register_operand (operands[3], E_VNx8BFmode))
                return -1;
              return 12;

            case E_VNx8HFmode:
              if (!register_operand (operands[3], E_VNx8HFmode))
                return -1;
              return 13;

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode))
                return -1;
              return 14;

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode))
                return -1;
              return 15;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[3] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[4] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          if (GET_MODE (x2) != E_VNx16QImode
              || GET_MODE (x3) != E_VNx16QImode
              || !register_operand (operands[3], E_VNx16BImode)
              || !register_operand (operands[4], E_VNx16QImode))
            return -1;
          return 16;

        case E_VNx8HImode:
          if (GET_MODE (x2) != E_VNx8HImode
              || !register_operand (operands[3], E_VNx8BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx8HImode:
              if (!register_operand (operands[4], E_VNx8HImode))
                return -1;
              return 17;

            case E_VNx8BFmode:
              if (!register_operand (operands[4], E_VNx8BFmode))
                return -1;
              return 18;

            case E_VNx8HFmode:
              if (!register_operand (operands[4], E_VNx8HFmode))
                return -1;
              return 19;

            default:
              return -1;
            }

        case E_VNx4SImode:
          if (GET_MODE (x2) != E_VNx4SImode
              || !register_operand (operands[3], E_VNx4BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[4], E_VNx4SImode))
                return -1;
              return 20;

            case E_VNx4SFmode:
              if (!register_operand (operands[4], E_VNx4SFmode))
                return -1;
              return 21;

            default:
              return -1;
            }

        case E_VNx2DImode:
          if (GET_MODE (x2) != E_VNx2DImode
              || !register_operand (operands[3], E_VNx2BImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[4], E_VNx2DImode))
                return -1;
              return 22;

            case E_VNx2DFmode:
              if (!register_operand (operands[4], E_VNx2DFmode))
                return -1;
              return 23;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return pattern354 (x1); /* [-1, 3] */
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern366 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[2], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern377 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !aarch64_sync_memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !aarch64_sync_memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !aarch64_sync_memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !aarch64_sync_memory_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern385 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_hi_half (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern390 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern389 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern389 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern389 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern389 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern389 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern389 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern389 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern401 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern402 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_simd_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern406 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern372 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern372 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern372 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern372 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern372 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern372 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern372 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern401 (x1, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern413 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern416 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern420 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern420 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern420 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern420 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern434 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V8QImode))
    return -1;
  return 0;
}

int
pattern446 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || pattern443 (x3, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || pattern444 (x3, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || pattern445 (x3, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, unsigned int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern461 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[4] = x3;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 3);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern210 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern210 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern210 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern210 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern474 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_struct_nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_sve_struct_nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern479 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern478 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern478 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern478 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern478 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern478 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern478 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern478 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern478 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern478 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern478 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern478 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern490 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern490 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern490 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern490 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  return pattern51 (x1); /* [-1, 1] */
}

int
pattern503 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[1], E_VNx16QImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern516 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern516 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern516 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern516 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern516 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_DImode:
      if (pattern516 (x1, 
E_V2DImode, 
E_DImode, 
E_V2SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern535 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !aarch64_simd_reg_or_zero (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || GET_MODE (x3) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HImode))
            return -1;
          return 1;

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DFmode)
          || !aarch64_simd_reg_or_zero (operands[2], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern568 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  return pattern456 (x5, 
31, 
3, 
UNSPEC_VOLATILE); /* [-1, 0] */
}

int
pattern574 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern573 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern573 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern573 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern573 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern585 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!memory_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern590 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_orr_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern598 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[6], E_VNx4BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[5], E_VNx4BImode)
      || !register_operand (operands[2], E_VNx4SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx4QImode:
      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx4QImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx4HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern602 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx2QImode:
      if (!aarch64_gather_scale_operand_b (operands[4], E_DImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_gather_scale_operand_h (operands[4], E_DImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_gather_scale_operand_w (operands[4], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern609 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern609 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern609 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern609 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern609 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern609 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern609 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern609 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern609 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern609 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern623 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  return pattern295 (x1); /* [-1, 2] */
}

int
pattern628 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x4, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern626 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern626 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 1;

        case E_V2DImode:
          if (pattern626 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != VEC_SELECT)
        return -1;
      x10 = XEXP (x6, 0);
      operands[2] = x10;
      x11 = XEXP (x6, 1);
      operands[4] = x11;
      x12 = XEXP (x7, 0);
      operands[3] = x12;
      x13 = XEXP (x7, 1);
      if (!rtx_equal_p (x13, operands[4]))
        return -1;
      x14 = XEXP (x8, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x8, 1);
      if (!rtx_equal_p (x15, operands[4]))
        return -1;
      x16 = XEXP (x9, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern627 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V4SImode:
          if (pattern627 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern627 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern649 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return pattern647 (x1); /* [-1, 2] */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 168)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern648 (x1, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern648 (x1, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern662 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  if (!register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern669 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_even_or_odd_half (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !vect_par_cnst_even_or_odd_half (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern679 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern678 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern678 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern678 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern685 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern689 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !aarch64_simd_raddsubhn_imm_vec (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[5], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern696 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_NZCmode
      || !register_operand (operands[0], E_VNx16BImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[1] = x8;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[2] = x9;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x10 = XVECEXP (x3, 0, 4);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern707 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 3;

    case E_BFmode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_BFmode)
          || GET_MODE (x1) != E_BFmode
          || !register_operand (operands[1], E_VNx8BFmode))
        return -1;
      return 4;

    case E_HFmode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_HFmode)
          || GET_MODE (x1) != E_HFmode
          || !register_operand (operands[1], E_VNx8HFmode))
        return -1;
      return 5;

    case E_SFmode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_VNx4SFmode))
        return -1;
      return 6;

    case E_DFmode:
      if (!aarch64_simd_nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_VNx2DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern722 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_lanes_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_stp_reg_operand (operands[1], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern725 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx8BImode)
      || !aarch64_sve_ld1ro_operand_h (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern730 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[1], i3))
    return -1;
  return 0;
}

int
pattern735 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern738 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern741 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern751 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern753 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern759 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern767 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern761 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern761 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern761 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern761 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern761 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern761 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern777 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_one (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern789 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern788 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern788 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern788 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern788 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern802 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern809 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !const_1_to_3_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern817 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern816 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern816 (x1, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern816 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern816 (x1, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern816 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern816 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern834 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_xor_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern841 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern296 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern846 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 126)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x5) != EQ)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  x10 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern845 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern845 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern845 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern845 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern845 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern845 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern870 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x2, 0, 2);
  operands[2] = x4;
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern868 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern868 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern868 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      res = pattern869 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern883 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!aarch64_imm3 (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern888 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern887 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern887 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern887 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern898 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern903 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern907 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern913 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern924 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern965 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern969 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_imm_zero (operands[2], i1)
      || !aarch64_simd_imm_minus_one (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern976 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 92
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 691
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 89
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 89
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern984 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 98)
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0)
    return -1;
  return 0;
}

int
pattern988 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern360 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern360 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern992 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!memory_operand (operands[2], E_V16QImode)
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!memory_operand (operands[2], E_V8HImode)
          || !register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!memory_operand (operands[2], E_V4SImode)
          || !register_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!memory_operand (operands[2], E_V2DImode)
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!memory_operand (operands[2], E_V8HFmode)
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!memory_operand (operands[2], E_V4SFmode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 5;

    case E_V2DFmode:
      if (!memory_operand (operands[2], E_V2DFmode)
          || !register_operand (operands[3], E_V2DFmode))
        return -1;
      return 6;

    case E_V8BFmode:
      if (!memory_operand (operands[2], E_V8BFmode)
          || !register_operand (operands[3], E_V8BFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern1008 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XVECEXP (x4, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1007 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern1007 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern1007 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern1007 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern1007 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern1007 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern1007 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern1007 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern1007 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern1007 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern1032 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1038 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1052 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1061 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_uxt_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1067 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1073 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1081 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1088 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1)
      || !aarch64_simd_umax_half_mode (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1098 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  return 0;
}

int
pattern1103 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_mul_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1107 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1107 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1107 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1108 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1108 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1108 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1127 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern1141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SFmode
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1150 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1)
      || pattern990 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern1171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[4] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[5] = x3;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[4]))
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      return pattern1168 (x4); /* [-1, 3] */

    case NOT:
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[2] = x8;
          x9 = XEXP (x7, 0);
          operands[3] = x9;
          switch (GET_MODE (x4))
            {
            case E_VNx16BImode:
              if (pattern1169 (x6, 
E_VNx16BImode) != 0)
                return -1;
              return 4;

            case E_VNx8BImode:
              if (pattern1169 (x6, 
E_VNx8BImode) != 0)
                return -1;
              return 5;

            case E_VNx4BImode:
              if (pattern1169 (x6, 
E_VNx4BImode) != 0)
                return -1;
              return 6;

            case E_VNx2BImode:
              if (pattern1169 (x6, 
E_VNx2BImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        case NOT:
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          operands[3] = x10;
          switch (GET_MODE (x4))
            {
            case E_VNx16BImode:
              if (pattern1170 (x6, 
E_VNx16BImode) != 0)
                return -1;
              return 8;

            case E_VNx8BImode:
              if (pattern1170 (x6, 
E_VNx8BImode) != 0)
                return -1;
              return 9;

            case E_VNx4BImode:
              if (pattern1170 (x6, 
E_VNx4BImode) != 0)
                return -1;
              return 10;

            case E_VNx2BImode:
              if (pattern1170 (x6, 
E_VNx2BImode) != 0)
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1197 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_general_reg (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_or_zero (operands[1], i1)
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1201 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!aarch64_simd_imm_zero (operands[3], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern1211 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_hi_half (operands[4], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1220 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  x7 = XEXP (x6, 1);
  if (!rtx_equal_p (x7, operands[4]))
    return -1;
  x8 = XEXP (x6, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[2] = x9;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      return pattern1215 (x1, 
i1); /* [-1, 7] */

    case NOT:
      x10 = XEXP (x8, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[2] = x10;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          x12 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x12))
            {
            case SET:
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != AND)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != i1)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != NOT)
                return -1;
              x16 = XEXP (x12, 0);
              operands[0] = x16;
              x17 = XEXP (x15, 0);
              if (!rtx_equal_p (x17, operands[3]))
                return -1;
              x18 = XEXP (x14, 1);
              if (!rtx_equal_p (x18, operands[2]))
                return -1;
              x19 = XEXP (x13, 1);
              if (!rtx_equal_p (x19, operands[4]))
                return -1;
              switch (GET_MODE (x6))
                {
                case E_VNx16BImode:
                  if (pattern1216 (x1, 
E_VNx16BImode) != 0)
                    return -1;
                  return 8;

                case E_VNx8BImode:
                  if (pattern1216 (x1, 
E_VNx8BImode) != 0)
                    return -1;
                  return 9;

                case E_VNx4BImode:
                  if (pattern1216 (x1, 
E_VNx4BImode) != 0)
                    return -1;
                  return 10;

                case E_VNx2BImode:
                  if (pattern1216 (x1, 
E_VNx2BImode) != 0)
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            case CLOBBER:
              x16 = XEXP (x12, 0);
              operands[0] = x16;
              if (!scratch_operand (operands[0], E_VNx16BImode))
                return -1;
              switch (GET_MODE (x6))
                {
                case E_VNx16BImode:
                  if (pattern1217 (x8, 
E_VNx16BImode) != 0)
                    return -1;
                  return 12;

                case E_VNx8BImode:
                  if (pattern1217 (x8, 
E_VNx8BImode) != 0)
                    return -1;
                  return 13;

                case E_VNx4BImode:
                  if (pattern1217 (x8, 
E_VNx4BImode) != 0)
                    return -1;
                  return 14;

                case E_VNx2BImode:
                  if (pattern1217 (x8, 
E_VNx2BImode) != 0)
                    return -1;
                  return 15;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          x20 = XEXP (x10, 0);
          operands[3] = x20;
          x12 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x12))
            {
            case SET:
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != AND)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != i1)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != NOT)
                return -1;
              x18 = XEXP (x14, 1);
              if (GET_CODE (x18) != NOT)
                return -1;
              x16 = XEXP (x12, 0);
              operands[0] = x16;
              x17 = XEXP (x15, 0);
              if (!rtx_equal_p (x17, operands[2]))
                return -1;
              x21 = XEXP (x18, 0);
              if (!rtx_equal_p (x21, operands[3]))
                return -1;
              x19 = XEXP (x13, 1);
              if (!rtx_equal_p (x19, operands[4]))
                return -1;
              switch (GET_MODE (x6))
                {
                case E_VNx16BImode:
                  if (pattern1218 (x1, 
E_VNx16BImode) != 0)
                    return -1;
                  return 16;

                case E_VNx8BImode:
                  if (pattern1218 (x1, 
E_VNx8BImode) != 0)
                    return -1;
                  return 17;

                case E_VNx4BImode:
                  if (pattern1218 (x1, 
E_VNx4BImode) != 0)
                    return -1;
                  return 18;

                case E_VNx2BImode:
                  if (pattern1218 (x1, 
E_VNx2BImode) != 0)
                    return -1;
                  return 19;

                default:
                  return -1;
                }

            case CLOBBER:
              x16 = XEXP (x12, 0);
              operands[0] = x16;
              if (!scratch_operand (operands[0], E_VNx16BImode))
                return -1;
              switch (GET_MODE (x6))
                {
                case E_VNx16BImode:
                  if (pattern1219 (x8, 
E_VNx16BImode) != 0)
                    return -1;
                  return 20;

                case E_VNx8BImode:
                  if (pattern1219 (x8, 
E_VNx8BImode) != 0)
                    return -1;
                  return 21;

                case E_VNx4BImode:
                  if (pattern1219 (x8, 
E_VNx4BImode) != 0)
                    return -1;
                  return 22;

                case E_VNx2BImode:
                  if (pattern1219 (x8, 
E_VNx2BImode) != 0)
                    return -1;
                  return 23;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1304 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_VNx2SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 5);
          operands[4] = x5;
          return 0;

        case TRUNCATE:
          if (GET_MODE (x4) != E_VNx2SImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_VNx2DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 5);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[4] = x5;
              return 1;

            case TRUNCATE:
              return 2;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx2SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      operands[4] = x5;
      return 3;

    default:
      return -1;
    }
}

int
pattern1326 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8BFmode:
      if (!register_operand (operands[2], E_VNx8BFmode)
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode)
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1333 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2HImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2SImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
        return -1;
      return 2;

    case E_VNx2DImode:
      if (!register_operand (operands[2], E_VNx2DImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_gather_scale_operand_d (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 0;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1349 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[3], E_V4HFmode)
          || !aarch64_imm2 (operands[5], E_SImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || !aarch64_lane_imm3 (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1354 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[2], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[2], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[2], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[2], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1367 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i2))
    return -1;
  x8 = XEXP (x3, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !aarch64_borrow_operation (operands[4], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern965 (x2, 
E_SImode) != 0
          || !aarch64_simd_shift_imm_si (operands[2], E_SImode)
          || pattern1278 (x3, 
E_SImode) != 0
          || !
#line 6514 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[5]),
				      UINTVAL (operands[2]),
				      UINTVAL(operands[3]))))
        return -1;
      return 852; /* *aarch64_bfisi5_shift_alt */

    case E_DImode:
      if (pattern965 (x2, 
E_DImode) != 0
          || !aarch64_simd_shift_imm_di (operands[2], E_DImode)
          || pattern1278 (x3, 
E_DImode) != 0
          || !
#line 6514 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[5]),
				      UINTVAL (operands[2]),
				      UINTVAL(operands[3]))))
        return -1;
      return 853; /* *aarch64_bfidi5_shift_alt */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x16QImode)
          || GET_MODE (x3) != E_V2x16QImode
          || !register_operand (operands[1], E_V2x16QImode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4433; /* aarch64_simd_st2v16qi */

    case E_V2x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HImode)
          || GET_MODE (x3) != E_V2x8HImode
          || !register_operand (operands[1], E_V2x8HImode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4434; /* aarch64_simd_st2v8hi */

    case E_V2x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SImode)
          || GET_MODE (x3) != E_V2x4SImode
          || !register_operand (operands[1], E_V2x4SImode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4435; /* aarch64_simd_st2v4si */

    case E_V2x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DImode)
          || GET_MODE (x3) != E_V2x2DImode
          || !register_operand (operands[1], E_V2x2DImode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4436; /* aarch64_simd_st2v2di */

    case E_V2x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HFmode)
          || GET_MODE (x3) != E_V2x8HFmode
          || !register_operand (operands[1], E_V2x8HFmode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4437; /* aarch64_simd_st2v8hf */

    case E_V2x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SFmode)
          || GET_MODE (x3) != E_V2x4SFmode
          || !register_operand (operands[1], E_V2x4SFmode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4438; /* aarch64_simd_st2v4sf */

    case E_V2x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DFmode)
          || GET_MODE (x3) != E_V2x2DFmode
          || !register_operand (operands[1], E_V2x2DFmode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4439; /* aarch64_simd_st2v2df */

    case E_V2x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8BFmode)
          || GET_MODE (x3) != E_V2x8BFmode
          || !register_operand (operands[1], E_V2x8BFmode)
          || !
#line 7618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4440; /* aarch64_simd_st2v8bf */

    case E_V2x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !register_operand (operands[1], E_V2x8QImode)
          || !
#line 8687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5100; /* aarch64_st2v8qi_dreg */

    case E_V2x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !register_operand (operands[1], E_V2x4HImode)
          || !
#line 8687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5101; /* aarch64_st2v4hi_dreg */

    case E_V2x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !register_operand (operands[1], E_V2x2SImode)
          || !
#line 8687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5102; /* aarch64_st2v2si_dreg */

    case E_V2x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !register_operand (operands[1], E_V2x4HFmode)
          || !
#line 8687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5103; /* aarch64_st2v4hf_dreg */

    case E_V2x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !register_operand (operands[1], E_V2x2SFmode)
          || !
#line 8687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5104; /* aarch64_st2v2sf_dreg */

    case E_V2x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !register_operand (operands[1], E_V2x4BFmode)
          || !
#line 8687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5105; /* aarch64_st2v4bf_dreg */

    case E_V2x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !register_operand (operands[1], E_V2x1DImode)
          || !
#line 8697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5106; /* aarch64_st2di_dreg */

    case E_V2x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !register_operand (operands[1], E_V2x1DFmode)
          || !
#line 8697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5107; /* aarch64_st2df_dreg */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4465; /* aarch64_simd_ld3rv8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4466; /* aarch64_simd_ld3rv4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4467; /* aarch64_simd_ld3rv2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4468; /* aarch64_simd_ld3rdi */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4469; /* aarch64_simd_ld3rv4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4470; /* aarch64_simd_ld3rv2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4471; /* aarch64_simd_ld3rdf */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4472; /* aarch64_simd_ld3rv4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4473; /* aarch64_simd_ld3rv16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4474; /* aarch64_simd_ld3rv8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4475; /* aarch64_simd_ld3rv4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4476; /* aarch64_simd_ld3rv2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4477; /* aarch64_simd_ld3rv8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4478; /* aarch64_simd_ld3rv4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4479; /* aarch64_simd_ld3rv2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4480; /* aarch64_simd_ld3rv8bf */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8383 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4803; /* aarch64_ld2v8qi_dreg */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8383 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4804; /* aarch64_ld2v4hi_dreg */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8383 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4805; /* aarch64_ld2v2si_dreg */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8383 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4806; /* aarch64_ld2v4hf_dreg */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8383 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4807; /* aarch64_ld2v2sf_dreg */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8383 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4808; /* aarch64_ld2v4bf_dreg */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8393 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4809; /* aarch64_ld2di_dreg */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8393 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4810; /* aarch64_ld2df_dreg */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11146; /* aarch64_pmov_to_vnx16qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11147; /* aarch64_pmov_to_vnx8hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11148; /* aarch64_pmov_to_vnx4si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2BImode)
          || !
#line 154 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11149; /* aarch64_pmov_to_vnx2di */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5022; /* aarch64_rev64v8qi */

    case 1:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5031; /* aarch64_rev64v16qi */

    case 2:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5034; /* aarch64_rev64v4hi */

    case 3:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5043; /* aarch64_rev64v8hi */

    case 4:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5046; /* aarch64_rev64v2si */

    case 5:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5055; /* aarch64_rev64v4si */

    case 6:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5058; /* aarch64_rev64v2di */

    case 7:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5061; /* aarch64_rev64v4hf */

    case 8:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5070; /* aarch64_rev64v8hf */

    case 9:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5073; /* aarch64_rev64v4bf */

    case 10:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5082; /* aarch64_rev64v8bf */

    case 11:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5085; /* aarch64_rev64v2sf */

    case 12:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5094; /* aarch64_rev64v4sf */

    case 13:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5097; /* aarch64_rev64v2df */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern74 (x1))
    {
    case 0:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12922; /* aarch64_sve_zipqvnx64qi */

    case 1:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12924; /* aarch64_sve_zipqvnx32hi */

    case 2:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12926; /* aarch64_sve_zipqvnx16si */

    case 3:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12928; /* aarch64_sve_zipqvnx8di */

    case 4:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12930; /* aarch64_sve_zipqvnx32bf */

    case 5:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12932; /* aarch64_sve_zipqvnx32hf */

    case 6:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12934; /* aarch64_sve_zipqvnx16sf */

    case 7:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12936; /* aarch64_sve_zipqvnx8df */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern56 (x1))
    {
    case 0:
      if (!(
#line 6851 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 901; /* rinthf2 */

    case 1:
      if (!
#line 6851 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 908; /* rintsf2 */

    case 2:
      if (!
#line 6851 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 915; /* rintdf2 */

    case 3:
      if (!(
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2502; /* rintv4hf2 */

    case 4:
      if (!(
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2513; /* rintv8hf2 */

    case 5:
      if (!
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2530; /* rintv2sf2 */

    case 6:
      if (!
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2541; /* rintv4sf2 */

    case 7:
      if (!
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2548; /* rintv2df2 */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern604 (x2))
    {
    case 0:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5781; /* aarch64_load_extendvnx8hivnx8qi */

    case 1:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5783; /* aarch64_load_extendvnx8hivnx4qi */

    case 2:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5785; /* aarch64_load_extendvnx8hivnx2qi */

    case 3:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5787; /* aarch64_load_extendvnx8hivnx4hi */

    case 4:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5789; /* aarch64_load_extendvnx8hivnx2hi */

    case 5:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5791; /* aarch64_load_extendvnx8hivnx2si */

    case 6:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5793; /* aarch64_load_extendvnx4hivnx8qi */

    case 7:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5795; /* aarch64_load_extendvnx4hivnx4qi */

    case 8:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5797; /* aarch64_load_extendvnx4hivnx2qi */

    case 9:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5799; /* aarch64_load_extendvnx4hivnx4hi */

    case 10:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5801; /* aarch64_load_extendvnx4hivnx2hi */

    case 11:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5803; /* aarch64_load_extendvnx4hivnx2si */

    case 12:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5805; /* aarch64_load_extendvnx2hivnx8qi */

    case 13:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5807; /* aarch64_load_extendvnx2hivnx4qi */

    case 14:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5809; /* aarch64_load_extendvnx2hivnx2qi */

    case 15:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5811; /* aarch64_load_extendvnx2hivnx4hi */

    case 16:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5813; /* aarch64_load_extendvnx2hivnx2hi */

    case 17:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5815; /* aarch64_load_extendvnx2hivnx2si */

    case 18:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5817; /* aarch64_load_extendvnx4sivnx8qi */

    case 19:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5819; /* aarch64_load_extendvnx4sivnx4qi */

    case 20:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5821; /* aarch64_load_extendvnx4sivnx2qi */

    case 21:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5823; /* aarch64_load_extendvnx4sivnx4hi */

    case 22:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5825; /* aarch64_load_extendvnx4sivnx2hi */

    case 23:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5827; /* aarch64_load_extendvnx4sivnx2si */

    case 24:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5829; /* aarch64_load_extendvnx2sivnx8qi */

    case 25:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5831; /* aarch64_load_extendvnx2sivnx4qi */

    case 26:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5833; /* aarch64_load_extendvnx2sivnx2qi */

    case 27:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5835; /* aarch64_load_extendvnx2sivnx4hi */

    case 28:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5837; /* aarch64_load_extendvnx2sivnx2hi */

    case 29:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5839; /* aarch64_load_extendvnx2sivnx2si */

    case 30:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5841; /* aarch64_load_extendvnx2divnx8qi */

    case 31:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5843; /* aarch64_load_extendvnx2divnx4qi */

    case 32:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5845; /* aarch64_load_extendvnx2divnx2qi */

    case 33:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5847; /* aarch64_load_extendvnx2divnx4hi */

    case 34:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5849; /* aarch64_load_extendvnx2divnx2hi */

    case 35:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5851; /* aarch64_load_extendvnx2divnx2si */

    case 36:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5941; /* aarch64_ldff1_extendvnx8hivnx8qi */

    case 37:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5945; /* aarch64_ldff1_extendvnx8hivnx4qi */

    case 38:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5949; /* aarch64_ldff1_extendvnx8hivnx2qi */

    case 39:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5953; /* aarch64_ldff1_extendvnx8hivnx4hi */

    case 40:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5957; /* aarch64_ldff1_extendvnx8hivnx2hi */

    case 41:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5961; /* aarch64_ldff1_extendvnx8hivnx2si */

    case 42:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5965; /* aarch64_ldff1_extendvnx4hivnx8qi */

    case 43:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5969; /* aarch64_ldff1_extendvnx4hivnx4qi */

    case 44:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5973; /* aarch64_ldff1_extendvnx4hivnx2qi */

    case 45:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5977; /* aarch64_ldff1_extendvnx4hivnx4hi */

    case 46:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5981; /* aarch64_ldff1_extendvnx4hivnx2hi */

    case 47:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5985; /* aarch64_ldff1_extendvnx4hivnx2si */

    case 48:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5989; /* aarch64_ldff1_extendvnx2hivnx8qi */

    case 49:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5993; /* aarch64_ldff1_extendvnx2hivnx4qi */

    case 50:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5997; /* aarch64_ldff1_extendvnx2hivnx2qi */

    case 51:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6001; /* aarch64_ldff1_extendvnx2hivnx4hi */

    case 52:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6005; /* aarch64_ldff1_extendvnx2hivnx2hi */

    case 53:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6009; /* aarch64_ldff1_extendvnx2hivnx2si */

    case 54:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6013; /* aarch64_ldff1_extendvnx4sivnx8qi */

    case 55:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6017; /* aarch64_ldff1_extendvnx4sivnx4qi */

    case 56:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6021; /* aarch64_ldff1_extendvnx4sivnx2qi */

    case 57:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6025; /* aarch64_ldff1_extendvnx4sivnx4hi */

    case 58:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6029; /* aarch64_ldff1_extendvnx4sivnx2hi */

    case 59:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6033; /* aarch64_ldff1_extendvnx4sivnx2si */

    case 60:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6037; /* aarch64_ldff1_extendvnx2sivnx8qi */

    case 61:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6041; /* aarch64_ldff1_extendvnx2sivnx4qi */

    case 62:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6045; /* aarch64_ldff1_extendvnx2sivnx2qi */

    case 63:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6049; /* aarch64_ldff1_extendvnx2sivnx4hi */

    case 64:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6053; /* aarch64_ldff1_extendvnx2sivnx2hi */

    case 65:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6057; /* aarch64_ldff1_extendvnx2sivnx2si */

    case 66:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6061; /* aarch64_ldff1_extendvnx2divnx8qi */

    case 67:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6065; /* aarch64_ldff1_extendvnx2divnx4qi */

    case 68:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6069; /* aarch64_ldff1_extendvnx2divnx2qi */

    case 69:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6073; /* aarch64_ldff1_extendvnx2divnx4hi */

    case 70:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6077; /* aarch64_ldff1_extendvnx2divnx2hi */

    case 71:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6081; /* aarch64_ldff1_extendvnx2divnx2si */

    case 72:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5942; /* aarch64_ldnf1_extendvnx8hivnx8qi */

    case 73:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5946; /* aarch64_ldnf1_extendvnx8hivnx4qi */

    case 74:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5950; /* aarch64_ldnf1_extendvnx8hivnx2qi */

    case 75:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5954; /* aarch64_ldnf1_extendvnx8hivnx4hi */

    case 76:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5958; /* aarch64_ldnf1_extendvnx8hivnx2hi */

    case 77:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5962; /* aarch64_ldnf1_extendvnx8hivnx2si */

    case 78:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5966; /* aarch64_ldnf1_extendvnx4hivnx8qi */

    case 79:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5970; /* aarch64_ldnf1_extendvnx4hivnx4qi */

    case 80:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5974; /* aarch64_ldnf1_extendvnx4hivnx2qi */

    case 81:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5978; /* aarch64_ldnf1_extendvnx4hivnx4hi */

    case 82:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5982; /* aarch64_ldnf1_extendvnx4hivnx2hi */

    case 83:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5986; /* aarch64_ldnf1_extendvnx4hivnx2si */

    case 84:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5990; /* aarch64_ldnf1_extendvnx2hivnx8qi */

    case 85:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5994; /* aarch64_ldnf1_extendvnx2hivnx4qi */

    case 86:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5998; /* aarch64_ldnf1_extendvnx2hivnx2qi */

    case 87:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6002; /* aarch64_ldnf1_extendvnx2hivnx4hi */

    case 88:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6006; /* aarch64_ldnf1_extendvnx2hivnx2hi */

    case 89:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6010; /* aarch64_ldnf1_extendvnx2hivnx2si */

    case 90:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6014; /* aarch64_ldnf1_extendvnx4sivnx8qi */

    case 91:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6018; /* aarch64_ldnf1_extendvnx4sivnx4qi */

    case 92:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6022; /* aarch64_ldnf1_extendvnx4sivnx2qi */

    case 93:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6026; /* aarch64_ldnf1_extendvnx4sivnx4hi */

    case 94:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6030; /* aarch64_ldnf1_extendvnx4sivnx2hi */

    case 95:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6034; /* aarch64_ldnf1_extendvnx4sivnx2si */

    case 96:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6038; /* aarch64_ldnf1_extendvnx2sivnx8qi */

    case 97:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6042; /* aarch64_ldnf1_extendvnx2sivnx4qi */

    case 98:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6046; /* aarch64_ldnf1_extendvnx2sivnx2qi */

    case 99:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6050; /* aarch64_ldnf1_extendvnx2sivnx4hi */

    case 100:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6054; /* aarch64_ldnf1_extendvnx2sivnx2hi */

    case 101:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6058; /* aarch64_ldnf1_extendvnx2sivnx2si */

    case 102:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6062; /* aarch64_ldnf1_extendvnx2divnx8qi */

    case 103:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6066; /* aarch64_ldnf1_extendvnx2divnx4qi */

    case 104:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6070; /* aarch64_ldnf1_extendvnx2divnx2qi */

    case 105:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6074; /* aarch64_ldnf1_extendvnx2divnx4hi */

    case 106:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6078; /* aarch64_ldnf1_extendvnx2divnx2hi */

    case 107:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6082; /* aarch64_ldnf1_extendvnx2divnx2si */

    case 108:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5853; /* *aarch64_load_extend_movvnx8hivnx8qi */

    case 109:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5855; /* *aarch64_load_extend_movvnx8hivnx4qi */

    case 110:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5857; /* *aarch64_load_extend_movvnx8hivnx2qi */

    case 111:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5859; /* *aarch64_load_extend_movvnx8hivnx4hi */

    case 112:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5861; /* *aarch64_load_extend_movvnx8hivnx2hi */

    case 113:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5863; /* *aarch64_load_extend_movvnx8hivnx2si */

    case 114:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5865; /* *aarch64_load_extend_movvnx4hivnx8qi */

    case 115:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5867; /* *aarch64_load_extend_movvnx4hivnx4qi */

    case 116:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5869; /* *aarch64_load_extend_movvnx4hivnx2qi */

    case 117:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5871; /* *aarch64_load_extend_movvnx4hivnx4hi */

    case 118:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5873; /* *aarch64_load_extend_movvnx4hivnx2hi */

    case 119:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5875; /* *aarch64_load_extend_movvnx4hivnx2si */

    case 120:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5877; /* *aarch64_load_extend_movvnx2hivnx8qi */

    case 121:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5879; /* *aarch64_load_extend_movvnx2hivnx4qi */

    case 122:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5881; /* *aarch64_load_extend_movvnx2hivnx2qi */

    case 123:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5883; /* *aarch64_load_extend_movvnx2hivnx4hi */

    case 124:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5885; /* *aarch64_load_extend_movvnx2hivnx2hi */

    case 125:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5887; /* *aarch64_load_extend_movvnx2hivnx2si */

    case 126:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5889; /* *aarch64_load_extend_movvnx4sivnx8qi */

    case 127:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5891; /* *aarch64_load_extend_movvnx4sivnx4qi */

    case 128:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5893; /* *aarch64_load_extend_movvnx4sivnx2qi */

    case 129:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5895; /* *aarch64_load_extend_movvnx4sivnx4hi */

    case 130:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5897; /* *aarch64_load_extend_movvnx4sivnx2hi */

    case 131:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5899; /* *aarch64_load_extend_movvnx4sivnx2si */

    case 132:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5901; /* *aarch64_load_extend_movvnx2sivnx8qi */

    case 133:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5903; /* *aarch64_load_extend_movvnx2sivnx4qi */

    case 134:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5905; /* *aarch64_load_extend_movvnx2sivnx2qi */

    case 135:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5907; /* *aarch64_load_extend_movvnx2sivnx4hi */

    case 136:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5909; /* *aarch64_load_extend_movvnx2sivnx2hi */

    case 137:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5911; /* *aarch64_load_extend_movvnx2sivnx2si */

    case 138:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5913; /* *aarch64_load_extend_movvnx2divnx8qi */

    case 139:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5915; /* *aarch64_load_extend_movvnx2divnx4qi */

    case 140:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5917; /* *aarch64_load_extend_movvnx2divnx2qi */

    case 141:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5919; /* *aarch64_load_extend_movvnx2divnx4hi */

    case 142:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5921; /* *aarch64_load_extend_movvnx2divnx2hi */

    case 143:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5923; /* *aarch64_load_extend_movvnx2divnx2si */

    case 144:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 6139; /* aarch64_gather_load_extendvnx4hivnx4qi */

    case 145:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 6143; /* aarch64_gather_load_extendvnx4hivnx4hi */

    case 146:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6141; /* aarch64_gather_load_extendvnx4sivnx4qi */

    case 147:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6145; /* aarch64_gather_load_extendvnx4sivnx4hi */

    case 148:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6147; /* aarch64_gather_load_extendvnx2hivnx2qi */

    case 149:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6153; /* aarch64_gather_load_extendvnx2hivnx2hi */

    case 150:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6159; /* aarch64_gather_load_extendvnx2hivnx2si */

    case 151:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6149; /* aarch64_gather_load_extendvnx2sivnx2qi */

    case 152:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6155; /* aarch64_gather_load_extendvnx2sivnx2hi */

    case 153:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6161; /* aarch64_gather_load_extendvnx2sivnx2si */

    case 154:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6151; /* aarch64_gather_load_extendvnx2divnx2qi */

    case 155:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6157; /* aarch64_gather_load_extendvnx2divnx2hi */

    case 156:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6163; /* aarch64_gather_load_extendvnx2divnx2si */

    case 157:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6165; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw_unpacked */

    case 158:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6177; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw_unpacked */

    case 159:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6189; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw_unpacked */

    case 160:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6169; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw_unpacked */

    case 161:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6181; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw_unpacked */

    case 162:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6193; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw_unpacked */

    case 163:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6173; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw_unpacked */

    case 164:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6185; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw_unpacked */

    case 165:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6197; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw_unpacked */

    case 166:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6201; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw */

    case 167:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6207; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw */

    case 168:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6213; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw */

    case 169:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6203; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw */

    case 170:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6209; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw */

    case 171:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6215; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw */

    case 172:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6205; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw */

    case 173:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6211; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw */

    case 174:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6217; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw */

    case 175:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6167; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw_unpacked */

    case 176:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6179; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw_unpacked */

    case 177:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6191; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw_unpacked */

    case 178:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6171; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw_unpacked */

    case 179:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6183; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw_unpacked */

    case 180:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6195; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw_unpacked */

    case 181:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6175; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw_unpacked */

    case 182:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6187; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw_unpacked */

    case 183:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6199; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw_unpacked */

    case 184:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6219; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw */

    case 185:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6225; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw */

    case 186:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6231; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw */

    case 187:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6221; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw */

    case 188:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6227; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw */

    case 189:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6233; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw */

    case 190:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6223; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw */

    case 191:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6229; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw */

    case 192:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6235; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw */

    case 193:
      if (!
#line 1976 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6245; /* aarch64_ldff1_gather_extendvnx4sivnx4qi */

    case 194:
      if (!
#line 1976 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6247; /* aarch64_ldff1_gather_extendvnx4sivnx4hi */

    case 195:
      if (!
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6249; /* aarch64_ldff1_gather_extendvnx2divnx2qi */

    case 196:
      if (!
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6251; /* aarch64_ldff1_gather_extendvnx2divnx2hi */

    case 197:
      if (!
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6253; /* aarch64_ldff1_gather_extendvnx2divnx2si */

    case 198:
      if (!
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6255; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_sxtw */

    case 199:
      if (!
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6257; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_sxtw */

    case 200:
      if (!
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6259; /* *aarch64_ldff1_gather_extendvnx2divnx2si_sxtw */

    case 201:
      if (!
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6261; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_uxtw */

    case 202:
      if (!
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6263; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_uxtw */

    case 203:
      if (!
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6265; /* *aarch64_ldff1_gather_extendvnx2divnx2si_uxtw */

    case 204:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 11259; /* aarch64_gather_ldnt_extendvnx4sivnx8qi */

    case 205:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 11261; /* aarch64_gather_ldnt_extendvnx4sivnx4qi */

    case 206:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 11263; /* aarch64_gather_ldnt_extendvnx4sivnx2qi */

    case 207:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 11265; /* aarch64_gather_ldnt_extendvnx4sivnx4hi */

    case 208:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 11267; /* aarch64_gather_ldnt_extendvnx4sivnx2hi */

    case 209:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 11269; /* aarch64_gather_ldnt_extendvnx4sivnx2si */

    case 210:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 11271; /* aarch64_gather_ldnt_extendvnx2divnx8qi */

    case 211:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 11273; /* aarch64_gather_ldnt_extendvnx2divnx4qi */

    case 212:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 11275; /* aarch64_gather_ldnt_extendvnx2divnx2qi */

    case 213:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 11277; /* aarch64_gather_ldnt_extendvnx2divnx4hi */

    case 214:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 11279; /* aarch64_gather_ldnt_extendvnx2divnx2hi */

    case 215:
      if (!
#line 398 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 11281; /* aarch64_gather_ldnt_extendvnx2divnx2si */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12875; /* aarch64_sve_uzpvnx32qi */

    case 1:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12877; /* aarch64_sve_uzpvnx16hi */

    case 2:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12879; /* aarch64_sve_uzpvnx8si */

    case 3:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12881; /* aarch64_sve_uzpvnx4di */

    case 4:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12883; /* aarch64_sve_uzpvnx16bf */

    case 5:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12885; /* aarch64_sve_uzpvnx16hf */

    case 6:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12887; /* aarch64_sve_uzpvnx8sf */

    case 7:
      if (!
#line 3875 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12889; /* aarch64_sve_uzpvnx4df */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern729 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10473; /* aarch64_sve_compactvnx4si */

    case E_VNx2DImode:
      if (pattern729 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10474; /* aarch64_sve_compactvnx2di */

    case E_VNx4SFmode:
      if (pattern729 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10475; /* aarch64_sve_compactvnx4sf */

    case E_VNx2DFmode:
      if (pattern729 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10476; /* aarch64_sve_compactvnx2df */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern78 (x1))
    {
    case 0:
      return 1042; /* ucvtfsi3 */

    case 1:
      return 1044; /* ucvtfdi3 */

    case 2:
      if (!
#line 7234 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1050; /* ucvtfsihf3 */

    case 3:
      if (!
#line 7234 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1052; /* ucvtfdihf3 */

    case 4:
      if (!
#line 7254 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1056; /* ucvtfhi3 */

    case 5:
      if (!(
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 291 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2643; /* ucvtfv4hi3 */

    case 6:
      if (!(
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 292 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2645; /* ucvtfv8hi3 */

    case 7:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2647; /* ucvtfv2si3 */

    case 8:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2649; /* ucvtfv4si3 */

    case 9:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2651; /* ucvtfv2di3 */

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern79 (x3, 
E_V8QImode) != 0
          || !
#line 5036 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3217; /* aarch64_pmulv8qi */

    case E_V16QImode:
      if (pattern79 (x3, 
E_V16QImode) != 0
          || !
#line 5036 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3218; /* aarch64_pmulv16qi */

    case E_VNx16QImode:
      if (pattern79 (x3, 
E_VNx16QImode) != 0
          || !
#line 3610 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12680; /* aarch64_sve2_pmulvnx16qi */

    default:
      return -1;
    }
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern89 (x1))
    {
    case 0:
      if (!(
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1403; /* aarch64_fcadd270v4hf */

    case 1:
      if (!(
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1407; /* aarch64_fcadd270v8hf */

    case 2:
      if (!
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
        return -1;
      return 1411; /* aarch64_fcadd270v2sf */

    case 3:
      if (!
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
        return -1;
      return 1415; /* aarch64_fcadd270v4sf */

    case 4:
      if (!
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
        return -1;
      return 1417; /* aarch64_fcadd270v2df */

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern142 (x1))
    {
    case 0:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12773; /* aarch64_pred_reduc_eorqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12781; /* aarch64_pred_reduc_eorqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12789; /* aarch64_pred_reduc_eorqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12797; /* aarch64_pred_reduc_eorqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern121 (x1))
    {
    case 0:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 8))
        return -1;
      return 10403; /* aarch64_pred_reduc_sadd_vnx16qi */

    case 1:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10405; /* aarch64_pred_reduc_sadd_vnx8hi */

    case 2:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10407; /* aarch64_pred_reduc_sadd_vnx4si */

    case 3:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10409; /* aarch64_pred_reduc_sadd_vnx2di */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1119 (x2))
        {
        case 0:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10866; /* *cond_fix_trunc_nontruncvnx8hfvnx8hi_relaxed */
          break;

        case 1:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10868; /* *cond_fix_trunc_nontruncvnx4sfvnx8hi_relaxed */
          break;

        case 2:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10870; /* *cond_fix_trunc_nontruncvnx2dfvnx8hi_relaxed */
          break;

        case 3:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10872; /* *cond_fix_trunc_nontruncvnx8hfvnx4si_relaxed */
          break;

        case 4:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10874; /* *cond_fix_trunc_nontruncvnx4sfvnx4si_relaxed */
          break;

        case 5:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10876; /* *cond_fix_trunc_nontruncvnx2dfvnx4si_relaxed */
          break;

        case 6:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10878; /* *cond_fix_trunc_nontruncvnx8hfvnx2di_relaxed */
          break;

        case 7:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10880; /* *cond_fix_trunc_nontruncvnx4sfvnx2di_relaxed */
          break;

        case 8:
          if (
#line 9459 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10882; /* *cond_fix_trunc_nontruncvnx2dfvnx2di_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (pattern1120 (x2))
        {
        case 0:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10884; /* *cond_fix_trunc_nontruncvnx8hfvnx8hi_strict */
          break;

        case 1:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10886; /* *cond_fix_trunc_nontruncvnx4sfvnx8hi_strict */
          break;

        case 2:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10888; /* *cond_fix_trunc_nontruncvnx2dfvnx8hi_strict */
          break;

        case 3:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10890; /* *cond_fix_trunc_nontruncvnx8hfvnx4si_strict */
          break;

        case 4:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10892; /* *cond_fix_trunc_nontruncvnx4sfvnx4si_strict */
          break;

        case 5:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10894; /* *cond_fix_trunc_nontruncvnx2dfvnx4si_strict */
          break;

        case 6:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10896; /* *cond_fix_trunc_nontruncvnx8hfvnx2di_strict */
          break;

        case 7:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10898; /* *cond_fix_trunc_nontruncvnx4sfvnx2di_strict */
          break;

        case 8:
          if (
#line 9482 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10900; /* *cond_fix_trunc_nontruncvnx2dfvnx2di_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
      || pattern1121 (x2, 
E_VNx2DFmode, 
E_VNx4SImode) != 0
      || !
#line 9516 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 10902; /* *cond_fix_trunc_truncvnx2dfvnx4si */
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11826; /* *cond_uqshlvnx16qi_2 */
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11834; /* *cond_uqshlvnx16qi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11842; /* *cond_uqshlvnx16qi_any */
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11689; /* *cond_urshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11734; /* *cond_urshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11774; /* *cond_urshlvnx8hi_any */
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11711; /* *cond_uqrshlvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11752; /* *cond_uqrshlvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11792; /* *cond_uqrshlvnx2di_any */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11697; /* *cond_uhaddvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11740; /* *cond_uhaddvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11780; /* *cond_uhaddvnx4si_any */
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11670; /* *cond_srhaddvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11718; /* *cond_srhaddvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11758; /* *cond_srhaddvnx16qi_any */
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern860 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8395; /* *cond_asrdvnx16qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8435; /* *cond_asrdvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8399; /* *cond_asrdvnx8qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8439; /* *cond_asrdvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8403; /* *cond_asrdvnx4qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8443; /* *cond_asrdvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8407; /* *cond_asrdvnx2qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8447; /* *cond_asrdvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8411; /* *cond_asrdvnx8hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8451; /* *cond_asrdvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8415; /* *cond_asrdvnx4hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8455; /* *cond_asrdvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8419; /* *cond_asrdvnx2hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8459; /* *cond_asrdvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8423; /* *cond_asrdvnx4si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8463; /* *cond_asrdvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8427; /* *cond_asrdvnx2si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8467; /* *cond_asrdvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8431; /* *cond_asrdvnx2di_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8471; /* *cond_asrdvnx2di_any */

    case 10:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8396; /* *cond_sqshluvnx16qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8436; /* *cond_sqshluvnx16qi_any */

    case 11:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8400; /* *cond_sqshluvnx8qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8440; /* *cond_sqshluvnx8qi_any */

    case 12:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8404; /* *cond_sqshluvnx4qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8444; /* *cond_sqshluvnx4qi_any */

    case 13:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8408; /* *cond_sqshluvnx2qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8448; /* *cond_sqshluvnx2qi_any */

    case 14:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8412; /* *cond_sqshluvnx8hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8452; /* *cond_sqshluvnx8hi_any */

    case 15:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8416; /* *cond_sqshluvnx4hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8456; /* *cond_sqshluvnx4hi_any */

    case 16:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8420; /* *cond_sqshluvnx2hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8460; /* *cond_sqshluvnx2hi_any */

    case 17:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8424; /* *cond_sqshluvnx4si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8464; /* *cond_sqshluvnx4si_any */

    case 18:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8428; /* *cond_sqshluvnx2si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8468; /* *cond_sqshluvnx2si_any */

    case 19:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8432; /* *cond_sqshluvnx2di_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3262 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8472; /* *cond_sqshluvnx2di_any */

    case 20:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8397; /* *cond_srshrvnx16qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8437; /* *cond_srshrvnx16qi_any */

    case 21:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8401; /* *cond_srshrvnx8qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8441; /* *cond_srshrvnx8qi_any */

    case 22:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8405; /* *cond_srshrvnx4qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8445; /* *cond_srshrvnx4qi_any */

    case 23:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8409; /* *cond_srshrvnx2qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8449; /* *cond_srshrvnx2qi_any */

    case 24:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8413; /* *cond_srshrvnx8hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8453; /* *cond_srshrvnx8hi_any */

    case 25:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8417; /* *cond_srshrvnx4hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8457; /* *cond_srshrvnx4hi_any */

    case 26:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8421; /* *cond_srshrvnx2hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8461; /* *cond_srshrvnx2hi_any */

    case 27:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8425; /* *cond_srshrvnx4si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8465; /* *cond_srshrvnx4si_any */

    case 28:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8429; /* *cond_srshrvnx2si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8469; /* *cond_srshrvnx2si_any */

    case 29:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8433; /* *cond_srshrvnx2di_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3263 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8473; /* *cond_srshrvnx2di_any */

    case 30:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8398; /* *cond_urshrvnx16qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8438; /* *cond_urshrvnx16qi_any */

    case 31:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8402; /* *cond_urshrvnx8qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8442; /* *cond_urshrvnx8qi_any */

    case 32:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8406; /* *cond_urshrvnx4qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8446; /* *cond_urshrvnx4qi_any */

    case 33:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8410; /* *cond_urshrvnx2qi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8450; /* *cond_urshrvnx2qi_any */

    case 34:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8414; /* *cond_urshrvnx8hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8454; /* *cond_urshrvnx8hi_any */

    case 35:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8418; /* *cond_urshrvnx4hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8458; /* *cond_urshrvnx4hi_any */

    case 36:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8422; /* *cond_urshrvnx2hi_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8462; /* *cond_urshrvnx2hi_any */

    case 37:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8426; /* *cond_urshrvnx4si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8466; /* *cond_urshrvnx4si_any */

    case 38:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8430; /* *cond_urshrvnx2si_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8470; /* *cond_urshrvnx2si_any */

    case 39:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 8434; /* *cond_urshrvnx2di_2 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 5135 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3264 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 8474; /* *cond_urshrvnx2di_any */

    case 40:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11667; /* *cond_shaddvnx16qi_2 */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11715; /* *cond_shaddvnx16qi_3 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 11755; /* *cond_shaddvnx16qi_any */

    case 41:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11679; /* *cond_shaddvnx8hi_2 */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11725; /* *cond_shaddvnx8hi_3 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 11765; /* *cond_shaddvnx8hi_any */

    case 42:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11691; /* *cond_shaddvnx4si_2 */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11735; /* *cond_shaddvnx4si_3 */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 11775; /* *cond_shaddvnx4si_any */

    case 43:
      return recog_253 (x1, insn, pnum_clobbers);

    case 44:
      return recog_252 (x1, insn, pnum_clobbers);

    case 45:
      return recog_251 (x1, insn, pnum_clobbers);

    case 46:
      return recog_250 (x1, insn, pnum_clobbers);

    case 47:
      return recog_249 (x1, insn, pnum_clobbers);

    case 48:
      return recog_248 (x1, insn, pnum_clobbers);

    case 49:
      return recog_247 (x1, insn, pnum_clobbers);

    case 50:
      return recog_246 (x1, insn, pnum_clobbers);

    case 51:
      return recog_245 (x1, insn, pnum_clobbers);

    case 52:
      return recog_244 (x1, insn, pnum_clobbers);

    case 53:
      return recog_243 (x1, insn, pnum_clobbers);

    case 54:
      return recog_242 (x1, insn, pnum_clobbers);

    case 55:
      return recog_241 (x1, insn, pnum_clobbers);

    case 56:
      return recog_240 (x1, insn, pnum_clobbers);

    case 57:
      return recog_239 (x1, insn, pnum_clobbers);

    case 58:
      return recog_238 (x1, insn, pnum_clobbers);

    case 59:
      return recog_237 (x1, insn, pnum_clobbers);

    case 60:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11672; /* *cond_suqaddvnx16qi_2 */

    case 61:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11684; /* *cond_suqaddvnx8hi_2 */

    case 62:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11696; /* *cond_suqaddvnx4si_2 */

    case 63:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11708; /* *cond_suqaddvnx2di_2 */

    case 64:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11795; /* *cond_suqaddvnx16qi_z */

    case 65:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11797; /* *cond_suqaddvnx8hi_z */

    case 66:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11799; /* *cond_suqaddvnx4si_z */

    case 67:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11801; /* *cond_suqaddvnx2di_z */

    case 68:
      return recog_236 (x1, insn, pnum_clobbers);

    case 69:
      return recog_235 (x1, insn, pnum_clobbers);

    case 70:
      return recog_234 (x1, insn, pnum_clobbers);

    case 71:
      return recog_233 (x1, insn, pnum_clobbers);

    case 72:
      return recog_232 (x1, insn, pnum_clobbers);

    case 73:
      return recog_231 (x1, insn, pnum_clobbers);

    case 74:
      return recog_230 (x1, insn, pnum_clobbers);

    case 75:
      return recog_229 (x1, insn, pnum_clobbers);

    case 76:
      return recog_228 (x1, insn, pnum_clobbers);

    case 77:
      return recog_227 (x1, insn, pnum_clobbers);

    case 78:
      return recog_226 (x1, insn, pnum_clobbers);

    case 79:
      return recog_225 (x1, insn, pnum_clobbers);

    case 80:
      return recog_224 (x1, insn, pnum_clobbers);

    case 81:
      return recog_223 (x1, insn, pnum_clobbers);

    case 82:
      return recog_222 (x1, insn, pnum_clobbers);

    case 83:
      return recog_221 (x1, insn, pnum_clobbers);

    case 84:
      return recog_220 (x1, insn, pnum_clobbers);

    case 85:
      return recog_219 (x1, insn, pnum_clobbers);

    case 86:
      return recog_218 (x1, insn, pnum_clobbers);

    case 87:
      return recog_217 (x1, insn, pnum_clobbers);

    case 88:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11678; /* *cond_usqaddvnx16qi_2 */

    case 89:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11690; /* *cond_usqaddvnx8hi_2 */

    case 90:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11702; /* *cond_usqaddvnx4si_2 */

    case 91:
      if (!
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11714; /* *cond_usqaddvnx2di_2 */

    case 92:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11796; /* *cond_usqaddvnx16qi_z */

    case 93:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11798; /* *cond_usqaddvnx8hi_z */

    case 94:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11800; /* *cond_usqaddvnx4si_z */

    case 95:
      if (!
#line 1135 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11802; /* *cond_usqaddvnx2di_z */

    case 96:
      return recog_216 (x1, insn, pnum_clobbers);

    case 97:
      return recog_215 (x1, insn, pnum_clobbers);

    case 98:
      return recog_214 (x1, insn, pnum_clobbers);

    case 99:
      return recog_213 (x1, insn, pnum_clobbers);

    case 100:
      return recog_212 (x1, insn, pnum_clobbers);

    case 101:
      return recog_211 (x1, insn, pnum_clobbers);

    case 102:
      return recog_210 (x1, insn, pnum_clobbers);

    case 103:
      return recog_209 (x1, insn, pnum_clobbers);

    case 104:
      if (!
#line 3503 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12669; /* *cond_urecpevnx4si */

    case 105:
      if (!
#line 3503 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12670; /* *cond_ursqrtevnx4si */

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern732 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7490; /* *cond_ussubvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7660; /* *cond_ussubvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7830; /* *cond_ussubvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7507; /* *cond_ussubvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7677; /* *cond_ussubvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7847; /* *cond_ussubvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7524; /* *cond_ussubvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7694; /* *cond_ussubvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7864; /* *cond_ussubvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7541; /* *cond_ussubvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7711; /* *cond_ussubvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7881; /* *cond_ussubvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7558; /* *cond_ussubvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7728; /* *cond_ussubvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7898; /* *cond_ussubvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7575; /* *cond_ussubvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7745; /* *cond_ussubvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7915; /* *cond_ussubvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7592; /* *cond_ussubvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7762; /* *cond_ussubvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7932; /* *cond_ussubvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7609; /* *cond_ussubvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7779; /* *cond_ussubvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7949; /* *cond_ussubvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7626; /* *cond_ussubvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7796; /* *cond_ussubvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7966; /* *cond_ussubvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7643; /* *cond_ussubvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7813; /* *cond_ussubvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7983; /* *cond_ussubvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_288 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern732 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7479; /* *cond_sminvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7649; /* *cond_sminvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7819; /* *cond_sminvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7496; /* *cond_sminvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7666; /* *cond_sminvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7836; /* *cond_sminvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7513; /* *cond_sminvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7683; /* *cond_sminvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7853; /* *cond_sminvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7530; /* *cond_sminvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7700; /* *cond_sminvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7870; /* *cond_sminvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7547; /* *cond_sminvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7717; /* *cond_sminvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7887; /* *cond_sminvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7564; /* *cond_sminvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7734; /* *cond_sminvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7904; /* *cond_sminvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7581; /* *cond_sminvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7751; /* *cond_sminvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7921; /* *cond_sminvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7598; /* *cond_sminvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7768; /* *cond_sminvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7938; /* *cond_sminvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7615; /* *cond_sminvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7785; /* *cond_sminvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7955; /* *cond_sminvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7632; /* *cond_sminvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7802; /* *cond_sminvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7972; /* *cond_sminvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case VEC_DUPLICATE:
          return recog_274 (x1, insn, pnum_clobbers);

        case ABS:
          switch (pattern612 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6731; /* *cond_absvnx16qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6821; /* *cond_absvnx16qi_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6740; /* *cond_absvnx8qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6830; /* *cond_absvnx8qi_any */

            case 2:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6749; /* *cond_absvnx4qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6839; /* *cond_absvnx4qi_any */

            case 3:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6758; /* *cond_absvnx2qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6848; /* *cond_absvnx2qi_any */

            case 4:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6767; /* *cond_absvnx8hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6857; /* *cond_absvnx8hi_any */

            case 5:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6776; /* *cond_absvnx4hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6866; /* *cond_absvnx4hi_any */

            case 6:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6785; /* *cond_absvnx2hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6875; /* *cond_absvnx2hi_any */

            case 7:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6794; /* *cond_absvnx4si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6884; /* *cond_absvnx4si_any */

            case 8:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6803; /* *cond_absvnx2si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6893; /* *cond_absvnx2si_any */

            case 9:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6812; /* *cond_absvnx2di_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6902; /* *cond_absvnx2di_any */

            default:
              return -1;
            }

        case NEG:
          switch (pattern612 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6732; /* *cond_negvnx16qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6822; /* *cond_negvnx16qi_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6741; /* *cond_negvnx8qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6831; /* *cond_negvnx8qi_any */

            case 2:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6750; /* *cond_negvnx4qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6840; /* *cond_negvnx4qi_any */

            case 3:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6759; /* *cond_negvnx2qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6849; /* *cond_negvnx2qi_any */

            case 4:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6768; /* *cond_negvnx8hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6858; /* *cond_negvnx8hi_any */

            case 5:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6777; /* *cond_negvnx4hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6867; /* *cond_negvnx4hi_any */

            case 6:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6786; /* *cond_negvnx2hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6876; /* *cond_negvnx2hi_any */

            case 7:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6795; /* *cond_negvnx4si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6885; /* *cond_negvnx4si_any */

            case 8:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6804; /* *cond_negvnx2si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6894; /* *cond_negvnx2si_any */

            case 9:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6813; /* *cond_negvnx2di_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6903; /* *cond_negvnx2di_any */

            default:
              return -1;
            }

        case NOT:
          switch (pattern612 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6733; /* *cond_one_cmplvnx16qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6823; /* *cond_one_cmplvnx16qi_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6742; /* *cond_one_cmplvnx8qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6832; /* *cond_one_cmplvnx8qi_any */

            case 2:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6751; /* *cond_one_cmplvnx4qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6841; /* *cond_one_cmplvnx4qi_any */

            case 3:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6760; /* *cond_one_cmplvnx2qi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6850; /* *cond_one_cmplvnx2qi_any */

            case 4:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6769; /* *cond_one_cmplvnx8hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6859; /* *cond_one_cmplvnx8hi_any */

            case 5:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6778; /* *cond_one_cmplvnx4hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6868; /* *cond_one_cmplvnx4hi_any */

            case 6:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6787; /* *cond_one_cmplvnx2hi_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6877; /* *cond_one_cmplvnx2hi_any */

            case 7:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6796; /* *cond_one_cmplvnx4si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6886; /* *cond_one_cmplvnx4si_any */

            case 8:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6805; /* *cond_one_cmplvnx2si_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6895; /* *cond_one_cmplvnx2si_any */

            case 9:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 6814; /* *cond_one_cmplvnx2di_2 */
              operands[3] = x6;
              if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
                  || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 6904; /* *cond_one_cmplvnx2di_any */

            default:
              return -1;
            }

        case CLRSB:
          return recog_297 (x1, insn, pnum_clobbers);

        case CLZ:
          return recog_296 (x1, insn, pnum_clobbers);

        case POPCOUNT:
          return recog_295 (x1, insn, pnum_clobbers);

        case BITREVERSE:
          return recog_294 (x1, insn, pnum_clobbers);

        case SS_ABS:
          return recog_292 (x1, insn, pnum_clobbers);

        case SS_NEG:
          return recog_293 (x1, insn, pnum_clobbers);

        case UNSPEC:
          return recog_279 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != TRUNCATE)
            return -1;
          operands[1] = x4;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          x6 = XVECEXP (x3, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              switch (pattern998 (x3, 
E_VNx8HImode, 
E_VNx8BImode))
                {
                case 0:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x81) == 0))
                    return -1;
                  return 7082; /* aarch64_cond_sxtvnx8hivnx8qi */

                case 1:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x41) == 0))
                    return -1;
                  return 7083; /* aarch64_cond_sxtvnx8hivnx4qi */

                case 2:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x21) == 0))
                    return -1;
                  return 7084; /* aarch64_cond_sxtvnx8hivnx2qi */

                case 3:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x42) == 0))
                    return -1;
                  return 7085; /* aarch64_cond_sxtvnx8hivnx4hi */

                case 4:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x22) == 0))
                    return -1;
                  return 7086; /* aarch64_cond_sxtvnx8hivnx2hi */

                case 5:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x81 & 0x24) == 0))
                    return -1;
                  return 7087; /* aarch64_cond_sxtvnx8hivnx2si */

                default:
                  return -1;
                }

            case E_VNx4SImode:
              switch (pattern998 (x3, 
E_VNx4SImode, 
E_VNx4BImode))
                {
                case 0:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x81) == 0))
                    return -1;
                  return 7088; /* aarch64_cond_sxtvnx4sivnx8qi */

                case 1:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x41) == 0))
                    return -1;
                  return 7089; /* aarch64_cond_sxtvnx4sivnx4qi */

                case 2:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x21) == 0))
                    return -1;
                  return 7090; /* aarch64_cond_sxtvnx4sivnx2qi */

                case 3:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x42) == 0))
                    return -1;
                  return 7091; /* aarch64_cond_sxtvnx4sivnx4hi */

                case 4:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x22) == 0))
                    return -1;
                  return 7092; /* aarch64_cond_sxtvnx4sivnx2hi */

                case 5:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x43 & 0x24) == 0))
                    return -1;
                  return 7093; /* aarch64_cond_sxtvnx4sivnx2si */

                default:
                  return -1;
                }

            case E_VNx2DImode:
              switch (pattern998 (x3, 
E_VNx2DImode, 
E_VNx2BImode))
                {
                case 0:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x81) == 0))
                    return -1;
                  return 7094; /* aarch64_cond_sxtvnx2divnx8qi */

                case 1:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x41) == 0))
                    return -1;
                  return 7095; /* aarch64_cond_sxtvnx2divnx4qi */

                case 2:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x21) == 0))
                    return -1;
                  return 7096; /* aarch64_cond_sxtvnx2divnx2qi */

                case 3:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x42) == 0))
                    return -1;
                  return 7097; /* aarch64_cond_sxtvnx2divnx4hi */

                case 4:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x22) == 0))
                    return -1;
                  return 7098; /* aarch64_cond_sxtvnx2divnx2hi */

                case 5:
                  if (!
#line 3389 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~0x27 & 0x24) == 0))
                    return -1;
                  return 7099; /* aarch64_cond_sxtvnx2divnx2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          return recog_273 (x1, insn, pnum_clobbers);

        case PLUS:
          return recog_275 (x1, insn, pnum_clobbers);

        case MINUS:
          return recog_272 (x1, insn, pnum_clobbers);

        case MULT:
          return recog_291 (x1, insn, pnum_clobbers);

        case SMAX:
          return recog_290 (x1, insn, pnum_clobbers);

        case UMAX:
          return recog_289 (x1, insn, pnum_clobbers);

        case SMIN:
          return recog_288 (x1, insn, pnum_clobbers);

        case UMIN:
          return recog_287 (x1, insn, pnum_clobbers);

        case ASHIFT:
          return recog_276 (x1, insn, pnum_clobbers);

        case ASHIFTRT:
          return recog_277 (x1, insn, pnum_clobbers);

        case LSHIFTRT:
          return recog_278 (x1, insn, pnum_clobbers);

        case IOR:
          return recog_286 (x1, insn, pnum_clobbers);

        case XOR:
          return recog_285 (x1, insn, pnum_clobbers);

        case SS_PLUS:
          return recog_284 (x1, insn, pnum_clobbers);

        case US_PLUS:
          return recog_283 (x1, insn, pnum_clobbers);

        case SS_MINUS:
          return recog_282 (x1, insn, pnum_clobbers);

        case US_MINUS:
          return recog_281 (x1, insn, pnum_clobbers);

        case DIV:
          switch (pattern615 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8158; /* *cond_divvnx4si_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8162; /* *cond_divvnx4si_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8166; /* *cond_divvnx4si_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8160; /* *cond_divvnx2di_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8164; /* *cond_divvnx2di_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8168; /* *cond_divvnx2di_any */

            default:
              return -1;
            }

        case UDIV:
          switch (pattern615 (x3))
            {
            case 0:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8159; /* *cond_udivvnx4si_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8163; /* *cond_udivvnx4si_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8167; /* *cond_udivvnx4si_any */

            case 1:
              x6 = XVECEXP (x3, 0, 2);
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 4645 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8161; /* *cond_udivvnx2di_2 */
              if (rtx_equal_p (x6, operands[3])
                  && 
#line 4662 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8165; /* *cond_udivvnx2di_3 */
              operands[4] = x6;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 8169; /* *cond_udivvnx2di_any */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
          return recog_280 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 126)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x10) != EQ)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      operands[1] = x11;
      x12 = XEXP (x10, 0);
      operands[2] = x12;
      x13 = XEXP (x10, 1);
      operands[3] = x13;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x3, 0, 2);
      if (!rtx_equal_p (x6, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1200 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7156; /* *cnotvnx16qi */

        case E_VNx8QImode:
          if (pattern1200 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7157; /* *cnotvnx8qi */

        case E_VNx4QImode:
          if (pattern1200 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7158; /* *cnotvnx4qi */

        case E_VNx2QImode:
          if (pattern1200 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7159; /* *cnotvnx2qi */

        case E_VNx8HImode:
          if (pattern1200 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7160; /* *cnotvnx8hi */

        case E_VNx4HImode:
          if (pattern1200 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7161; /* *cnotvnx4hi */

        case E_VNx2HImode:
          if (pattern1200 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7162; /* *cnotvnx2hi */

        case E_VNx4SImode:
          if (pattern1200 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7163; /* *cnotvnx4si */

        case E_VNx2SImode:
          if (pattern1200 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7164; /* *cnotvnx2si */

        case E_VNx2DImode:
          if (pattern1200 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 3508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7165; /* *cnotvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          switch (pattern1167 (
E_V8QImode))
            {
            case 0:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (8)))
                return -1;
              return 5301; /* aarch64_lutv8qiv8qi */

            case 1:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (8)))
                return -1;
              return 5306; /* aarch64_lutv8qiv16qi */

            default:
              return -1;
            }

        case E_V16QImode:
          switch (pattern1167 (
E_V16QImode))
            {
            case 0:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (16)))
                return -1;
              return 5302; /* aarch64_lutv16qiv8qi */

            case 1:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (16)))
                return -1;
              return 5307; /* aarch64_lutv16qiv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          switch (pattern1167 (
E_V4HImode))
            {
            case 0:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5303; /* aarch64_lutv4hiv8qi */

            case 1:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5308; /* aarch64_lutv4hiv16qi */

            default:
              return -1;
            }

        case E_V2x8HImode:
          switch (pattern1167 (
E_V2x8HImode))
            {
            case 0:
              if (!
#line 10068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5311; /* aarch64_lutv2x8hiv8qi */

            case 1:
              if (!
#line 10068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5314; /* aarch64_lutv2x8hiv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          switch (pattern1167 (
E_V4HFmode))
            {
            case 0:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5304; /* aarch64_lutv4hfv8qi */

            case 1:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5309; /* aarch64_lutv4hfv16qi */

            default:
              return -1;
            }

        case E_V2x8HFmode:
          switch (pattern1167 (
E_V2x8HFmode))
            {
            case 0:
              if (!
#line 10068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5312; /* aarch64_lutv2x8hfv8qi */

            case 1:
              if (!
#line 10068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5315; /* aarch64_lutv2x8hfv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          switch (pattern1167 (
E_V4BFmode))
            {
            case 0:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5305; /* aarch64_lutv4bfv8qi */

            case 1:
              if (!
#line 10055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) <= exact_log2 (4)))
                return -1;
              return 5310; /* aarch64_lutv4bfv16qi */

            default:
              return -1;
            }

        case E_V2x8BFmode:
          switch (pattern1167 (
E_V2x8BFmode))
            {
            case 0:
              if (!
#line 10068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5313; /* aarch64_lutv2x8bfv8qi */

            case 1:
              if (!
#line 10068 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_LUT && INTVAL (operands[4]) == 4))
                return -1;
              return 5316; /* aarch64_lutv2x8bfv16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern232 (x1))
    {
    case 0:
      if (!
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13448; /* aarch64_sme_fsubvnx8sf */

    case 1:
      if (!
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13450; /* aarch64_sme_fsubvnx16sf */

    case 2:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13452; /* aarch64_sme_fsubvnx4df */

    case 3:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13454; /* aarch64_sme_fsubvnx8df */

    case 4:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13456; /* aarch64_sme_fsubvnx16hf */

    case 5:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13458; /* aarch64_sme_fsubvnx32hf */

    case 6:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13460; /* aarch64_sme_fsubvnx16bf */

    case 7:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13462; /* aarch64_sme_fsubvnx32bf */

    case 8:
      if (!
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13464; /* *aarch64_sme_fsubvnx8sf_plus */

    case 9:
      if (!
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13466; /* *aarch64_sme_fsubvnx16sf_plus */

    case 10:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 724 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13468; /* *aarch64_sme_fsubvnx4df_plus */

    case 11:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 725 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13470; /* *aarch64_sme_fsubvnx8df_plus */

    case 12:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 726 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13472; /* *aarch64_sme_fsubvnx16hf_plus */

    case 13:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 727 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13474; /* *aarch64_sme_fsubvnx32hf_plus */

    case 14:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 728 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13476; /* *aarch64_sme_fsubvnx16bf_plus */

    case 15:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13478; /* *aarch64_sme_fsubvnx32bf_plus */

    default:
      return -1;
    }
}

 int
recog_420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern195 (x2, 
E_V8QImode, 
E_V4HFmode) != 0
          || !
#line 203 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5335; /* aarch64_fdotv4hf */

    case E_V8HFmode:
      if (pattern195 (x2, 
E_V16QImode, 
E_V8HFmode) != 0
          || !
#line 204 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5336; /* aarch64_fdotv8hf */

    case E_V2SFmode:
      if (pattern195 (x2, 
E_V8QImode, 
E_V2SFmode) != 0
          || !
#line 205 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5337; /* aarch64_fdotv2sf */

    case E_V4SFmode:
      if (pattern195 (x2, 
E_V16QImode, 
E_V4SFmode) != 0
          || !
#line 206 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5338; /* aarch64_fdotv4sf */

    default:
      return -1;
    }
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern231 (x1))
    {
    case 0:
      if (!
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13432; /* aarch64_sme_subvnx8si */

    case 1:
      if (!(
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13434; /* aarch64_sme_subvnx4di */

    case 2:
      if (!
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13436; /* aarch64_sme_subvnx16si */

    case 3:
      if (!(
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13438; /* aarch64_sme_subvnx8di */

    case 4:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13440; /* *aarch64_sme_subvnx8si_plus */

    case 5:
      if (!(
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13442; /* *aarch64_sme_subvnx4di_plus */

    case 6:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13444; /* *aarch64_sme_subvnx16si_plus */

    case 7:
      if (!(
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13446; /* *aarch64_sme_subvnx8di_plus */

    default:
      return -1;
    }
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern230 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 3);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern248 (x1))
            {
            case 0:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13513; /* aarch64_sme_usdotvnx4sivnx32qi */

            case 1:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13516; /* aarch64_sme_usdotvnx4sivnx64qi */

            case 2:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13519; /* aarch64_sme_usdotvnx4sivnx16hi */

            case 3:
              if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13522; /* aarch64_sme_usdotvnx4sivnx32hi */

            case 4:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13525; /* aarch64_sme_usdotvnx2divnx32qi */

            case 5:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13528; /* aarch64_sme_usdotvnx2divnx64qi */

            case 6:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13531; /* aarch64_sme_usdotvnx2divnx16hi */

            case 7:
              if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13534; /* aarch64_sme_usdotvnx2divnx32hi */

            case 8:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13561; /* aarch64_sme_single_usdotvnx4sivnx32qi */

            case 9:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13564; /* aarch64_sme_single_usdotvnx4sivnx64qi */

            case 10:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13567; /* aarch64_sme_single_usdotvnx4sivnx16hi */

            case 11:
              if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13570; /* aarch64_sme_single_usdotvnx4sivnx32hi */

            case 12:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13573; /* aarch64_sme_single_usdotvnx2divnx32qi */

            case 13:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13576; /* aarch64_sme_single_usdotvnx2divnx64qi */

            case 14:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13579; /* aarch64_sme_single_usdotvnx2divnx16hi */

            case 15:
              if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13582; /* aarch64_sme_single_usdotvnx2divnx32hi */

            case 16:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13617; /* aarch64_sme_lane_usdotvnx4sivnx32qi */

            case 17:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13625; /* aarch64_sme_lane_usdotvnx4sivnx64qi */

            case 18:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13633; /* aarch64_sme_lane_usdotvnx4sivnx16hi */

            case 19:
              if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13641; /* aarch64_sme_lane_usdotvnx4sivnx32hi */

            case 20:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13649; /* aarch64_sme_lane_usdotvnx2divnx32qi */

            case 21:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13657; /* aarch64_sme_lane_usdotvnx2divnx64qi */

            case 22:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13665; /* aarch64_sme_lane_usdotvnx2divnx16hi */

            case 23:
              if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13673; /* aarch64_sme_lane_usdotvnx2divnx32hi */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x4 = XEXP (x1, 0);
          if (GET_MODE (x4) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (GET_MODE (x5) != E_VNx4SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_VNx16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 4);
          operands[1] = x7;
          switch (GET_MODE (x3))
            {
            case E_VNx32QImode:
              if (!register_operand (operands[1], E_VNx32QImode)
                  || !
#line 1356 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13607; /* aarch64_sme_single_sudotvnx4sivnx32qi */

            case E_VNx64QImode:
              if (!register_operand (operands[1], E_VNx64QImode)
                  || !
#line 1356 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13608; /* aarch64_sme_single_sudotvnx4sivnx64qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 3);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern252 (x1))
            {
            case 0:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13537; /* *aarch64_sme_usdotvnx4sivnx32qi_plus */

            case 1:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13540; /* *aarch64_sme_usdotvnx4sivnx64qi_plus */

            case 2:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13543; /* *aarch64_sme_usdotvnx4sivnx16hi_plus */

            case 3:
              if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13546; /* *aarch64_sme_usdotvnx4sivnx32hi_plus */

            case 4:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13549; /* *aarch64_sme_usdotvnx2divnx32qi_plus */

            case 5:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13552; /* *aarch64_sme_usdotvnx2divnx64qi_plus */

            case 6:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13555; /* *aarch64_sme_usdotvnx2divnx16hi_plus */

            case 7:
              if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13558; /* *aarch64_sme_usdotvnx2divnx32hi_plus */

            case 8:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13585; /* *aarch64_sme_single_usdotvnx4sivnx32qi_plus */

            case 9:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13588; /* *aarch64_sme_single_usdotvnx4sivnx64qi_plus */

            case 10:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13591; /* *aarch64_sme_single_usdotvnx4sivnx16hi_plus */

            case 11:
              if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13594; /* *aarch64_sme_single_usdotvnx4sivnx32hi_plus */

            case 12:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13597; /* *aarch64_sme_single_usdotvnx2divnx32qi_plus */

            case 13:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13600; /* *aarch64_sme_single_usdotvnx2divnx64qi_plus */

            case 14:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13603; /* *aarch64_sme_single_usdotvnx2divnx16hi_plus */

            case 15:
              if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13606; /* *aarch64_sme_single_usdotvnx2divnx32hi_plus */

            case 16:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13681; /* *aarch64_sme_lane_usdotvnx4sivnx32qi_plus */

            case 17:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13689; /* *aarch64_sme_lane_usdotvnx4sivnx64qi_plus */

            case 18:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13697; /* *aarch64_sme_lane_usdotvnx4sivnx16hi_plus */

            case 19:
              if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13705; /* *aarch64_sme_lane_usdotvnx4sivnx32hi_plus */

            case 20:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13713; /* *aarch64_sme_lane_usdotvnx2divnx32qi_plus */

            case 21:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13721; /* *aarch64_sme_lane_usdotvnx2divnx64qi_plus */

            case 22:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13729; /* *aarch64_sme_lane_usdotvnx2divnx16hi_plus */

            case 23:
              if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13737; /* *aarch64_sme_lane_usdotvnx2divnx32hi_plus */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x4 = XEXP (x1, 0);
          if (GET_MODE (x4) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (GET_MODE (x5) != E_VNx4SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[3] = x6;
          if (!register_operand (operands[3], E_VNx16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 4);
          operands[2] = x7;
          switch (GET_MODE (x3))
            {
            case E_VNx32QImode:
              if (!register_operand (operands[2], E_VNx32QImode)
                  || !
#line 1371 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13609; /* *aarch64_sme_single_sudotvnx4sivnx32qi_plus */

            case E_VNx64QImode:
              if (!register_operand (operands[2], E_VNx64QImode)
                  || !
#line 1371 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13610; /* *aarch64_sme_single_sudotvnx4sivnx64qi_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 43:
      return recog_158 (x1, insn, pnum_clobbers);

    case 9:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 465; /* aarch64_crc32b */

    case 14:
      if (pattern75 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 466; /* aarch64_crc32h */

    case 15:
      if (pattern76 (x1, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 467; /* aarch64_crc32w */

    case 16:
      if (pattern75 (x1, 
E_DImode, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 468; /* aarch64_crc32x */

    case 10:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 469; /* aarch64_crc32cb */

    case 11:
      if (pattern75 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 470; /* aarch64_crc32ch */

    case 12:
      if (pattern76 (x1, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 471; /* aarch64_crc32cw */

    case 13:
      if (pattern75 (x1, 
E_DImode, 
E_SImode) != 0
          || !
#line 4723 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 472; /* aarch64_crc32cx */

    case 84:
      if (pattern75 (x1, 
E_QImode, 
E_DImode) != 0
          || !
#line 6083 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 757; /* *aarch64_sisd_ushl */

    case 105:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 6093 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 758; /* *aarch64_ushl_2s */

    case 83:
      if (pattern75 (x1, 
E_QImode, 
E_DImode) != 0
          || !
#line 6103 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 759; /* *aarch64_sisd_sshl */

    case 85:
      if (pattern75 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 6113 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 760; /* *aarch64_sshl_2s */

    case 19:
      return recog_152 (x1, insn, pnum_clobbers);

    case 20:
      return recog_151 (x1, insn, pnum_clobbers);

    case 79:
      return recog_150 (x1, insn, pnum_clobbers);

    case 104:
      return recog_149 (x1, insn, pnum_clobbers);

    case 196:
      return recog_95 (x1, insn, pnum_clobbers);

    case 199:
      return recog_94 (x1, insn, pnum_clobbers);

    case 277:
      return recog_93 (x1, insn, pnum_clobbers);

    case 278:
      return recog_74 (x1, insn, pnum_clobbers);

    case 42:
      return recog_128 (x1, insn, pnum_clobbers);

    case 99:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1142; /* tlsle12_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1143; /* tlsle12_di */

        default:
          return -1;
        }

    case 100:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1144; /* tlsle24_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1145; /* tlsle24_di */

        default:
          return -1;
        }

    case 74:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1156; /* paciasp */

    case 2:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1157; /* autiasp */

    case 75:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1158; /* pacibsp */

    case 3:
      if (pattern86 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1159; /* autibsp */

    case 72:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1160; /* pacia1716 */

    case 0:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1161; /* autia1716 */

    case 73:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1162; /* pacib1716 */

    case 1:
      if (pattern86 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1163; /* autib1716 */

    case 109:
      return recog_148 (x1, insn, pnum_clobbers);

    case 154:
      if (pattern88 (x1) != 0)
        return -1;
      return 1183; /* speculation_tracker */

    case 155:
      if (pattern88 (x1) != 0)
        return -1;
      return 1184; /* speculation_tracker_rev */

    case 405:
      return recog_171 (x1, insn, pnum_clobbers);

    case 406:
      return recog_170 (x1, insn, pnum_clobbers);

    case 112:
      return recog_119 (x1, insn, pnum_clobbers);

    case 186:
      return recog_157 (x1, insn, pnum_clobbers);

    case 185:
      return recog_156 (x1, insn, pnum_clobbers);

    case 274:
      return recog_90 (x1, insn, pnum_clobbers);

    case 208:
      return recog_124 (x1, insn, pnum_clobbers);

    case 209:
      return recog_122 (x1, insn, pnum_clobbers);

    case 206:
      return recog_123 (x1, insn, pnum_clobbers);

    case 207:
      return recog_121 (x1, insn, pnum_clobbers);

    case 198:
      return recog_147 (x1, insn, pnum_clobbers);

    case 201:
      return recog_146 (x1, insn, pnum_clobbers);

    case 197:
      return recog_145 (x1, insn, pnum_clobbers);

    case 200:
      return recog_144 (x1, insn, pnum_clobbers);

    case 202:
      return recog_143 (x1, insn, pnum_clobbers);

    case 218:
      return recog_160 (x1, insn, pnum_clobbers);

    case 271:
      return recog_112 (x1, insn, pnum_clobbers);

    case 219:
      return recog_75 (x1, insn, pnum_clobbers);

    case 221:
      return recog_88 (x1, insn, pnum_clobbers);

    case 220:
      return recog_118 (x1, insn, pnum_clobbers);

    case 216:
      return recog_73 (x1, insn, pnum_clobbers);

    case 217:
      return recog_78 (x1, insn, pnum_clobbers);

    case 229:
      return recog_142 (x1, insn, pnum_clobbers);

    case 230:
      return recog_141 (x1, insn, pnum_clobbers);

    case 231:
      return recog_92 (x1, insn, pnum_clobbers);

    case 232:
      return recog_91 (x1, insn, pnum_clobbers);

    case 227:
      return recog_98 (x1, insn, pnum_clobbers);

    case 228:
      return recog_97 (x1, insn, pnum_clobbers);

    case 233:
      return recog_117 (x1, insn, pnum_clobbers);

    case 234:
      return recog_116 (x1, insn, pnum_clobbers);

    case 226:
      return recog_96 (x1, insn, pnum_clobbers);

    case 94:
      return recog_86 (x1, insn, pnum_clobbers);

    case 95:
      return recog_85 (x1, insn, pnum_clobbers);

    case 96:
      return recog_84 (x1, insn, pnum_clobbers);

    case 183:
      return recog_115 (x1, insn, pnum_clobbers);

    case 273:
      return recog_77 (x1, insn, pnum_clobbers);

    case 242:
      return recog_89 (x1, insn, pnum_clobbers);

    case 246:
      if (pattern107 (x1, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 8615 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4843; /* aarch64_combinev16qi */

    case 247:
      return recog_72 (x1, insn, pnum_clobbers);

    case 248:
      return recog_83 (x1, insn, pnum_clobbers);

    case 251:
      return recog_82 (x1, insn, pnum_clobbers);

    case 252:
      return recog_81 (x1, insn, pnum_clobbers);

    case 249:
      return recog_80 (x1, insn, pnum_clobbers);

    case 250:
      return recog_79 (x1, insn, pnum_clobbers);

    case 28:
      return recog_114 (x1, insn, pnum_clobbers);

    case 266:
      if (pattern76 (x1, 
E_V4SImode) != 0
          || !
#line 9015 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5184; /* aarch64_crypto_sha1su1v4si */

    case 269:
      if (pattern76 (x1, 
E_V4SImode) != 0
          || !
#line 9060 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5191; /* aarch64_crypto_sha256su0v4si */

    case 292:
      if (pattern76 (x1, 
E_V2DImode) != 0
          || !
#line 9094 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
        return -1;
      return 5195; /* aarch64_crypto_sha512su0qv2di */

    case 288:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 9229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
            return -1;
          return 5214; /* aarch64_sm4eqv4si */

        case 1:
          if (!
#line 4232 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_SM4))
            return -1;
          return 12986; /* aarch64_sve2_sm4e */

        default:
          return -1;
        }

    case 289:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 9239 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
            return -1;
          return 5215; /* aarch64_sm4ekeyqv4si */

        case 1:
          if (!
#line 4243 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_SM4))
            return -1;
          return 12987; /* aarch64_sve2_sm4ekey */

        default:
          return -1;
        }

    case 272:
      if (pattern107 (x1, 
E_V2DImode, 
E_TImode) != 0
          || !
#line 9835 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
        return -1;
      return 5241; /* aarch64_crypto_pmullv2di */

    case 586:
      if (pattern75 (x1, 
E_V4SFmode, 
E_V8BFmode) != 0
          || !
#line 9986 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5275; /* aarch64_bfcvtn2v8bf */

    case 589:
      return recog_169 (x1, insn, pnum_clobbers);

    case 590:
      return recog_168 (x1, insn, pnum_clobbers);

    case 190:
      return recog_193 (x1, insn, pnum_clobbers);

    case 192:
      return recog_192 (x1, insn, pnum_clobbers);

    case 204:
      return recog_120 (x1, insn, pnum_clobbers);

    case 69:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      return 5533; /* *dmb */

    case 125:
      return recog_71 (x1, insn, pnum_clobbers);

    case 152:
      return recog_106 (x1, insn, pnum_clobbers);

    case 158:
      return recog_155 (x1, insn, pnum_clobbers);

    case 119:
      return recog_111 (x1, insn, pnum_clobbers);

    case 177:
      return recog_105 (x1, insn, pnum_clobbers);

    case 148:
      return recog_110 (x1, insn, pnum_clobbers);

    case 398:
      return recog_104 (x1, insn, pnum_clobbers);

    case 399:
      return recog_103 (x1, insn, pnum_clobbers);

    case 298:
      return recog_107 (x1, insn, pnum_clobbers);

    case 400:
      switch (pattern117 (x1))
        {
        case 0:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8350; /* aarch64_sve_lslvnx16qi */

        case 1:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8353; /* aarch64_sve_lslvnx8hi */

        case 2:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8356; /* aarch64_sve_lslvnx4si */

        default:
          return -1;
        }

    case 401:
      switch (pattern117 (x1))
        {
        case 0:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8351; /* aarch64_sve_asrvnx16qi */

        case 1:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8354; /* aarch64_sve_asrvnx8hi */

        case 2:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8357; /* aarch64_sve_asrvnx4si */

        default:
          return -1;
        }

    case 402:
      switch (pattern117 (x1))
        {
        case 0:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8352; /* aarch64_sve_lsrvnx16qi */

        case 1:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8355; /* aarch64_sve_lsrvnx8hi */

        case 2:
          if (!
#line 4978 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8358; /* aarch64_sve_lsrvnx4si */

        default:
          return -1;
        }

    case 328:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 5184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8475; /* aarch64_sve_ftsmulvnx8hf */

        case 1:
          if (!
#line 5184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8477; /* aarch64_sve_ftsmulvnx4sf */

        case 2:
          if (!
#line 5184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8479; /* aarch64_sve_ftsmulvnx2df */

        default:
          return -1;
        }

    case 329:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 5184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8476; /* aarch64_sve_ftsselvnx8hf */

        case 1:
          if (!
#line 5184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8478; /* aarch64_sve_ftsselvnx4sf */

        case 2:
          if (!
#line 5184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8480; /* aarch64_sve_ftsselvnx2df */

        default:
          return -1;
        }

    case 313:
      return recog_127 (x1, insn, pnum_clobbers);

    case 314:
      return recog_125 (x1, insn, pnum_clobbers);

    case 315:
      return recog_126 (x1, insn, pnum_clobbers);

    case 308:
      return recog_191 (x1, insn, pnum_clobbers);

    case 309:
      return recog_190 (x1, insn, pnum_clobbers);

    case 310:
      return recog_189 (x1, insn, pnum_clobbers);

    case 311:
      return recog_188 (x1, insn, pnum_clobbers);

    case 312:
      return recog_187 (x1, insn, pnum_clobbers);

    case 243:
      return recog_109 (x1, insn, pnum_clobbers);

    case 172:
      return recog_140 (x1, insn, pnum_clobbers);

    case 628:
      return recog_102 (x1, insn, pnum_clobbers);

    case 629:
      return recog_100 (x1, insn, pnum_clobbers);

    case 630:
      return recog_101 (x1, insn, pnum_clobbers);

    case 631:
      return recog_99 (x1, insn, pnum_clobbers);

    case 338:
      return recog_139 (x1, insn, pnum_clobbers);

    case 339:
      return recog_138 (x1, insn, pnum_clobbers);

    case 334:
      return recog_137 (x1, insn, pnum_clobbers);

    case 335:
      return recog_136 (x1, insn, pnum_clobbers);

    case 336:
      return recog_135 (x1, insn, pnum_clobbers);

    case 337:
      return recog_133 (x1, insn, pnum_clobbers);

    case 133:
      return recog_113 (x1, insn, pnum_clobbers);

    case 612:
      return recog_154 (x1, insn, pnum_clobbers);

    case 607:
      return recog_134 (x1, insn, pnum_clobbers);

    case 609:
      return recog_76 (x1, insn, pnum_clobbers);

    case 494:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12102; /* aarch64_sve_saddwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12110; /* aarch64_sve_saddwbvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12118; /* aarch64_sve_saddwbvnx2di */

        default:
          return -1;
        }

    case 495:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12103; /* aarch64_sve_saddwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12111; /* aarch64_sve_saddwtvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12119; /* aarch64_sve_saddwtvnx2di */

        default:
          return -1;
        }

    case 539:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12104; /* aarch64_sve_ssubwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12112; /* aarch64_sve_ssubwbvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12120; /* aarch64_sve_ssubwbvnx2di */

        default:
          return -1;
        }

    case 540:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12105; /* aarch64_sve_ssubwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12113; /* aarch64_sve_ssubwtvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12121; /* aarch64_sve_ssubwtvnx2di */

        default:
          return -1;
        }

    case 551:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12106; /* aarch64_sve_uaddwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12114; /* aarch64_sve_uaddwbvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12122; /* aarch64_sve_uaddwbvnx2di */

        default:
          return -1;
        }

    case 552:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12107; /* aarch64_sve_uaddwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12115; /* aarch64_sve_uaddwtvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12123; /* aarch64_sve_uaddwtvnx2di */

        default:
          return -1;
        }

    case 571:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12108; /* aarch64_sve_usubwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12116; /* aarch64_sve_usubwbvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12124; /* aarch64_sve_usubwbvnx2di */

        default:
          return -1;
        }

    case 572:
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12109; /* aarch64_sve_usubwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12117; /* aarch64_sve_usubwtvnx4si */

        case 2:
          if (!
#line 2233 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12125; /* aarch64_sve_usubwtvnx2di */

        default:
          return -1;
        }

    case 489:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12126; /* aarch64_sve_sabdlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12147; /* aarch64_sve_sabdlbvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12168; /* aarch64_sve_sabdlbvnx2di */

        default:
          return -1;
        }

    case 490:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12127; /* aarch64_sve_sabdltvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12148; /* aarch64_sve_sabdltvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12169; /* aarch64_sve_sabdltvnx2di */

        default:
          return -1;
        }

    case 491:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12128; /* aarch64_sve_saddlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12149; /* aarch64_sve_saddlbvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12170; /* aarch64_sve_saddlbvnx2di */

        default:
          return -1;
        }

    case 492:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12129; /* aarch64_sve_saddlbtvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12150; /* aarch64_sve_saddlbtvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12171; /* aarch64_sve_saddlbtvnx2di */

        default:
          return -1;
        }

    case 493:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12130; /* aarch64_sve_saddltvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12151; /* aarch64_sve_saddltvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12172; /* aarch64_sve_saddltvnx2di */

        default:
          return -1;
        }

    case 505:
      return recog_167 (x1, insn, pnum_clobbers);

    case 506:
      return recog_166 (x1, insn, pnum_clobbers);

    case 509:
      return recog_165 (x1, insn, pnum_clobbers);

    case 511:
      return recog_164 (x1, insn, pnum_clobbers);

    case 535:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12135; /* aarch64_sve_ssublbvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12156; /* aarch64_sve_ssublbvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12177; /* aarch64_sve_ssublbvnx2di */

        default:
          return -1;
        }

    case 536:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12136; /* aarch64_sve_ssublbtvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12157; /* aarch64_sve_ssublbtvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12178; /* aarch64_sve_ssublbtvnx2di */

        default:
          return -1;
        }

    case 537:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12137; /* aarch64_sve_ssubltvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12158; /* aarch64_sve_ssubltvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12179; /* aarch64_sve_ssubltvnx2di */

        default:
          return -1;
        }

    case 538:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12138; /* aarch64_sve_ssubltbvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12159; /* aarch64_sve_ssubltbvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12180; /* aarch64_sve_ssubltbvnx2di */

        default:
          return -1;
        }

    case 547:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12139; /* aarch64_sve_uabdlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12160; /* aarch64_sve_uabdlbvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12181; /* aarch64_sve_uabdlbvnx2di */

        default:
          return -1;
        }

    case 548:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12140; /* aarch64_sve_uabdltvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12161; /* aarch64_sve_uabdltvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12182; /* aarch64_sve_uabdltvnx2di */

        default:
          return -1;
        }

    case 549:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12141; /* aarch64_sve_uaddlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12162; /* aarch64_sve_uaddlbvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12183; /* aarch64_sve_uaddlbvnx2di */

        default:
          return -1;
        }

    case 550:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12142; /* aarch64_sve_uaddltvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12163; /* aarch64_sve_uaddltvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12184; /* aarch64_sve_uaddltvnx2di */

        default:
          return -1;
        }

    case 557:
      return recog_163 (x1, insn, pnum_clobbers);

    case 558:
      return recog_162 (x1, insn, pnum_clobbers);

    case 569:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12145; /* aarch64_sve_usublbvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12166; /* aarch64_sve_usublbvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12187; /* aarch64_sve_usublbvnx2di */

        default:
          return -1;
        }

    case 570:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12146; /* aarch64_sve_usubltvnx8hi */

        case 1:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12167; /* aarch64_sve_usubltvnx4si */

        case 2:
          if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12188; /* aarch64_sve_usubltvnx2di */

        default:
          return -1;
        }

    case 533:
      switch (pattern131 (x1))
        {
        case 0:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12201; /* aarch64_sve_sshllbvnx8hi */

        case 1:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12205; /* aarch64_sve_sshllbvnx4si */

        case 2:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12209; /* aarch64_sve_sshllbvnx2di */

        default:
          return -1;
        }

    case 534:
      switch (pattern131 (x1))
        {
        case 0:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12202; /* aarch64_sve_sshlltvnx8hi */

        case 1:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12206; /* aarch64_sve_sshlltvnx4si */

        case 2:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12210; /* aarch64_sve_sshlltvnx2di */

        default:
          return -1;
        }

    case 567:
      switch (pattern131 (x1))
        {
        case 0:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12203; /* aarch64_sve_ushllbvnx8hi */

        case 1:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12207; /* aarch64_sve_ushllbvnx4si */

        case 2:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12211; /* aarch64_sve_ushllbvnx2di */

        default:
          return -1;
        }

    case 568:
      switch (pattern131 (x1))
        {
        case 0:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12204; /* aarch64_sve_ushlltvnx8hi */

        case 1:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12208; /* aarch64_sve_ushlltvnx4si */

        case 2:
          if (!
#line 2304 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12212; /* aarch64_sve_ushlltvnx2di */

        default:
          return -1;
        }

    case 529:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12376; /* aarch64_sve_sqxtntvnx8hi */

        case 1:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12379; /* aarch64_sve_sqxtntvnx4si */

        case 2:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12382; /* aarch64_sve_sqxtntvnx2di */

        default:
          return -1;
        }

    case 531:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12377; /* aarch64_sve_sqxtuntvnx8hi */

        case 1:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12380; /* aarch64_sve_sqxtuntvnx4si */

        case 2:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12383; /* aarch64_sve_sqxtuntvnx2di */

        default:
          return -1;
        }

    case 566:
      switch (pattern132 (x1))
        {
        case 0:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12378; /* aarch64_sve_uqxtntvnx8hi */

        case 1:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12381; /* aarch64_sve_uqxtntvnx4si */

        case 2:
          if (!
#line 2638 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12384; /* aarch64_sve_uqxtntvnx2di */

        default:
          return -1;
        }

    case 418:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12403; /* aarch64_sve_addhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12407; /* aarch64_sve_addhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12411; /* aarch64_sve_addhnbvnx2di */

        default:
          return -1;
        }

    case 483:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12404; /* aarch64_sve_raddhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12408; /* aarch64_sve_raddhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12412; /* aarch64_sve_raddhnbvnx2di */

        default:
          return -1;
        }

    case 487:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12405; /* aarch64_sve_rsubhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12409; /* aarch64_sve_rsubhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12413; /* aarch64_sve_rsubhnbvnx2di */

        default:
          return -1;
        }

    case 543:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12406; /* aarch64_sve_subhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12410; /* aarch64_sve_subhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12414; /* aarch64_sve_subhnbvnx2di */

        default:
          return -1;
        }

    case 485:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12430; /* aarch64_sve_rshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12438; /* aarch64_sve_rshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12446; /* aarch64_sve_rshrnbvnx2di */

        default:
          return -1;
        }

    case 498:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12431; /* aarch64_sve_shrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12439; /* aarch64_sve_shrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12447; /* aarch64_sve_shrnbvnx2di */

        default:
          return -1;
        }

    case 518:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12432; /* aarch64_sve_sqrshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12440; /* aarch64_sve_sqrshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12448; /* aarch64_sve_sqrshrnbvnx2di */

        default:
          return -1;
        }

    case 522:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12433; /* aarch64_sve_sqrshrunbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12441; /* aarch64_sve_sqrshrunbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12449; /* aarch64_sve_sqrshrunbvnx2di */

        default:
          return -1;
        }

    case 524:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12434; /* aarch64_sve_sqshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12442; /* aarch64_sve_sqshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12450; /* aarch64_sve_sqshrnbvnx2di */

        default:
          return -1;
        }

    case 526:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12435; /* aarch64_sve_sqshrunbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12443; /* aarch64_sve_sqshrunbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12451; /* aarch64_sve_sqshrunbvnx2di */

        default:
          return -1;
        }

    case 561:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12436; /* aarch64_sve_uqrshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12444; /* aarch64_sve_uqrshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12452; /* aarch64_sve_uqrshrnbvnx2di */

        default:
          return -1;
        }

    case 563:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12437; /* aarch64_sve_uqshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12445; /* aarch64_sve_uqshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12453; /* aarch64_sve_uqshrnbvnx2di */

        default:
          return -1;
        }

    case 516:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3577 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12478; /* aarch64_sve_sqrshrvnx8si */

        case 1:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3577 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12490; /* aarch64_sve_sqrshrvnx8di */

        case 2:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3577 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12484; /* aarch64_sve_sqrshrvnx16si */

        default:
          return -1;
        }

    case 517:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3578 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12479; /* aarch64_sve_sqrshrnvnx8si */

        case 1:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3578 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12491; /* aarch64_sve_sqrshrnvnx8di */

        case 2:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3578 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12485; /* aarch64_sve_sqrshrnvnx16si */

        default:
          return -1;
        }

    case 520:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3579 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12480; /* aarch64_sve_sqrshruvnx8si */

        case 1:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3579 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12492; /* aarch64_sve_sqrshruvnx8di */

        case 2:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3579 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12486; /* aarch64_sve_sqrshruvnx16si */

        default:
          return -1;
        }

    case 521:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3580 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12481; /* aarch64_sve_sqrshrunvnx8si */

        case 1:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3580 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12493; /* aarch64_sve_sqrshrunvnx8di */

        case 2:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3580 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12487; /* aarch64_sve_sqrshrunvnx16si */

        default:
          return -1;
        }

    case 559:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3581 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12482; /* aarch64_sve_uqrshrvnx8si */

        case 1:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3581 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12494; /* aarch64_sve_uqrshrvnx8di */

        case 2:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3581 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12488; /* aarch64_sve_uqrshrvnx16si */

        default:
          return -1;
        }

    case 560:
      switch (pattern135 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3582 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12483; /* aarch64_sve_uqrshrnvnx8si */

        case 1:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3582 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12495; /* aarch64_sve_uqrshrnvnx8di */

        case 2:
          if (!(
#line 2795 "../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3582 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12489; /* aarch64_sve_uqrshrnvnx16si */

        default:
          return -1;
        }

    case 424:
      return recog_186 (x1, insn, pnum_clobbers);

    case 423:
      return recog_185 (x1, insn, pnum_clobbers);

    case 508:
      return recog_184 (x1, insn, pnum_clobbers);

    case 507:
      return recog_183 (x1, insn, pnum_clobbers);

    case 447:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12635; /* aarch64_sve2_fp8_cvt_f1cvtvnx8bf */

        case 1:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12639; /* aarch64_sve2_fp8_cvt_f1cvtvnx8hf */

        default:
          return -1;
        }

    case 449:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12636; /* aarch64_sve2_fp8_cvt_f2cvtvnx8bf */

        case 1:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12640; /* aarch64_sve2_fp8_cvt_f2cvtvnx8hf */

        default:
          return -1;
        }

    case 448:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12637; /* aarch64_sve2_fp8_cvt_f1cvtltvnx8bf */

        case 1:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12641; /* aarch64_sve2_fp8_cvt_f1cvtltvnx8hf */

        default:
          return -1;
        }

    case 450:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12638; /* aarch64_sve2_fp8_cvt_f2cvtltvnx8bf */

        case 1:
          if (!
#line 3207 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12642; /* aarch64_sve2_fp8_cvt_f2cvtltvnx8hf */

        default:
          return -1;
        }

    case 468:
      return recog_159 (x1, insn, pnum_clobbers);

    case 452:
      if (pattern139 (x2) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!aligned_register_operand (operands[1], E_VNx8SFmode)
          || !
#line 3397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
        return -1;
      return 12657; /* aarch64_sve2_fp8_cvtnbvnx16qi */

    case 477:
      switch (pattern140 (x1))
        {
        case 0:
          if (!
#line 3622 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12681; /* aarch64_sve_pmullbvnx8hi */

        case 1:
          if (!
#line 3622 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12683; /* aarch64_sve_pmullbvnx2di */

        default:
          return -1;
        }

    case 479:
      switch (pattern140 (x1))
        {
        case 0:
          if (!
#line 3622 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12682; /* aarch64_sve_pmulltvnx8hi */

        case 1:
          if (!
#line 3622 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12684; /* aarch64_sve_pmulltvnx2di */

        default:
          return -1;
        }

    case 478:
      switch (pattern141 (x1))
        {
        case 0:
          if (!
#line 3635 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12685; /* aarch64_sve_pmullb_pairvnx16qi */

        case 1:
          if (!
#line 3635 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12687; /* aarch64_sve_pmullb_pairvnx4si */

        case 2:
          if (!(
#line 3635 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 658 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2_AES)))
            return -1;
          return 12689; /* aarch64_sve_pmullb_pairvnx2di */

        default:
          return -1;
        }

    case 480:
      switch (pattern141 (x1))
        {
        case 0:
          if (!
#line 3635 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12686; /* aarch64_sve_pmullt_pairvnx16qi */

        case 1:
          if (!
#line 3635 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12688; /* aarch64_sve_pmullt_pairvnx4si */

        case 2:
          if (!(
#line 3635 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 658 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2_AES)))
            return -1;
          return 12690; /* aarch64_sve_pmullt_pairvnx2di */

        default:
          return -1;
        }

    case 594:
      return recog_182 (x1, insn, pnum_clobbers);

    case 595:
      return recog_180 (x1, insn, pnum_clobbers);

    case 597:
      return recog_181 (x1, insn, pnum_clobbers);

    case 610:
      return recog_179 (x1, insn, pnum_clobbers);

    case 615:
      return recog_178 (x1, insn, pnum_clobbers);

    case 616:
      return recog_177 (x1, insn, pnum_clobbers);

    case 624:
      return recog_176 (x1, insn, pnum_clobbers);

    case 625:
      return recog_175 (x1, insn, pnum_clobbers);

    case 599:
      switch (pattern143 (x1))
        {
        case 0:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12803; /* aarch64_pred_reduc_faddqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12808; /* aarch64_pred_reduc_faddqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12813; /* aarch64_pred_reduc_faddqv_vnx2df */

        default:
          return -1;
        }

    case 600:
      switch (pattern143 (x1))
        {
        case 0:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12804; /* aarch64_pred_reduc_fmaxqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12809; /* aarch64_pred_reduc_fmaxqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12814; /* aarch64_pred_reduc_fmaxqv_vnx2df */

        default:
          return -1;
        }

    case 601:
      switch (pattern143 (x1))
        {
        case 0:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12805; /* aarch64_pred_reduc_fmaxnmqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12810; /* aarch64_pred_reduc_fmaxnmqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12815; /* aarch64_pred_reduc_fmaxnmqv_vnx2df */

        default:
          return -1;
        }

    case 602:
      switch (pattern143 (x1))
        {
        case 0:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12806; /* aarch64_pred_reduc_fminqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12811; /* aarch64_pred_reduc_fminqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12816; /* aarch64_pred_reduc_fminqv_vnx2df */

        default:
          return -1;
        }

    case 603:
      switch (pattern143 (x1))
        {
        case 0:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12807; /* aarch64_pred_reduc_fminnmqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12812; /* aarch64_pred_reduc_fminnmqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12817; /* aarch64_pred_reduc_fminnmqv_vnx2df */

        default:
          return -1;
        }

    case 596:
      return recog_87 (x1, insn, pnum_clobbers);

    case 545:
      return recog_108 (x1, insn, pnum_clobbers);

    case 576:
      return recog_132 (x1, insn, pnum_clobbers);

    case 574:
      return recog_130 (x1, insn, pnum_clobbers);

    case 577:
      return recog_131 (x1, insn, pnum_clobbers);

    case 575:
      return recog_129 (x1, insn, pnum_clobbers);

    case 420:
      return recog_174 (x1, insn, pnum_clobbers);

    case 421:
      return recog_173 (x1, insn, pnum_clobbers);

    case 422:
      return recog_172 (x1, insn, pnum_clobbers);

    case 470:
      if (pattern76 (x1, 
E_VNx16QImode) != 0
          || !
#line 3996 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 12952; /* aarch64_sve2_histsegvnx16qi */

    case 682:
      if (pattern146 (x1, 
E_DImode, 
67) != 0)
        return -1;
      return 12988; /* aarch64_old_vg_saved */

    case 690:
      if (pnum_clobbers == NULL
          || pattern147 (x1, 
91, 
90) != 0)
        return -1;
      *pnum_clobbers = 7;
      return 12994; /* aarch64_tpidr2_save */

    case 689:
      if (pattern147 (x1, 
93, 
91) != 0)
        return -1;
      return 12997; /* aarch64_initial_zero_za */

    case 693:
      return recog_153 (x1, insn, pnum_clobbers);

    case 692:
      if (GET_MODE (x2) != E_DImode
          || pattern264 (x2, 
92, 
E_DImode, 
90) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 13001; /* aarch64_read_tpidr2 */

    case 700:
      return recog_161 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sve_dup_operand (operands[1], E_QImode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6401; /* *vec_duplicatevnx16qi_reg */

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6420; /* aarch64_vec_duplicate_vqvnx16qi_le */

        default:
          return -1;
        }

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6402; /* *vec_duplicatevnx8qi_reg */

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6403; /* *vec_duplicatevnx4qi_reg */

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6404; /* *vec_duplicatevnx2qi_reg */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!aarch64_sve_dup_operand (operands[1], E_HImode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6405; /* *vec_duplicatevnx8hi_reg */

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6421; /* aarch64_vec_duplicate_vqvnx8hi_le */

        default:
          return -1;
        }

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6406; /* *vec_duplicatevnx4hi_reg */

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6407; /* *vec_duplicatevnx2hi_reg */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!aarch64_sve_dup_operand (operands[1], E_SImode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6408; /* *vec_duplicatevnx4si_reg */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6422; /* aarch64_vec_duplicate_vqvnx4si_le */

        default:
          return -1;
        }

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2SImode
          || !aarch64_sve_dup_operand (operands[1], E_SImode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6409; /* *vec_duplicatevnx2si_reg */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!aarch64_sve_dup_operand (operands[1], E_DImode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6410; /* *vec_duplicatevnx2di_reg */

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6423; /* aarch64_vec_duplicate_vqvnx2di_le */

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_HFmode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6411; /* *vec_duplicatevnx8hf_reg */

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6425; /* aarch64_vec_duplicate_vqvnx8hf_le */

        default:
          return -1;
        }

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6412; /* *vec_duplicatevnx4hf_reg */

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6413; /* *vec_duplicatevnx2hf_reg */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_BFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_BFmode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6414; /* *vec_duplicatevnx8bf_reg */

        case E_V8BFmode:
          if (!nonimmediate_operand (operands[1], E_V8BFmode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6424; /* aarch64_vec_duplicate_vqvnx8bf_le */

        default:
          return -1;
        }

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6415; /* *vec_duplicatevnx4bf_reg */

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6416; /* *vec_duplicatevnx2bf_reg */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_SFmode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6417; /* *vec_duplicatevnx4sf_reg */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6426; /* aarch64_vec_duplicate_vqvnx4sf_le */

        default:
          return -1;
        }

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2SFmode
          || !aarch64_sve_dup_operand (operands[1], E_SFmode)
          || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6418; /* *vec_duplicatevnx2sf_reg */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_DFmode)
              || !
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6419; /* *vec_duplicatevnx2df_reg */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6427; /* aarch64_vec_duplicate_vqvnx2df_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_487 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x2, 0);
              operands[4] = x7;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x5, 1);
              switch (GET_CODE (x9))
                {
                case SIGN_EXTEND:
                  switch (pattern967 (x2))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3084; /* *aarch64_shaddv8qi_vec_concatz_be_insn */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3100; /* *aarch64_shaddv4hi_vec_concatz_be_insn */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3116; /* *aarch64_shaddv2si_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_VECTOR:
                  operands[3] = x9;
                  x10 = XEXP (x4, 1);
                  operands[2] = x10;
                  switch (pattern1026 (x2))
                    {
                    case 0:
                      if (pattern545 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3796; /* aarch64_srshr_nv8qi_vec_concatz_be_insn */

                    case 1:
                      if (pattern547 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3804; /* aarch64_srshr_nv4hi_vec_concatz_be_insn */

                    case 2:
                      if (pattern549 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3812; /* aarch64_srshr_nv2si_vec_concatz_be_insn */

                    case 3:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3822; /* aarch64_srshr_ndi_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x9 = XEXP (x5, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x7 = XEXP (x2, 0);
              operands[4] = x7;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              switch (pattern967 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3090; /* *aarch64_uhaddv8qi_vec_concatz_be_insn */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3106; /* *aarch64_uhaddv4hi_vec_concatz_be_insn */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3122; /* *aarch64_uhaddv2si_vec_concatz_be_insn */

                default:
                  return -1;
                }

            case PLUS:
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              x8 = XEXP (x6, 0);
              switch (GET_CODE (x8))
                {
                case SIGN_EXTEND:
                  switch (pattern912 (x2, 
SIGN_EXTEND))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3132; /* *aarch64_srhaddv8qi_vec_concatz_be_insn */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3140; /* *aarch64_srhaddv4hi_vec_concatz_be_insn */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3148; /* *aarch64_srhaddv2si_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern912 (x2, 
ZERO_EXTEND))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3135; /* *aarch64_urhaddv8qi_vec_concatz_be_insn */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3143; /* *aarch64_urhaddv4hi_vec_concatz_be_insn */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3151; /* *aarch64_urhaddv2si_vec_concatz_be_insn */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[1] = x8;
                  x7 = XEXP (x2, 0);
                  operands[5] = x7;
                  x11 = XEXP (x6, 1);
                  operands[2] = x11;
                  switch (pattern1025 (x2))
                    {
                    case 0:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3174; /* aarch64_raddhnv8hi_insn_vec_concatz_be */

                    case 1:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3180; /* aarch64_raddhnv4si_insn_vec_concatz_be */

                    case 2:
                      if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3186; /* aarch64_raddhnv2di_insn_vec_concatz_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              x7 = XEXP (x2, 0);
              operands[4] = x7;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              x10 = XEXP (x4, 1);
              operands[3] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1085 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3156; /* aarch64_addhnv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1085 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3162; /* aarch64_addhnv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1085 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3168; /* aarch64_addhnv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case MINUS:
              x7 = XEXP (x2, 0);
              operands[5] = x7;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              switch (pattern1025 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3177; /* aarch64_rsubhnv8hi_insn_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3183; /* aarch64_rsubhnv4si_insn_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3189; /* aarch64_rsubhnv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern914 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3087; /* *aarch64_shsubv8qi_vec_concatz_be_insn */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3103; /* *aarch64_shsubv4hi_vec_concatz_be_insn */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3119; /* *aarch64_shsubv2si_vec_concatz_be_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern914 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3093; /* *aarch64_uhsubv8qi_vec_concatz_be_insn */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3109; /* *aarch64_uhsubv4hi_vec_concatz_be_insn */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3125; /* *aarch64_uhsubv2si_vec_concatz_be_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1085 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3159; /* aarch64_subhnv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1085 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3165; /* aarch64_subhnv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1085 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3171; /* aarch64_subhnv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (pattern542 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3913; /* *aarch64_sshrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3931; /* *aarch64_sshrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3949; /* *aarch64_sshrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMIN:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SMAX)
        return -1;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1086 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5466 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3389; /* *aarch64_sqmovunv8hi_insn_vec_concatz_be */

            case E_V8HImode:
              if (pattern1086 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5466 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3392; /* *aarch64_sqmovunv4si_insn_vec_concatz_be */

            case E_V4SImode:
              if (pattern1086 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5466 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3395; /* *aarch64_sqmovunv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        case ASHIFTRT:
          x11 = XEXP (x6, 1);
          operands[2] = x11;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[1] = x8;
              x7 = XEXP (x2, 0);
              operands[5] = x7;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              x10 = XEXP (x4, 1);
              operands[4] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1175 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V8HImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V8HImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3988; /* *aarch64_sqshrun_nv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1175 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V4SImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V4SImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3991; /* *aarch64_sqshrun_nv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1175 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V2DImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V2DImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3994; /* *aarch64_sqshrun_nv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case PLUS:
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != SIGN_EXTEND)
                return -1;
              x7 = XEXP (x2, 0);
              operands[6] = x7;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x14 = XEXP (x8, 1);
              operands[3] = x14;
              x9 = XEXP (x5, 1);
              operands[4] = x9;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1236 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V8SImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V8SImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4000; /* *aarch64_sqrshrun_nv8hi_insn_vec_concatz_be */

                case E_V8HImode:
                  if (pattern1236 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V4DImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V4DImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4003; /* *aarch64_sqrshrun_nv4si_insn_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1236 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V2TImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V2TImode)
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 4006; /* *aarch64_sqrshrun_nv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          switch (pattern1026 (x2))
            {
            case 0:
              if (pattern1144 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V8HImode:
                  if (pattern544 (x5, 
E_V8QImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3799; /* aarch64_urshr_nv8qi_vec_concatz_be_insn */

                case E_V8SImode:
                  if (pattern544 (x5, 
E_V8HImode, 
E_V8SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3961; /* *aarch64_rshrn_nv8hi_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case 1:
              if (pattern1144 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V4SImode:
                  if (pattern546 (x5, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3807; /* aarch64_urshr_nv4hi_vec_concatz_be_insn */

                case E_V4DImode:
                  if (pattern546 (x5, 
E_V4SImode, 
E_V4DImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3970; /* *aarch64_rshrn_nv4si_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case 2:
              if (pattern1144 (x2, 
E_V2SImode, 
E_V4SImode) != 0)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2DImode:
                  if (pattern548 (x5, 
E_V2SImode, 
E_V2DImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3815; /* aarch64_urshr_nv2si_vec_concatz_be_insn */

                case E_V2TImode:
                  if (pattern548 (x5, 
E_V2DImode, 
E_V2TImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3979; /* *aarch64_rshrn_nv2di_insn_vec_concatz_be */

                default:
                  return -1;
                }

            case 3:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 3825; /* aarch64_urshr_ndi_vec_concatz_be_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern543 (x2))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3916; /* *aarch64_shrn_nv8hi_insn_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3934; /* *aarch64_shrn_nv4si_insn_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3952; /* *aarch64_shrn_nv2di_insn_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern541 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 9874 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5250; /* truncv8hiv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 9874 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5253; /* truncv4siv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 9874 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 5256; /* truncv2div2si2_vec_concatz_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern432 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1600; /* negv8qi2_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1604; /* negv4hi2_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1608; /* negv2si2_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2397; /* negv4hf2_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2401; /* negv2sf2_vec_concatz_le */

        default:
          return -1;
        }

    case LT:
      switch (pattern435 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4077; /* aarch64_cmltv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4097; /* aarch64_cmltv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4242; /* aarch64_cmltv4hf_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4117; /* aarch64_cmltv2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4262; /* aarch64_cmltv2sf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4297; /* aarch64_cmltdf_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4312; /* aarch64_facltv4hf_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4328; /* aarch64_facltv2sf_vec_concatz_le */

        case 8:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4356; /* aarch64_facltdf_vec_concatz_le */

        default:
          return -1;
        }

    case LE:
      switch (pattern435 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4080; /* aarch64_cmlev8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4100; /* aarch64_cmlev4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4245; /* aarch64_cmlev4hf_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4120; /* aarch64_cmlev2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4265; /* aarch64_cmlev2sf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4300; /* aarch64_cmledf_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4315; /* aarch64_faclev4hf_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4331; /* aarch64_faclev2sf_vec_concatz_le */

        case 8:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4359; /* aarch64_facledf_vec_concatz_le */

        default:
          return -1;
        }

    case EQ:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (pattern433 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4083; /* aarch64_cmeqv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4103; /* aarch64_cmeqv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4248; /* aarch64_cmeqv4hf_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4123; /* aarch64_cmeqv2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4268; /* aarch64_cmeqv2sf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4303; /* aarch64_cmeqdf_vec_concatz_le */

        default:
          return -1;
        }

    case GE:
      switch (pattern435 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4086; /* aarch64_cmgev8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4106; /* aarch64_cmgev4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4251; /* aarch64_cmgev4hf_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4126; /* aarch64_cmgev2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4271; /* aarch64_cmgev2sf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4306; /* aarch64_cmgedf_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4318; /* aarch64_facgev4hf_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4334; /* aarch64_facgev2sf_vec_concatz_le */

        case 8:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4362; /* aarch64_facgedf_vec_concatz_le */

        default:
          return -1;
        }

    case GT:
      switch (pattern435 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4089; /* aarch64_cmgtv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4109; /* aarch64_cmgtv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4254; /* aarch64_cmgtv4hf_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4129; /* aarch64_cmgtv2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4274; /* aarch64_cmgtv2sf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4309; /* aarch64_cmgtdf_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4321; /* aarch64_facgtv4hf_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4337; /* aarch64_facgtv2sf_vec_concatz_le */

        case 8:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4365; /* aarch64_facgtdf_vec_concatz_le */

        default:
          return -1;
        }

    case LTU:
      switch (pattern437 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4152; /* aarch64_cmltuv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4168; /* aarch64_cmltuv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4184; /* aarch64_cmltuv2si_vec_concatz_le */

        default:
          return -1;
        }

    case LEU:
      switch (pattern437 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4155; /* aarch64_cmleuv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4171; /* aarch64_cmleuv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4187; /* aarch64_cmleuv2si_vec_concatz_le */

        default:
          return -1;
        }

    case GEU:
      switch (pattern437 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4158; /* aarch64_cmgeuv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4174; /* aarch64_cmgeuv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4190; /* aarch64_cmgeuv2si_vec_concatz_le */

        default:
          return -1;
        }

    case GTU:
      switch (pattern437 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4161; /* aarch64_cmgtuv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4177; /* aarch64_cmgtuv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4193; /* aarch64_cmgtuv2si_vec_concatz_le */

        default:
          return -1;
        }

    case NE:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != AND
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7399 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 4239; /* *aarch64_cmtstdi_vec_concatz_le */

    default:
      return -1;
    }
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_461 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern307 (x3))
            {
            case 0:
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              switch (pattern51 (x3))
                {
                case 0:
                  return 206; /* *add_lsl_si */

                case 1:
                  return 209; /* *add_lsl_di */

                default:
                  break;
                }
              if (!subreg_lowpart_operator (x6, E_SImode)
                  || pattern661 (x3) != 0
                  || !
#line 6269 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32
   && UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32
   && INTVAL (operands[3]) == INTVAL (operands[5])))
                return -1;
              return 795; /* *extrsi5_insn_di */

            case 1:
              if (!
#line 6209 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (SImode) &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == GET_MODE_BITSIZE (SImode))))
                return -1;
              return 777; /* *extrsi5_insn */

            case 2:
              if (!
#line 6209 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (DImode) &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == GET_MODE_BITSIZE (DImode))))
                return -1;
              return 780; /* *extrdi5_insn */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern388 (x3))
            {
            case 0:
              return 235; /* *add_extendqi_shft_si */

            case 1:
              return 239; /* *add_extendhi_shft_si */

            case 2:
              return 243; /* *add_extendsi_shft_si */

            case 3:
              return 237; /* *add_extendqi_shft_di */

            case 4:
              return 241; /* *add_extendhi_shft_di */

            case 5:
              return 245; /* *add_extendsi_shft_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern388 (x3))
            {
            case 0:
              return 236; /* *add_zero_extendqi_shft_si */

            case 1:
              return 240; /* *add_zero_extendhi_shft_si */

            case 2:
              return 244; /* *add_zero_extendsi_shft_si */

            case 3:
              return 238; /* *add_zero_extendqi_shft_di */

            case 4:
              return 242; /* *add_zero_extendhi_shft_di */

            case 5:
              return 246; /* *add_zero_extendsi_shft_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          operands[2] = x7;
          switch (pattern499 (x3))
            {
            case 0:
              return 207; /* *add_asr_si */

            case 1:
              return 210; /* *add_asr_di */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case CONST:
          switch (pattern390 (x3))
            {
            case 0:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1893; /* aarch64_ssra_nv8qi_insn */

            case 1:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1895; /* aarch64_ssra_nv16qi_insn */

            case 2:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1897; /* aarch64_ssra_nv4hi_insn */

            case 3:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1899; /* aarch64_ssra_nv8hi_insn */

            case 4:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1901; /* aarch64_ssra_nv2si_insn */

            case 5:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1903; /* aarch64_ssra_nv4si_insn */

            case 6:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1905; /* aarch64_ssra_nv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
              switch (pattern54 (x3))
                {
                case 0:
                  return 208; /* *add_lsr_si */

                case 1:
                  return 211; /* *add_lsr_di */

                case 2:
                  if (!
#line 6224 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (SImode)
   && (UINTVAL (operands[3]) + UINTVAL (operands[4])
       == GET_MODE_BITSIZE (SImode))))
                    return -1;
                  return 783; /* *extrsi5_insn_alt */

                case 3:
                  if (!
#line 6224 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (DImode)
   && (UINTVAL (operands[3]) + UINTVAL (operands[4])
       == GET_MODE_BITSIZE (DImode))))
                    return -1;
                  return 786; /* *extrdi5_insn_alt */

                default:
                  return -1;
                }

            case CONST_VECTOR:
            case CONST:
              switch (pattern390 (x3))
                {
                case 0:
                  if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 1894; /* aarch64_usra_nv8qi_insn */

                case 1:
                  if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 1896; /* aarch64_usra_nv16qi_insn */

                case 2:
                  if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 1898; /* aarch64_usra_nv4hi_insn */

                case 3:
                  if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 1900; /* aarch64_usra_nv8hi_insn */

                case 4:
                  if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 1902; /* aarch64_usra_nv2si_insn */

                case 5:
                  if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 1904; /* aarch64_usra_nv4si_insn */

                case 6:
                  if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 1906; /* aarch64_usra_nv2di_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          switch (pattern392 (x3))
            {
            case 0:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3214; /* *bitmask_shift_plusv8hi */

            case 1:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3215; /* *bitmask_shift_plusv4si */

            case 2:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3216; /* *bitmask_shift_plusv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_464 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_463 (x1, insn, pnum_clobbers);

    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case GEU:
        case LTU:
          operands[3] = x5;
          x7 = XEXP (x4, 1);
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern808 (x3, 
E_SImode) != 0)
                return -1;
              return 251; /* *addsi3_carryin */

            case E_DImode:
              if (pattern808 (x3, 
E_DImode) != 0)
                return -1;
              return 252; /* *adddi3_carryin */

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != VEC_SELECT)
            return -1;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          x9 = XEXP (x7, 1);
          operands[4] = x9;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          x10 = XEXP (x5, 0);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              switch (pattern885 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1701; /* *aarch64_sadalpv8qi_insn */

                case 1:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1707; /* *aarch64_sadalpv16qi_insn */

                case 2:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1709; /* *aarch64_sadalpv4hi_insn */

                case 3:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1715; /* *aarch64_sadalpv8hi_insn */

                case 4:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1717; /* *aarch64_sadalpv4si_insn */

                case 5:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1719; /* *aarch64_sadalpv2si_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern885 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1704; /* *aarch64_uadalpv8qi_insn */

                case 1:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1708; /* *aarch64_uadalpv16qi_insn */

                case 2:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1712; /* *aarch64_uadalpv4hi_insn */

                case 3:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1716; /* *aarch64_uadalpv8hi_insn */

                case 4:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1718; /* *aarch64_uadalpv4si_insn */

                case 5:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1722; /* *aarch64_uadalpv2si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ASHIFT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          if (!aarch64_imm3 (operands[2], E_VOIDmode)
              || !const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1004 (x3, 
E_SImode) != 0
                  || !
#line 3260 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
                return -1;
              return 262; /* *add_uxtsi_shift2 */

            case E_DImode:
              if (pattern1004 (x3, 
E_DImode) != 0
                  || !
#line 3260 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
                return -1;
              return 263; /* *add_uxtdi_shift2 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x5;
          if (!register_operand (operands[2], E_VNx2DImode)
              || !register_operand (operands[0], E_VNx2DImode)
              || GET_MODE (x3) != E_VNx2DImode
              || GET_MODE (x4) != E_VNx2DImode
              || !aarch64_sve_uxtw_immediate (operands[3], E_VNx2DImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_VNx2DImode)
              || !
#line 4177 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 8008; /* *aarch64_adr_uxtw_and */

        default:
          return -1;
        }

    case MULT:
      return recog_460 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_465 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern293 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 498; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern293 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 495; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern293 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 496; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 500; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern293 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 497; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 5010 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 501; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_462 (x1, insn, pnum_clobbers);

    case MINUS:
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SMAX:
          switch (pattern514 (x3, 
SMIN))
            {
            case 0:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1725; /* aarch64_sabav8qi */

            case 1:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1731; /* aarch64_sabav16qi */

            case 2:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1733; /* aarch64_sabav4hi */

            case 3:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1739; /* aarch64_sabav8hi */

            case 4:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1741; /* aarch64_sabav2si */

            case 5:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1747; /* aarch64_sabav4si */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern514 (x3, 
UMIN))
            {
            case 0:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1728; /* aarch64_uabav8qi */

            case 1:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1732; /* aarch64_uabav16qi */

            case 2:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1736; /* aarch64_uabav4hi */

            case 3:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1740; /* aarch64_uabav8hi */

            case 4:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1744; /* aarch64_uabav2si */

            case 5:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1748; /* aarch64_uabav4si */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 125)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != UNSPEC
              || XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 125)
            return -1;
          x11 = XVECEXP (x5, 0, 0);
          operands[4] = x11;
          x12 = XVECEXP (x7, 0, 0);
          operands[5] = x12;
          x13 = XVECEXP (x5, 0, 1);
          switch (GET_CODE (x13))
            {
            case SMAX:
              switch (pattern1135 (x3, 
SMIN))
                {
                case 0:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12066; /* *aarch64_sve2_sabavnx16qi */

                case 1:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12068; /* *aarch64_sve2_sabavnx8hi */

                case 2:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12070; /* *aarch64_sve2_sabavnx4si */

                case 3:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12072; /* *aarch64_sve2_sabavnx2di */

                default:
                  return -1;
                }

            case UMAX:
              switch (pattern1135 (x3, 
UMIN))
                {
                case 0:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12067; /* *aarch64_sve2_uabavnx16qi */

                case 1:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12069; /* *aarch64_sve2_uabavnx8hi */

                case 2:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12071; /* *aarch64_sve2_uabavnx4si */

                case 3:
                  if (!
#line 2058 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 12073; /* *aarch64_sve2_uabavnx2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ASHIFTRT:
          switch (pattern515 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1914; /* aarch64_srsra_nv8qi_insn */

            case 1:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1916; /* aarch64_srsra_nv16qi_insn */

            case 2:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1918; /* aarch64_srsra_nv4hi_insn */

            case 3:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1920; /* aarch64_srsra_nv8hi_insn */

            case 4:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1922; /* aarch64_srsra_nv2si_insn */

            case 5:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1924; /* aarch64_srsra_nv4si_insn */

            case 6:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1926; /* aarch64_srsra_nv2di_insn */

            case 7:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1928; /* aarch64_srsra_ndi_insn */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern515 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1915; /* aarch64_ursra_nv8qi_insn */

            case 1:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1917; /* aarch64_ursra_nv16qi_insn */

            case 2:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1919; /* aarch64_ursra_nv4hi_insn */

            case 3:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1921; /* aarch64_ursra_nv8hi_insn */

            case 4:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1923; /* aarch64_ursra_nv2si_insn */

            case 5:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1925; /* aarch64_ursra_nv4si_insn */

            case 6:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1927; /* aarch64_ursra_nv2di_insn */

            case 7:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1929; /* aarch64_ursra_ndi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern517 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2794; /* *aarch64_saddlpv8qi_insn */

            case 1:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2800; /* *aarch64_saddlpv16qi_insn */

            case 2:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2802; /* *aarch64_saddlpv4hi_insn */

            case 3:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2808; /* *aarch64_saddlpv8hi_insn */

            case 4:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2810; /* *aarch64_saddlpv4si_insn */

            case 5:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2812; /* *aarch64_saddlpv2si_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern517 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2797; /* *aarch64_uaddlpv8qi_insn */

            case 1:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2801; /* *aarch64_uaddlpv16qi_insn */

            case 2:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2805; /* *aarch64_uaddlpv4hi_insn */

            case 3:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2809; /* *aarch64_uaddlpv8hi_insn */

            case 4:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2811; /* *aarch64_uaddlpv4si_insn */

            case 5:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2815; /* *aarch64_uaddlpv2si_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x14 = XEXP (x6, 0);
          if (GET_CODE (x14) != VEC_CONCAT)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          x15 = XEXP (x6, 1);
          operands[4] = x15;
          x16 = XEXP (x14, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x17 = XEXP (x14, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern1136 (x3, 
E_V16QImode, 
E_V8QImode) != 0
                  || !
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4371; /* aarch64_addpv8qi_insn */

            case E_V4HImode:
              if (pattern1136 (x3, 
E_V8HImode, 
E_V4HImode) != 0
                  || !
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4374; /* aarch64_addpv4hi_insn */

            case E_V2SImode:
              if (pattern1136 (x3, 
E_V4SImode, 
E_V2SImode) != 0
                  || !
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4377; /* aarch64_addpv2si_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern462 (x3))
            {
            case 0:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4380; /* *aarch64_addp_same_regv16qi */

            case 1:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4381; /* *aarch64_addp_same_regv8hi */

            case 2:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4382; /* *aarch64_addp_same_regv4si */

            case 3:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4383; /* *aarch64_addp_same_regv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_466 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          switch (pattern493 (x3))
            {
            case 0:
              return 106; /* *extendsidi2_aarch64 */

            case 1:
              return 111; /* *extendqidi2_aarch64 */

            case 2:
              return 113; /* *extendhidi2_aarch64 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern494 (x3))
            {
            case 0:
              return 110; /* *extendqisi2_aarch64 */

            case 1:
              return 112; /* *extendhisi2_aarch64 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 118; /* *extendqihi2_aarch64 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 9844 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5242; /* extendv8qiv8hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 9844 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5244; /* extendv4hiv4si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 9844 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5246; /* extendv2siv2di2 */

        case E_VNx16HImode:
          if (!aligned_register_operand (operands[0], E_VNx16HImode)
              || GET_MODE (x3) != E_VNx16HImode
              || !register_operand (operands[1], E_VNx16QImode)
              || !
#line 2201 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12090; /* extendvnx16qivnx16hi2 */

        case E_VNx8SImode:
          if (!aligned_register_operand (operands[0], E_VNx8SImode)
              || GET_MODE (x3) != E_VNx8SImode
              || !register_operand (operands[1], E_VNx8HImode)
              || !
#line 2201 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12092; /* extendvnx8hivnx8si2 */

        case E_VNx4DImode:
          if (!aligned_register_operand (operands[0], E_VNx4DImode)
              || GET_MODE (x3) != E_VNx4DImode
              || !register_operand (operands[1], E_VNx4SImode)
              || !
#line 2201 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12094; /* extendvnx4sivnx4di2 */

        case E_VNx32HImode:
          if (!aligned_register_operand (operands[0], E_VNx32HImode)
              || GET_MODE (x3) != E_VNx32HImode
              || !aligned_register_operand (operands[1], E_VNx32QImode)
              || !
#line 2209 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12096; /* extendvnx32qivnx32hi2 */

        case E_VNx16SImode:
          if (!aligned_register_operand (operands[0], E_VNx16SImode)
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[1], E_VNx16HImode)
              || !
#line 2209 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12098; /* extendvnx16hivnx16si2 */

        case E_VNx8DImode:
          if (!aligned_register_operand (operands[0], E_VNx8DImode)
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[1], E_VNx8SImode)
              || !
#line 2209 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12100; /* extendvnx8sivnx8di2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern291 (x3))
        {
        case 0:
          if (!
#line 6281 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 798; /* *extendsi_ashlqi */

        case 1:
          if (!
#line 6281 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 802; /* *extendsi_ashlhi */

        case 2:
          if (!
#line 6281 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 800; /* *extenddi_ashlqi */

        case 3:
          if (!
#line 6281 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 804; /* *extenddi_ashlhi */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern291 (x3))
        {
        case 0:
          if (!
#line 6307 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 810; /* *extendsi_ashrqi */

        case 1:
          if (!
#line 6307 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 812; /* *extendsi_ashrhi */

        case 2:
          if (!
#line 6307 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 811; /* *extenddi_ashrqi */

        case 3:
          if (!
#line 6307 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 813; /* *extenddi_ashrhi */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern368 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) == 0
              && 
#line 1968 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2228; /* aarch64_simd_vec_unpacks_hi_v16qi */
          break;

        case E_V4SImode:
          if (pattern368 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) == 0
              && 
#line 1968 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2230; /* aarch64_simd_vec_unpacks_hi_v8hi */
          break;

        case E_V2DImode:
          if (pattern368 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) == 0
              && 
#line 1968 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2232; /* aarch64_simd_vec_unpacks_hi_v4si */
          break;

        default:
          break;
        }
      if (XVECLEN (x5, 0) != 1)
        return -1;
      switch (pattern496 (x3))
        {
        case 0:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2918; /* *aarch64_get_lane_extendsiv8qi */

        case 1:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2920; /* *aarch64_get_lane_extendsiv16qi */

        case 2:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2922; /* *aarch64_get_lane_extendsiv4hi */

        case 3:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2924; /* *aarch64_get_lane_extendsiv8hi */

        case 4:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2919; /* *aarch64_get_lane_extenddiv8qi */

        case 5:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2921; /* *aarch64_get_lane_extenddiv16qi */

        case 6:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2923; /* *aarch64_get_lane_extenddiv4hi */

        case 7:
          if (!
#line 4229 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2925; /* *aarch64_get_lane_extenddiv8hi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 25)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern881 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 8)))
                return -1;
              return 5513; /* *aarch64_atomic_loadqi_rcpc_sext */

            case 1:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 16)))
                return -1;
              return 5515; /* *aarch64_atomic_loadhi_rcpc_sext */

            case 2:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 32)))
                return -1;
              return 5517; /* *aarch64_atomic_loadsi_rcpc_sext */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern881 (x3, 
E_DImode))
            {
            case 0:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 8)))
                return -1;
              return 5514; /* *aarch64_atomic_loadqi_rcpc_sext */

            case 1:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 16)))
                return -1;
              return 5516; /* *aarch64_atomic_loadhi_rcpc_sext */

            case 2:
              if (!
#line 725 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 32)))
                return -1;
              return 5518; /* *aarch64_atomic_loadsi_rcpc_sext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 3)
        return -1;
      switch (pattern616 (x3))
        {
        case 0:
          if (!
#line 10417 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11034; /* aarch64_sve_sqincsi_pat */

        case 1:
          if (!
#line 10771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11080; /* *aarch64_sve_sqincsivnx16bi_cntp */

        case 2:
          if (!
#line 10771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11082; /* *aarch64_sve_sqincsivnx8bi_cntp */

        case 3:
          if (!
#line 10771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11084; /* *aarch64_sve_sqincsivnx4bi_cntp */

        case 4:
          if (!
#line 10771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11086; /* *aarch64_sve_sqincsivnx2bi_cntp */

        default:
          return -1;
        }

    case SS_MINUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3)
        return -1;
      switch (pattern618 (x3))
        {
        case 0:
          if (!
#line 10567 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11049; /* aarch64_sve_sqdecsi_pat */

        case 1:
          if (!
#line 11004 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11113; /* *aarch64_sve_sqdecsivnx16bi_cntp */

        case 2:
          if (!
#line 11004 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11115; /* *aarch64_sve_sqdecsivnx8bi_cntp */

        case 3:
          if (!
#line 11004 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11117; /* *aarch64_sve_sqdecsivnx4bi_cntp */

        case 4:
          if (!
#line 11004 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11119; /* *aarch64_sve_sqdecsivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_531 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern39 (x3))
        {
        case 0:
          if (!
#line 7392 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 1085; /* *aarch64_uminsi3_cssc */

        case 1:
          if (!
#line 7392 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 1089; /* *aarch64_umindi3_cssc */

        case 2:
          if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2081; /* uminv8qi3 */

        case 3:
          if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2087; /* uminv16qi3 */

        case 4:
          if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2097; /* uminv4hi3 */

        case 5:
          if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2103; /* uminv8hi3 */

        case 6:
          if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2113; /* uminv2si3 */

        case 7:
          if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2119; /* uminv4si3 */

        case 8:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11459; /* *uminvnx32qi3 */

        case 9:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11463; /* *uminvnx16hi3 */

        case 10:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11467; /* *uminvnx8si3 */

        case 11:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11471; /* *uminvnx4di3 */

        case 12:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11475; /* *uminvnx64qi3 */

        case 13:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11479; /* *uminvnx32hi3 */

        case 14:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11483; /* *uminvnx16si3 */

        case 15:
          if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11487; /* *uminvnx8di3 */

        case 16:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7423; /* *post_ra_uminvnx16qi3 */

        case 17:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7428; /* *post_ra_uminvnx8qi3 */

        case 18:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7433; /* *post_ra_uminvnx4qi3 */

        case 19:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7438; /* *post_ra_uminvnx2qi3 */

        case 20:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7443; /* *post_ra_uminvnx8hi3 */

        case 21:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7448; /* *post_ra_uminvnx4hi3 */

        case 22:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7453; /* *post_ra_uminvnx2hi3 */

        case 23:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7458; /* *post_ra_uminvnx4si3 */

        case 24:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7463; /* *post_ra_uminvnx2si3 */

        case 25:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7468; /* *post_ra_uminvnx2di3 */

        case 26:
          if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7473; /* *post_ra_uminv2di3 */

        case 27:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11492; /* aarch64_sve_single_uminvnx32qi */

        case 28:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11497; /* aarch64_sve_single_uminvnx16hi */

        case 29:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11502; /* aarch64_sve_single_uminvnx8si */

        case 30:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11507; /* aarch64_sve_single_uminvnx4di */

        case 31:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11512; /* aarch64_sve_single_uminvnx64qi */

        case 32:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11517; /* aarch64_sve_single_uminvnx32hi */

        case 33:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11522; /* aarch64_sve_single_uminvnx16si */

        case 34:
          if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11527; /* aarch64_sve_single_uminvnx8di */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern320 (x3))
        {
        case 0:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11577; /* aarch64_sve_uclampvnx16qi */

        case 1:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11579; /* aarch64_sve_uclampvnx8hi */

        case 2:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11581; /* aarch64_sve_uclampvnx4si */

        case 3:
          if (!
#line 786 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11583; /* aarch64_sve_uclampvnx2di */

        case 4:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11593; /* aarch64_sve_uclamp_singlevnx32qi */

        case 5:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11595; /* aarch64_sve_uclamp_singlevnx16hi */

        case 6:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11597; /* aarch64_sve_uclamp_singlevnx8si */

        case 7:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11599; /* aarch64_sve_uclamp_singlevnx4di */

        case 8:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11601; /* aarch64_sve_uclamp_singlevnx64qi */

        case 9:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11603; /* aarch64_sve_uclamp_singlevnx32hi */

        case 10:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11605; /* aarch64_sve_uclamp_singlevnx16si */

        case 11:
          if (!
#line 829 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11607; /* aarch64_sve_uclamp_singlevnx8di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_542 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern452 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3245; /* usaddv8qi3 */

        case 1:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3255; /* usaddv16qi3 */

        case 2:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3261; /* usaddv4hi3 */

        case 3:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3271; /* usaddv8hi3 */

        case 4:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3277; /* usaddv2si3 */

        case 5:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3287; /* usaddv4si3 */

        case 6:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3291; /* usaddv2di3 */

        case 7:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3295; /* usaddhi3 */

        case 8:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3299; /* usaddqi3 */

        case 9:
          *pnum_clobbers = 1;
          return 3306; /* usaddsi3 */

        case 10:
          *pnum_clobbers = 1;
          return 3308; /* usadddi3 */

        case 11:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8106; /* usaddvnx16qi3 */

        case 12:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8108; /* usaddvnx8hi3 */

        case 13:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8110; /* usaddvnx4si3 */

        case 14:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8112; /* usaddvnx2di3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern335 (x3))
        {
        case 0:
          if (!
#line 10381 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11032; /* aarch64_sve_uqincdi_pat */

        case 1:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11066; /* *aarch64_sve_uqincdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11069; /* *aarch64_sve_uqincdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11072; /* *aarch64_sve_uqincdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11075; /* *aarch64_sve_uqincdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern339 (x3))
        {
        case 0:
          if (!
#line 10446 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11038; /* aarch64_sve_uqincvnx2di_pat */

        case 1:
          if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11090; /* *aarch64_sve_uqincvnx2di_cntp */

        case 2:
          if (!
#line 10467 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11041; /* aarch64_sve_uqincvnx4si_pat */

        case 3:
          if (!
#line 10862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11093; /* *aarch64_sve_uqincvnx4si_cntp */

        case 4:
          if (!
#line 10502 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11044; /* *aarch64_sve_uqincvnx8hi_pat */

        case 5:
          if (!
#line 10903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11096; /* *aarch64_sve_uqincvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10059; /* *while_rwsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10069; /* *while_rwdivnx16bi_cc */
}

 int
recog_570 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10058; /* *while_ugesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10068; /* *while_ugedivnx16bi_cc */
}

 int
recog_579 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10196; /* while_gtsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10206; /* while_gtdivnx2bi_ptest */
}

 int
recog_589 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10155; /* while_gesivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10165; /* while_gedivnx8bi_ptest */
}

 int
recog_599 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  x7 = XVECEXP (x6, 0, 0);
  operands[6] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[7] = x8;
  if (!aarch64_sve_ptrue_flag (operands[7], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  switch (GET_CODE (x9))
    {
    case LT:
      switch (pattern1330 (x1, 
LT))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9581; /* *cmpltvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9591; /* *cmpltvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9621; /* *cmpltvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9601; /* *cmpltvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9631; /* *cmpltvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9651; /* *cmpltvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9611; /* *cmpltvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9641; /* *cmpltvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9661; /* *cmpltvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9671; /* *cmpltvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9681; /* *cmpltvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9691; /* *cmpltvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9721; /* *cmpltvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9701; /* *cmpltvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9731; /* *cmpltvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9751; /* *cmpltvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9711; /* *cmpltvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9741; /* *cmpltvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9761; /* *cmpltvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9771; /* *cmpltvnx2di_ptest */

        default:
          return -1;
        }

    case LE:
      switch (pattern1330 (x1, 
LE))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9582; /* *cmplevnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9592; /* *cmplevnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9622; /* *cmplevnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9602; /* *cmplevnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9632; /* *cmplevnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9652; /* *cmplevnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9612; /* *cmplevnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9642; /* *cmplevnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9662; /* *cmplevnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9672; /* *cmplevnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9682; /* *cmplevnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9692; /* *cmplevnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9722; /* *cmplevnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9702; /* *cmplevnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9732; /* *cmplevnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9752; /* *cmplevnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9712; /* *cmplevnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9742; /* *cmplevnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9762; /* *cmplevnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9772; /* *cmplevnx2di_ptest */

        default:
          return -1;
        }

    case EQ:
      switch (pattern1330 (x1, 
EQ))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9583; /* *cmpeqvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9593; /* *cmpeqvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9623; /* *cmpeqvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9603; /* *cmpeqvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9633; /* *cmpeqvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9653; /* *cmpeqvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9613; /* *cmpeqvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9643; /* *cmpeqvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9663; /* *cmpeqvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9673; /* *cmpeqvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9683; /* *cmpeqvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9693; /* *cmpeqvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9723; /* *cmpeqvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9703; /* *cmpeqvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9733; /* *cmpeqvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9753; /* *cmpeqvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9713; /* *cmpeqvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9743; /* *cmpeqvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9763; /* *cmpeqvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9773; /* *cmpeqvnx2di_ptest */

        default:
          return -1;
        }

    case NE:
      switch (pattern1330 (x1, 
NE))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9584; /* *cmpnevnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9594; /* *cmpnevnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9624; /* *cmpnevnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9604; /* *cmpnevnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9634; /* *cmpnevnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9654; /* *cmpnevnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9614; /* *cmpnevnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9644; /* *cmpnevnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9664; /* *cmpnevnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9674; /* *cmpnevnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9684; /* *cmpnevnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9694; /* *cmpnevnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9724; /* *cmpnevnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9704; /* *cmpnevnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9734; /* *cmpnevnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9754; /* *cmpnevnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9714; /* *cmpnevnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9744; /* *cmpnevnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9764; /* *cmpnevnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9774; /* *cmpnevnx2di_ptest */

        default:
          return -1;
        }

    case GE:
      switch (pattern1330 (x1, 
GE))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9585; /* *cmpgevnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9595; /* *cmpgevnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9625; /* *cmpgevnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9605; /* *cmpgevnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9635; /* *cmpgevnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9655; /* *cmpgevnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9615; /* *cmpgevnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9645; /* *cmpgevnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9665; /* *cmpgevnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9675; /* *cmpgevnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9685; /* *cmpgevnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9695; /* *cmpgevnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9725; /* *cmpgevnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9705; /* *cmpgevnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9735; /* *cmpgevnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9755; /* *cmpgevnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9715; /* *cmpgevnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9745; /* *cmpgevnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9765; /* *cmpgevnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9775; /* *cmpgevnx2di_ptest */

        default:
          return -1;
        }

    case GT:
      switch (pattern1330 (x1, 
GT))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9586; /* *cmpgtvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9596; /* *cmpgtvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9626; /* *cmpgtvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9606; /* *cmpgtvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9636; /* *cmpgtvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9656; /* *cmpgtvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9616; /* *cmpgtvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9646; /* *cmpgtvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9666; /* *cmpgtvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9676; /* *cmpgtvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9686; /* *cmpgtvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9696; /* *cmpgtvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9726; /* *cmpgtvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9706; /* *cmpgtvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9736; /* *cmpgtvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9756; /* *cmpgtvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9716; /* *cmpgtvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9746; /* *cmpgtvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9766; /* *cmpgtvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9776; /* *cmpgtvnx2di_ptest */

        default:
          return -1;
        }

    case LTU:
      switch (pattern1334 (x1, 
LTU))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9587; /* *cmplovnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9597; /* *cmplovnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9627; /* *cmplovnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9607; /* *cmplovnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9637; /* *cmplovnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9657; /* *cmplovnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9617; /* *cmplovnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9647; /* *cmplovnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9667; /* *cmplovnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9677; /* *cmplovnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9687; /* *cmplovnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9697; /* *cmplovnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9727; /* *cmplovnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9707; /* *cmplovnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9737; /* *cmplovnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9757; /* *cmplovnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9717; /* *cmplovnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9747; /* *cmplovnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9767; /* *cmplovnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9777; /* *cmplovnx2di_ptest */

        default:
          return -1;
        }

    case LEU:
      switch (pattern1334 (x1, 
LEU))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9588; /* *cmplsvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9598; /* *cmplsvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9628; /* *cmplsvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9608; /* *cmplsvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9638; /* *cmplsvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9658; /* *cmplsvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9618; /* *cmplsvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9648; /* *cmplsvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9668; /* *cmplsvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9678; /* *cmplsvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9688; /* *cmplsvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9698; /* *cmplsvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9728; /* *cmplsvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9708; /* *cmplsvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9738; /* *cmplsvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9758; /* *cmplsvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9718; /* *cmplsvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9748; /* *cmplsvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9768; /* *cmplsvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9778; /* *cmplsvnx2di_ptest */

        default:
          return -1;
        }

    case GEU:
      switch (pattern1334 (x1, 
GEU))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9589; /* *cmphsvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9599; /* *cmphsvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9629; /* *cmphsvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9609; /* *cmphsvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9639; /* *cmphsvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9659; /* *cmphsvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9619; /* *cmphsvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9649; /* *cmphsvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9669; /* *cmphsvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9679; /* *cmphsvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9689; /* *cmphsvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9699; /* *cmphsvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9729; /* *cmphsvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9709; /* *cmphsvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9739; /* *cmphsvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9759; /* *cmphsvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9719; /* *cmphsvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9749; /* *cmphsvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9769; /* *cmphsvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9779; /* *cmphsvnx2di_ptest */

        default:
          return -1;
        }

    case GTU:
      return recog_598 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_597 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern475 (x2))
        {
        case 0:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16QImode)
       || register_operand (operands[2], VNx16QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx16QImode)
   && register_operand (operands[2], VNx16QImode))))
            return NULL;
          return gen_split_429 (insn, operands);

        case 1:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8QImode)
       || register_operand (operands[2], VNx8QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8QImode)
   && register_operand (operands[2], VNx8QImode))))
            return NULL;
          return gen_split_430 (insn, operands);

        case 2:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4QImode)
       || register_operand (operands[2], VNx4QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4QImode)
   && register_operand (operands[2], VNx4QImode))))
            return NULL;
          return gen_split_431 (insn, operands);

        case 3:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2QImode)
       || register_operand (operands[2], VNx2QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2QImode)
   && register_operand (operands[2], VNx2QImode))))
            return NULL;
          return gen_split_432 (insn, operands);

        case 4:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HImode)
       || register_operand (operands[2], VNx8HImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HImode)
   && register_operand (operands[2], VNx8HImode))))
            return NULL;
          return gen_split_433 (insn, operands);

        case 5:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HImode)
       || register_operand (operands[2], VNx4HImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HImode)
   && register_operand (operands[2], VNx4HImode))))
            return NULL;
          return gen_split_434 (insn, operands);

        case 6:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HImode)
       || register_operand (operands[2], VNx2HImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HImode)
   && register_operand (operands[2], VNx2HImode))))
            return NULL;
          return gen_split_435 (insn, operands);

        case 7:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SImode)
       || register_operand (operands[2], VNx4SImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SImode)
   && register_operand (operands[2], VNx4SImode))))
            return NULL;
          return gen_split_436 (insn, operands);

        case 8:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SImode)
       || register_operand (operands[2], VNx2SImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SImode)
   && register_operand (operands[2], VNx2SImode))))
            return NULL;
          return gen_split_437 (insn, operands);

        case 9:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DImode)
       || register_operand (operands[2], VNx2DImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DImode)
   && register_operand (operands[2], VNx2DImode))))
            return NULL;
          return gen_split_438 (insn, operands);

        case 10:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HFmode)
       || register_operand (operands[2], VNx8HFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HFmode)
   && register_operand (operands[2], VNx8HFmode))))
            return NULL;
          return gen_split_439 (insn, operands);

        case 11:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HFmode)
       || register_operand (operands[2], VNx4HFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HFmode)
   && register_operand (operands[2], VNx4HFmode))))
            return NULL;
          return gen_split_440 (insn, operands);

        case 12:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HFmode)
       || register_operand (operands[2], VNx2HFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HFmode)
   && register_operand (operands[2], VNx2HFmode))))
            return NULL;
          return gen_split_441 (insn, operands);

        case 13:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BFmode)
       || register_operand (operands[2], VNx8BFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8BFmode)
   && register_operand (operands[2], VNx8BFmode))))
            return NULL;
          return gen_split_442 (insn, operands);

        case 14:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BFmode)
       || register_operand (operands[2], VNx4BFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4BFmode)
   && register_operand (operands[2], VNx4BFmode))))
            return NULL;
          return gen_split_443 (insn, operands);

        case 15:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BFmode)
       || register_operand (operands[2], VNx2BFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2BFmode)
   && register_operand (operands[2], VNx2BFmode))))
            return NULL;
          return gen_split_444 (insn, operands);

        case 16:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SFmode)
       || register_operand (operands[2], VNx4SFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SFmode)
   && register_operand (operands[2], VNx4SFmode))))
            return NULL;
          return gen_split_445 (insn, operands);

        case 17:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SFmode)
       || register_operand (operands[2], VNx2SFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SFmode)
   && register_operand (operands[2], VNx2SFmode))))
            return NULL;
          return gen_split_446 (insn, operands);

        case 18:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DFmode)
       || register_operand (operands[2], VNx2DFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DFmode)
   && register_operand (operands[2], VNx2DFmode))))
            return NULL;
          return gen_split_447 (insn, operands);

        case 19:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32QImode)
       || register_operand (operands[2], VNx32QImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_534 (insn, operands);

        case 20:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HImode)
       || register_operand (operands[2], VNx16HImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_535 (insn, operands);

        case 21:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SImode)
       || register_operand (operands[2], VNx8SImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_536 (insn, operands);

        case 22:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DImode)
       || register_operand (operands[2], VNx4DImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_537 (insn, operands);

        case 23:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BFmode)
       || register_operand (operands[2], VNx16BFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_538 (insn, operands);

        case 24:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HFmode)
       || register_operand (operands[2], VNx16HFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_539 (insn, operands);

        case 25:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SFmode)
       || register_operand (operands[2], VNx8SFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_540 (insn, operands);

        case 26:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DFmode)
       || register_operand (operands[2], VNx4DFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_541 (insn, operands);

        case 27:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx48QImode)
       || register_operand (operands[2], VNx48QImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_542 (insn, operands);

        case 28:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HImode)
       || register_operand (operands[2], VNx24HImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_543 (insn, operands);

        case 29:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SImode)
       || register_operand (operands[2], VNx12SImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_544 (insn, operands);

        case 30:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DImode)
       || register_operand (operands[2], VNx6DImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_545 (insn, operands);

        case 31:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24BFmode)
       || register_operand (operands[2], VNx24BFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_546 (insn, operands);

        case 32:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HFmode)
       || register_operand (operands[2], VNx24HFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_547 (insn, operands);

        case 33:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SFmode)
       || register_operand (operands[2], VNx12SFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_548 (insn, operands);

        case 34:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DFmode)
       || register_operand (operands[2], VNx6DFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_549 (insn, operands);

        case 35:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx64QImode)
       || register_operand (operands[2], VNx64QImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_550 (insn, operands);

        case 36:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HImode)
       || register_operand (operands[2], VNx32HImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_551 (insn, operands);

        case 37:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SImode)
       || register_operand (operands[2], VNx16SImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_552 (insn, operands);

        case 38:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DImode)
       || register_operand (operands[2], VNx8DImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_553 (insn, operands);

        case 39:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32BFmode)
       || register_operand (operands[2], VNx32BFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_554 (insn, operands);

        case 40:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HFmode)
       || register_operand (operands[2], VNx32HFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_555 (insn, operands);

        case 41:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SFmode)
       || register_operand (operands[2], VNx16SFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_556 (insn, operands);

        case 42:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DFmode)
       || register_operand (operands[2], VNx8DFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_557 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC)
        return NULL;
      return split_3 (x1, insn);

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC)
        return NULL;
      return split_4 (x1, insn);

    case MULT:
      switch (pattern479 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1190 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1195 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1200 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1205 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1210 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1215 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1220 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1225 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1230 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1235 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1240 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern479 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1191 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1196 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1201 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1206 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1211 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1216 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1221 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1226 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1231 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1236 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1241 (insn, operands);

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern482 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1192 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1197 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1202 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1207 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1212 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1217 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1222 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1227 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1232 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1237 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1242 (insn, operands);

        case 11:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2795 (insn, operands);

        case 12:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2797 (insn, operands);

        case 13:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case 14:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2801 (insn, operands);

        default:
          return NULL;
        }

    case UMAX:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1193 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1198 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1203 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1208 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1213 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1218 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1223 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1228 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1233 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1238 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1243 (insn, operands);

        default:
          return NULL;
        }

    case UMIN:
      switch (pattern485 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1194 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1199 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1204 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1209 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1214 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1219 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1224 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1229 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1234 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1239 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1244 (insn, operands);

        case 11:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2796 (insn, operands);

        case 12:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2798 (insn, operands);

        case 13:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2800 (insn, operands);

        case 14:
          if (!(
#line 806 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2802 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern489 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1509 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1512 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1515 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1518 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1521 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1524 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1527 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1530 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1533 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1536 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern610 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1510 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1513 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1516 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1519 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1522 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1525 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1528 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1531 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1534 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1537 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern610 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1511 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1514 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1517 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1520 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1523 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1526 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1529 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1532 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1535 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1538 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern491 (x2))
        {
        case 0:
          if (!(
#line 1628 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2971 (insn, operands);

        case 1:
          if (!(
#line 1628 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2972 (insn, operands);

        case 2:
          if (!(
#line 1628 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2973 (insn, operands);

        case 3:
          if (!(
#line 1628 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2974 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern491 (x2))
        {
        case 0:
          if (!(
#line 1650 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2975 (insn, operands);

        case 1:
          if (!(
#line 1650 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2976 (insn, operands);

        case 2:
          if (!(
#line 1650 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2977 (insn, operands);

        case 3:
          if (!(
#line 1650 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2978 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return NULL;
      switch (pattern608 (x2))
        {
        case 0:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2979 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2980 (insn, operands);

        case 1:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2981 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2982 (insn, operands);

        case 2:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2983 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2984 (insn, operands);

        case 3:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2985 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2986 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1245 (insn, operands);

        case 1:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1262 (insn, operands);

        case 2:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1279 (insn, operands);

        case 3:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1296 (insn, operands);

        case 4:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1313 (insn, operands);

        case 5:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1330 (insn, operands);

        case 6:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1347 (insn, operands);

        case 7:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1364 (insn, operands);

        case 8:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1381 (insn, operands);

        case 9:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1398 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x3, 1);
      operands[4] = x7;
      x8 = XVECEXP (x2, 0, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1111 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1992 (insn, operands);

        case E_VNx8QImode:
          if (pattern1111 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1993 (insn, operands);

        case E_VNx4QImode:
          if (pattern1111 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1994 (insn, operands);

        case E_VNx2QImode:
          if (pattern1111 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1995 (insn, operands);

        case E_VNx8HImode:
          if (pattern1111 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1996 (insn, operands);

        case E_VNx4HImode:
          if (pattern1111 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1997 (insn, operands);

        case E_VNx2HImode:
          if (pattern1111 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1998 (insn, operands);

        case E_VNx4SImode:
          if (pattern1111 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1999 (insn, operands);

        case E_VNx2SImode:
          if (pattern1111 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2000 (insn, operands);

        case E_VNx2DImode:
          if (pattern1111 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2001 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_78 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return NULL;
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern706 (x2, 
E_V16QImode, 
E_V8QImode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V8QImode))))
        return gen_split_141 (insn, operands);
      break;

    case E_V4HImode:
      if (pattern706 (x2, 
E_V8HImode, 
E_V4HImode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V4HImode))))
        return gen_split_142 (insn, operands);
      break;

    case E_V2SImode:
      if (pattern706 (x2, 
E_V4SImode, 
E_V2SImode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V2SImode))))
        return gen_split_143 (insn, operands);
      break;

    case E_V4HFmode:
      if (pattern706 (x2, 
E_V8HFmode, 
E_V4HFmode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V4HFmode))))
        return gen_split_144 (insn, operands);
      break;

    case E_V4BFmode:
      if (pattern706 (x2, 
E_V8BFmode, 
E_V4BFmode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V4BFmode))))
        return gen_split_145 (insn, operands);
      break;

    case E_V2SFmode:
      if (pattern706 (x2, 
E_V4SFmode, 
E_V2SFmode) == 0
          && (
#line 295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT) && 
#line 301 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && aarch64_simd_register (operands[0], V2SFmode))))
        return gen_split_146 (insn, operands);
      break;

    case E_V16QImode:
      if (pattern668 (x2, 
E_VNx16QImode, 
E_V16QImode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2763 (insn, operands);
      break;

    case E_V8HImode:
      if (pattern668 (x2, 
E_VNx8HImode, 
E_V8HImode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2764 (insn, operands);
      break;

    case E_V4SImode:
      if (pattern668 (x2, 
E_VNx4SImode, 
E_V4SImode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2765 (insn, operands);
      break;

    case E_V2DImode:
      if (pattern668 (x2, 
E_VNx2DImode, 
E_V2DImode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2766 (insn, operands);
      break;

    case E_V8BFmode:
      if (pattern668 (x2, 
E_VNx8BFmode, 
E_V8BFmode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2767 (insn, operands);
      break;

    case E_V8HFmode:
      if (pattern668 (x2, 
E_VNx8HFmode, 
E_V8HFmode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2768 (insn, operands);
      break;

    case E_V4SFmode:
      if (pattern668 (x2, 
E_VNx4SFmode, 
E_V4SFmode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2769 (insn, operands);
      break;

    case E_V2DFmode:
      if (pattern668 (x2, 
E_VNx2DFmode, 
E_V2DFmode) == 0
          && (
#line 11152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)) && 
#line 11157 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
        return gen_split_2770 (insn, operands);
      break;

    default:
      break;
    }
  if (XVECLEN (x3, 0) != 1)
    return NULL;
  operands[0] = x4;
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  if (immediate_operand (operands[2], E_SImode))
    {
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_QImode)
              && GET_MODE (x2) == E_QImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_178 (insn, operands);
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (16, INTVAL (operands[2])) == 0)))
                    return gen_split_179 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_HImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_HImode)
              && GET_MODE (x2) == E_HImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_180 (insn, operands);
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_181 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_SImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
                    return gen_split_182 (insn, operands);
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_183 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_DImode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_V2DImode)
              && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
            return gen_split_184 (insn, operands);
          break;

        case E_HFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_HFmode)
              && GET_MODE (x2) == E_HFmode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_185 (insn, operands);
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_186 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_BFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_BFmode)
              && GET_MODE (x2) == E_BFmode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4BFmode:
                  if (register_operand (operands[1], E_V4BFmode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_187 (insn, operands);
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[1], E_V8BFmode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (8, INTVAL (operands[2])) == 0)))
                    return gen_split_188 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_SFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_SFmode)
              && GET_MODE (x2) == E_SFmode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
                    return gen_split_189 (insn, operands);
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (4, INTVAL (operands[2])) == 0)))
                    return gen_split_190 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_DFmode:
          if (aarch64_simd_nonimmediate_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && register_operand (operands[1], E_V2DFmode)
              && (
#line 4263 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 4278 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed
  && ENDIAN_LANE_N (2, INTVAL (operands[2])) == 0)))
            return gen_split_191 (insn, operands);
          break;

        default:
          break;
        }
    }
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  switch (pattern707 (x2))
    {
    case 0:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1060 (insn, operands);

    case 1:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1061 (insn, operands);

    case 2:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1062 (insn, operands);

    case 3:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1063 (insn, operands);

    case 4:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1064 (insn, operands);

    case 5:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1065 (insn, operands);

    case 6:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1066 (insn, operands);

    case 7:
      if (!(
#line 3010 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3025 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && REG_P (operands[0])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_1067 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_84 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2557 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2567 (insn, operands);
}

 rtx_insn *
split_86 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2517 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2527 (insn, operands);
}

 rtx_insn *
split_89 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2457 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2467 (insn, operands);
}

 rtx_insn *
split_92 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2556 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2566 (insn, operands);
}

 rtx_insn *
split_95 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2496 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2506 (insn, operands);
}

 rtx_insn *
split_98 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2436 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2446 (insn, operands);
}

 rtx_insn *
split_102 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2515 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2525 (insn, operands);
}

 rtx_insn *
split_106 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2435 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2445 (insn, operands);
}

 rtx_insn *
split_111 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2494 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2504 (insn, operands);
}

 rtx_insn *
split_118 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2513 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2523 (insn, operands);
}

 rtx_insn *
split_125 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2532 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2542 (insn, operands);
}

 rtx_insn *
split_133 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1334 (x1, 
GTU))
    {
    case 0:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2117 (insn, operands);

    case 1:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2127 (insn, operands);

    case 2:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2157 (insn, operands);

    case 3:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2137 (insn, operands);

    case 4:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2167 (insn, operands);

    case 5:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2187 (insn, operands);

    case 6:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2147 (insn, operands);

    case 7:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2177 (insn, operands);

    case 8:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2197 (insn, operands);

    case 9:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2207 (insn, operands);

    case 10:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2217 (insn, operands);

    case 11:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2227 (insn, operands);

    case 12:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2257 (insn, operands);

    case 13:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2237 (insn, operands);

    case 14:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2267 (insn, operands);

    case 15:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2287 (insn, operands);

    case 16:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2247 (insn, operands);

    case 17:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2277 (insn, operands);

    case 18:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2297 (insn, operands);

    case 19:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_DFmode)
      && memory_operand (operands[1], E_DFmode))
    {
      switch (GET_MODE (operands[2]))
        {
        case E_DFmode:
          if (register_operand (operands[2], E_DFmode)
              && memory_operand (operands[3], E_DFmode)
              && 
#line 50 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_17 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V8QImode:
          if (register_operand (operands[2], E_V8QImode)
              && memory_operand (operands[3], E_V8QImode)
              && 
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_25 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V4HImode:
          if (register_operand (operands[2], E_V4HImode)
              && memory_operand (operands[3], E_V4HImode)
              && 
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_31 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V4HFmode:
          if (register_operand (operands[2], E_V4HFmode)
              && memory_operand (operands[3], E_V4HFmode)
              && 
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_37 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V2SImode:
          if (register_operand (operands[2], E_V2SImode)
              && memory_operand (operands[3], E_V2SImode)
              && 
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_43 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_V2SFmode:
          if (register_operand (operands[2], E_V2SFmode)
              && memory_operand (operands[3], E_V2SFmode)
              && 
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_49 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_DFmode))
    {
      if (aarch64_reg_or_fp_zero (operands[1], E_DFmode)
          && memory_operand (operands[2], E_DFmode)
          && aarch64_reg_or_fp_zero (operands[3], E_DFmode)
          && 
#line 62 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_19 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (register_operand (operands[1], E_DFmode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_V8QImode:
              if (memory_operand (operands[2], E_V8QImode)
                  && register_operand (operands[3], E_V8QImode)
                  && 
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_61 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V4HImode:
              if (memory_operand (operands[2], E_V4HImode)
                  && register_operand (operands[3], E_V4HImode)
                  && 
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_67 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V4HFmode:
              if (memory_operand (operands[2], E_V4HFmode)
                  && register_operand (operands[3], E_V4HFmode)
                  && 
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_73 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V2SImode:
              if (memory_operand (operands[2], E_V2SImode)
                  && register_operand (operands[3], E_V2SImode)
                  && 
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_79 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_V2SFmode:
              if (memory_operand (operands[2], E_V2SFmode)
                  && register_operand (operands[3], E_V2SFmode)
                  && 
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_85 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (aarch64_reg_zero_or_fp_zero (operands[1], E_DFmode)
          && memory_operand (operands[2], E_DImode)
          && aarch64_reg_zero_or_fp_zero (operands[3], E_DImode)
          && 
#line 161 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_222 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (register_operand (operands[0], E_DFmode)
      && memory_operand (operands[1], E_DFmode)
      && register_operand (operands[2], E_DFmode)
      && memory_operand (operands[3], E_DFmode)
      && 
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
    {
      *pmatch_len_ = 1;
      res = gen_peephole2_55 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (memory_operand (operands[0], E_DFmode)
      && register_operand (operands[1], E_DFmode)
      && memory_operand (operands[2], E_DFmode)
      && register_operand (operands[3], E_DFmode)
      && 
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
    {
      *pmatch_len_ = 1;
      res = gen_peephole2_91 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 3
      || peep2_current_count < 4)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (register_operand (operands[4], E_DFmode))
    {
      x4 = XEXP (x2, 1);
      if (pattern1162 (x4, 
E_DFmode) == 0
          && 
#line 204 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, DFmode)))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_229 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (!memory_operand (operands[4], E_DFmode))
    return NULL;
  x4 = XEXP (x2, 1);
  if (pattern1164 (x4, 
E_DFmode) != 0
      || !
#line 284 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, DFmode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_235 (insn, operands);
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V8BFmode))
    {
      switch (pattern936 (
E_V8BFmode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_148 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_149 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_150 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_151 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_152 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_153 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_154 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_155 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V8BFmode)
      || !register_operand (operands[1], E_V8BFmode))
    return NULL;
  switch (pattern992 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_212 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_213 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_214 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_215 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_216 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_217 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_218 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_219 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V8HImode))
    {
      switch (pattern936 (
E_V8HImode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_100 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_101 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_102 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_103 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_104 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_105 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_106 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_107 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V8HImode)
      || !register_operand (operands[1], E_V8HImode))
    return NULL;
  switch (pattern992 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_164 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_165 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_166 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_167 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_168 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_169 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_170 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_171 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && memory_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_SImode)
          && memory_operand (operands[3], E_SImode)
          && 
#line 26 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_12 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (memory_operand (operands[0], E_SImode))
        {
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && memory_operand (operands[2], E_SImode)
              && aarch64_reg_or_zero (operands[3], E_SImode)
              && 
#line 38 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_14 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (aarch64_reg_zero_or_fp_zero (operands[1], E_SImode)
              && memory_operand (operands[2], E_SFmode)
              && aarch64_reg_zero_or_fp_zero (operands[3], E_SFmode)
              && 
#line 161 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_225 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (register_operand (operands[4], E_SImode))
        {
          x9 = XEXP (x7, 1);
          if (pattern1162 (x9, 
E_SImode) == 0
              && 
#line 184 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_226 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      x9 = XEXP (x7, 1);
      if (pattern1163 (x9, 
E_SImode) != 0
          || !
#line 264 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, SImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_232 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && memory_operand (operands[1], E_DImode)
          && register_operand (operands[2], E_DImode)
          && memory_operand (operands[3], E_DImode)
          && 
#line 26 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_13 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (memory_operand (operands[0], E_DImode))
        {
          if (aarch64_reg_or_zero (operands[1], E_DImode)
              && memory_operand (operands[2], E_DImode)
              && aarch64_reg_or_zero (operands[3], E_DImode)
              && 
#line 38 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_15 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (aarch64_reg_zero_or_fp_zero (operands[1], E_DImode)
              && memory_operand (operands[2], E_DFmode)
              && aarch64_reg_zero_or_fp_zero (operands[3], E_DFmode)
              && 
#line 161 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_223 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (register_operand (operands[4], E_DImode))
        {
          x9 = XEXP (x7, 1);
          if (pattern1162 (x9, 
E_DImode) == 0
              && 
#line 184 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, DImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_227 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[4], E_DImode))
        return NULL;
      x9 = XEXP (x7, 1);
      if (pattern1163 (x9, 
E_DImode) != 0
          || !
#line 264 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, DImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_233 (insn, operands);

    case E_SFmode:
      if (register_operand (operands[0], E_SFmode)
          && memory_operand (operands[1], E_SFmode)
          && register_operand (operands[2], E_SFmode)
          && memory_operand (operands[3], E_SFmode)
          && 
#line 50 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_16 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (memory_operand (operands[0], E_SFmode))
        {
          if (aarch64_reg_or_fp_zero (operands[1], E_SFmode)
              && memory_operand (operands[2], E_SFmode)
              && aarch64_reg_or_fp_zero (operands[3], E_SFmode)
              && 
#line 62 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_18 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (aarch64_reg_zero_or_fp_zero (operands[1], E_SFmode)
              && memory_operand (operands[2], E_SImode)
              && aarch64_reg_zero_or_fp_zero (operands[3], E_SImode)
              && 
#line 161 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_224 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (register_operand (operands[4], E_SFmode))
        {
          x9 = XEXP (x7, 1);
          if (pattern1162 (x9, 
E_SFmode) == 0
              && 
#line 204 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SFmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_228 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!memory_operand (operands[4], E_SFmode))
        return NULL;
      x9 = XEXP (x7, 1);
      if (pattern1164 (x9, 
E_SFmode) != 0
          || !
#line 284 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, false, SFmode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_234 (insn, operands);

    case E_DFmode:
      return peephole2_1 (x1, insn, pmatch_len_);

    case E_V8QImode:
      if (register_operand (operands[0], E_V8QImode))
        {
          switch (pattern933 (
E_V8QImode))
            {
            case 0:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_20 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_26 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_32 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_38 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_44 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_50 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_V8QImode)
          || !register_operand (operands[1], E_V8QImode))
        return NULL;
      switch (pattern989 ())
        {
        case 0:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_56 (insn, operands);

        case 1:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_62 (insn, operands);

        case 2:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_68 (insn, operands);

        case 3:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_74 (insn, operands);

        case 4:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_80 (insn, operands);

        case 5:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_86 (insn, operands);

        default:
          return NULL;
        }

    case E_V4HImode:
      if (register_operand (operands[0], E_V4HImode))
        {
          switch (pattern933 (
E_V4HImode))
            {
            case 0:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_21 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_27 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_33 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_39 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_45 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_51 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_V4HImode)
          || !register_operand (operands[1], E_V4HImode))
        return NULL;
      switch (pattern989 ())
        {
        case 0:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_57 (insn, operands);

        case 1:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_63 (insn, operands);

        case 2:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_69 (insn, operands);

        case 3:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_75 (insn, operands);

        case 4:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_81 (insn, operands);

        case 5:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_87 (insn, operands);

        default:
          return NULL;
        }

    case E_V4HFmode:
      if (register_operand (operands[0], E_V4HFmode))
        {
          switch (pattern933 (
E_V4HFmode))
            {
            case 0:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_22 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_28 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_34 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_40 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_46 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_52 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode))
        return NULL;
      switch (pattern989 ())
        {
        case 0:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_58 (insn, operands);

        case 1:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_64 (insn, operands);

        case 2:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_70 (insn, operands);

        case 3:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_76 (insn, operands);

        case 4:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_82 (insn, operands);

        case 5:
          if (!
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_88 (insn, operands);

        default:
          return NULL;
        }

    case E_V2SImode:
      return peephole2_11 (x1, insn, pmatch_len_);

    case E_V2SFmode:
      return peephole2_10 (x1, insn, pmatch_len_);

    case E_V16QImode:
      return peephole2_9 (x1, insn, pmatch_len_);

    case E_V8HImode:
      return peephole2_8 (x1, insn, pmatch_len_);

    case E_V4SImode:
      return peephole2_7 (x1, insn, pmatch_len_);

    case E_V2DImode:
      return peephole2_3 (x1, insn, pmatch_len_);

    case E_V8HFmode:
      return peephole2_6 (x1, insn, pmatch_len_);

    case E_V4SFmode:
      return peephole2_4 (x1, insn, pmatch_len_);

    case E_V2DFmode:
      return peephole2_2 (x1, insn, pmatch_len_);

    case E_V8BFmode:
      return peephole2_5 (x1, insn, pmatch_len_);

    default:
      return NULL;
    }
}
